<?php
if ( ! defined( 'ABSPATH' ) ) exit;

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       http://myworks.design/
 * @since      1.0.0
 *
 * @package    MW_QBO_Desktop
 * @subpackage MW_QBO_Desktop/admin/partials
 */
?>
<?php
	global $MWQDC_LB;
	global $wpdb;
	$page_url = 'admin.php?page=mw-qbo-desktop-map&tab=category';
	
	/*Save Mapping*/
	if ( ! empty( $_POST ) && check_admin_referer( 'myworks_wc_qbo_sync_map_wc_qbo_category_desk', 'map_wc_qbo_category_desk' ) ) {
		//$MWQDC_LB->_p($_POST);die;
		
		$item_ids = array();
		foreach ($_POST as $key=>$value){
			if ($MWQDC_LB->start_with($key, "map_category_")){
				$id = (int) str_replace("map_category_", "", $key);
				if($id){ //&& (int) $value
					$item_ids[$id] = $value;
				}
			}
		}
		//$MWQDC_LB->_p($item_ids);
		
		if(count($item_ids)){
			foreach ($item_ids as $key=>$value){
				$save_data = array();			
				$save_data['qbo_department_id'] = $value;
				
				$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_map_departments';
				if($MWQDC_LB->get_field_by_val($table,'id','wc_category_id',$key)){
					$wpdb->update($table,$save_data,array('wc_category_id'=>$key),'',array('%d'));
				}else{
					$save_data['wc_category_id'] = $key;
					$wpdb->insert($table, $save_data);
				}
			}
			//$MWQDC_LB->set_session_msg('map_client_msg',__('Categories mapped successfully.','mw_wc_qbo_desk'));		
			$MWQDC_LB->set_session_val('map_page_update_message',__('Categories mapped successfully.','mw_wc_qbo_desk'));
		}
		
		$wpdb->query("DELETE FROM `".$table."` WHERE `qbo_department_id` = '' ");
		$MWQDC_LB->redirect($page_url);		
	}
	
	$MWQDC_LB->set_per_page_from_url();
	$items_per_page = $MWQDC_LB->get_item_per_page();

	$MWQDC_LB->set_and_get('category_map_search');
	$category_map_search = $MWQDC_LB->get_session_val('category_map_search');
	
	$total_records = $MWQDC_LB->count_woocommerce_category_list($category_map_search);

	$offset = $MWQDC_LB->get_offset($MWQDC_LB->get_page_var(),$items_per_page);
	$pagination_links = $MWQDC_LB->get_paginate_links($total_records,$items_per_page);

	$wc_category_list = $MWQDC_LB->get_woocommerce_category_list($category_map_search," $offset , $items_per_page");
	
	//$MWQDC_LB->_p($wc_category_list);
	
	$qc_whr = '';
	$qbd_category_options = $MWQDC_LB->option_html('', $wpdb->prefix.'mw_wc_qbo_desk_qbd_list_department','qbd_id','name',$qc_whr,'name ASC','',true);
	
	$selected_options_script = '';
?>
<?php require_once plugin_dir_path( __FILE__ ) . 'mw-qbo-desktop-admin-menu-map-nav.php';?>
<div class="container map-category-outer cnt-mwqbd">
	<div class="page_title"><h4><?php _e( 'Category Mappings', 'mw_wc_qbo_desk' );?></h4></div>
	 <div class="mw_wc_filter">
		<span class="search_text">Search</span>
		&nbsp;
		<input type="text" id="category_map_search" value="<?php echo $category_map_search;?>">
		&nbsp;		
		<button onclick="javascript:search_item();" class="btn btn-info">Filter</button>
		&nbsp;
		<button onclick="javascript:reset_item();" class="btn btn-info">Reset</button>
		&nbsp;
		<span class="filter-right-sec">
		  <span class="entries">Show entries</span>
		  &nbsp;
		  <select style="width:50px;" onchange="javascript:window.location='<?php echo $page_url;?>&<?php echo $MWQDC_LB->per_page_keyword;?>='+this.value;">
			<?php echo  $MWQDC_LB->only_option($items_per_page,$MWQDC_LB->show_per_page);?>
		 </select>
		</span>
	 </div>
	 <br />
	 
	 <div class="card">
		<div class="card-content">
			<div class="row">
				<form method="POST" class="col s12 m12 l12">
					<div class="row">
						<div class="col s12 m12 l12">
							<table class="mw-qbo-sync-settings-table menu-blue-bg menu-bg-a new-table">
								<thead>
									<tr>
										<th width="10%">&nbsp; ID</th>
										<th width="45%">WooCommerce Category</th>
										
										<th width="45%" class="title-description">
											QuickBooks Departments								    	
										</th>
									</tr>
								</thead>
								
								<tbody>
									<?php foreach($wc_category_list as $data):?>
									<tr>
										<td><?php echo $data['id']?></td>
										<td>
											<a href="<?php echo admin_url('term.php?taxonomy=product_cat&post_type=product&tag_ID=').$data['id'] ?>" target="_blank"><?php _e( $data['name'], 'mw_wc_qbo_sync' );?></a>
										</td>
										
										<td>
											<select class="mw_wc_qbo_sync_select2_desk" name="map_category_<?php echo $data['id']?>" id="map_category_<?php echo $data['id']?>">
												<option value=""></option>
												<?php echo $qbd_category_options;?>
											</select>
											<?php 
											if(isset($data['qbo_department_id']) && $data['qbo_department_id']!=''){
												$selected_options_script.='jQuery(\'#map_category_'.$data['id'].'\').val(\''.$data['qbo_department_id'].'\');';
											}
											?>	
										</td>
									</tr>
									<?php endforeach;?>
								</tbody>
								
							</table>
						</div>
					</div>
					
					<div class="row">
						<?php wp_nonce_field( 'myworks_wc_qbo_sync_map_wc_qbo_category_desk', 'map_wc_qbo_category_desk' ); ?>
						<div class="input-field col s12 m6 l4">
							<button class="waves-effect waves-light btn save-btn mw-qbo-sync-green">Save</button>
						</div>
					</div>
					
				</form>
			</div>
		</div>
	</div>
	
</div>

<script type="text/javascript">
	function search_item(){		
		var category_map_search = jQuery('#category_map_search').val();
		if(category_map_search!=''){			
			window.location = '<?php echo $page_url;?>&category_map_search='+category_map_search;
		}else{
			alert('<?php echo __('Please enter search keyword.','mw_wc_qbo_desk')?>');
		}
	}

	function reset_item(){		
		window.location = '<?php echo $page_url;?>&category_map_search=';
	}
	
	<?php if($selected_options_script!=''):?>
	jQuery(document).ready(function(){
		<?php echo $selected_options_script;?>
	});
	<?php endif;?>
</script>
<?php echo $MWQDC_LB->get_select2_js('.mw_wc_qbo_sync_select2_desk','');?>