﻿<?php
if ( ! defined( 'ABSPATH' ) ) exit;

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       http://myworks.design/
 * @since      1.0.0
 *
 * @package    MW_QBO_Desktop
 * @subpackage MW_QBO_Desktop/admin/partials
 */
?>

<?php
	global $MWQDC_LB;
	global $wpdb;
	$page_url = 'admin.php?page=mw-qbo-desktop-pull&tab=product';
	
	$MWQDC_LB->set_per_page_from_url();
	$items_per_page = $MWQDC_LB->get_item_per_page();

	$MWQDC_LB->set_and_get('product_pull_search');
	$product_pull_search = $MWQDC_LB->get_session_val('product_pull_search');	
	$product_pull_search = $MWQDC_LB->sanitize($product_pull_search);	
	
	$MWQDC_LB->set_and_get('product_pull_dept_search');
	$product_pull_dept_search = $MWQDC_LB->get_session_val('product_pull_dept_search');	
	$product_pull_dept_search = $MWQDC_LB->sanitize($product_pull_dept_search);
	
	$MWQDC_LB->set_and_get('product_stock_srch');
	$product_stock_srch = $MWQDC_LB->get_session_val('product_stock_srch');
	
	$whr = '';
	
	if($product_pull_search!=''){
		$whr.= " AND (`sku` = '{$product_pull_search}' OR `name` LIKE '%$product_pull_search%') ";
	}
	
	if($product_pull_dept_search!=''){
		$whr.= " AND info_arr REGEXP '.*\"DepartmentListID\";s:[0-9]+:\"{$product_pull_dept_search}\".*'";
	}
	
	$total_records = $wpdb->get_var("SELECT COUNT(*) FROM `".$wpdb->prefix."mw_wc_qbo_desk_qbd_items` WHERE `id` >0 {$whr} ");
	$offset = $MWQDC_LB->get_offset($MWQDC_LB->get_page_var(),$items_per_page);

	$pagination_links = $MWQDC_LB->get_paginate_links($total_records,$items_per_page);

	$product_q = "SELECT * FROM `".$wpdb->prefix."mw_wc_qbo_desk_qbd_items` WHERE `id` >0 {$whr} ORDER BY `id` DESC LIMIT {$offset} , {$items_per_page} ";
	$qbd_product_list = $MWQDC_LB->get_data($product_q);
	//$MWQDC_LB->_p($qbd_product_list);
	
	$show_sync_status = true;
	$cs = get_woocommerce_currency_symbol();
	
	$all_dept_arr = array();
	if(is_array($qbd_product_list) && count($qbd_product_list)){
		$all_dept_arr = $MWQDC_LB->get_key_val_pair_from_tbl($wpdb->prefix.'mw_wc_qbo_desk_qbd_list_department','qbd_id','name');
		//$MWQDC_LB->_p($all_dept_arr);
	}
?>

<div class="container mwqbd-cnt">
	<div class="page_title"><h4><?php _e( 'Product Pull', 'mw_wc_qbo_desk' );?></h4></div>
	<div class="card">
		<div class="card-content">
			<div class="col s12 m12 l12">
				<div class="panel panel-primary">
					<div class="mw_wc_filter">
						<span class="search_text">Search</span>
						&nbsp;
						<input placeholder="Name / Item No" type="text" id="product_pull_search" value="<?php echo $product_pull_search;?>">					  
						&nbsp;
						
						<span class="search_text">Department</span>
						&nbsp;
						<select name="product_pull_dept_search" id="product_pull_dept_search">
							<option value="">All</option>
							<?php $MWQDC_LB->option_html($product_pull_dept_search,$wpdb->prefix.'mw_wc_qbo_desk_qbd_list_department','qbd_id','name');?>
						</select>
						&nbsp;
						
						<span class="search_text">Stock Status</span>
						&nbsp;
						<span>
							<select style="width:80px;" name="product_stock_srch" id="product_stock_srch">
								<?php if(empty($product_stock_srch)):?>
								<option value="">All</option>
								<?php endif;?>
							<?php echo  $MWQDC_LB->only_option($product_stock_srch,array('instock'=>'In Stock','outofstock'=>'Out of Stock'));?>
							</select>
						</span>
						&nbsp;
						
						<button onclick="javascript:search_item();" class="btn btn-info">Filter</button>
						&nbsp;
						<button onclick="javascript:reset_item();" class="btn btn-info">Reset</button>
						&nbsp;
						<span class="filter-right-sec">
						<span class="entries">Show entries</span>
						&nbsp;
						<select style="width:50px;" onchange="javascript:window.location='<?php echo $page_url;?>&<?php echo $MWQDC_LB->per_page_keyword;?>='+this.value;">
						<?php echo  $MWQDC_LB->only_option($items_per_page,$MWQDC_LB->show_per_page);?>
						</select>
					 </span>
					 </div>
					 
					<br />
					<div class="row">
						<div class="input-field col s12 m12 14">
							<button id="pull_selected_product_btn" class="waves-effect waves-light btn save-btn mw-qbo-sync-green"><?php echo __('Pull Selected Products','mw_wc_qbo_desk')?></button>
							<button style="display:none;" id="pull_all_product_btn" class="waves-effect waves-light btn save-btn mw-qbo-sync-green hide"><?php echo __('Pull All Products','mw_wc_qbo_desk')?></button>						
						</div>
					</div>
					<br />
					
					<?php $qmhi = 0;?>
					<?php if(is_array($qbd_product_list) && count($qbd_product_list)):?>
					<div class="table-m">
						<table class="table tablesorter" id="mwqs_product_pull_table_desk">
							<thead>
								<tr>
									<th width="2%">
									<input type="checkbox" onclick="javascript:mw_qbo_sync_check_all_desk(this,'product_pull_')">
									</th>
									<th width="13%">QB Item Num #</th>
									<th width="33%">Product Name</th>
									<th width="12%">Type</th>
									<th width="17%">Department</th>
									<th width="8%">Price</th>
									<th width="7%">Qty</th>
									<th width="8%">Sync Status</th>
								</tr>
							</thead>
							<tbody>
							
							<?php foreach($qbd_product_list as $p_val):?>
							<?php
							
							$sync_status_html = '';
							$wc_price = '';
							$chk_dsbld = '';
							if($show_sync_status){
								$wc_variation_id = 0;
								$sync_status_html = '<i class="fa fa-times-circle" style="color:red"></i>';
								if(isset($p_val['wc_product_id']) && (int) $p_val['wc_product_id']){
									$wc_product_id = (int) $p_val['wc_product_id'];
								}else{
									$wc_product_id = (int) $MWQDC_LB->get_field_by_val($wpdb->prefix.'mw_wc_qbo_desk_qbd_product_pairs','wc_product_id','quickbook_product_id',$p_val['qbd_id']);
									
									if(!$wc_product_id){
										$wc_product_id = (int) $MWQDC_LB->get_field_by_val($wpdb->prefix.'mw_wc_qbo_desk_qbd_variation_pairs','wc_variation_id','quickbook_product_id',$p_val['qbd_id']);
										$wc_variation_id = $wc_product_id;
									}
								}
								if($wc_product_id>0){
									$e_txt = ($wc_variation_id)?' variation':'';
									$sync_status_html = '<i title="Mapped to'.$e_txt.' #'.$wc_product_id.'" class="fa fa-check-circle" style="color:green"></i>';
									$wc_price = get_post_meta($wc_product_id,'_price',true);
									if($wc_variation_id){
										$chk_dsbld = 'disabled';
									}									
								}								
							}
							
							$qbd_price = '';
							
							/**/
							$ItemNumber = '';
							$DepartmentCode = '';
							$DepartmentListID = '';
							
							$ItemType = '';
							
							$Qty = 0;
							
							$qp_info_arr = $p_val['info_arr'];
							if($qp_info_arr!=''){
								$qp_info_arr = unserialize($qp_info_arr);
								if(is_array($qp_info_arr) && count($qp_info_arr)){
									if(isset($qp_info_arr['Price1'])){
										$qbd_price = $qp_info_arr['Price1'];
									}
									
									if(empty($qbd_price)){
										if(isset($qp_info_arr['Price2'])){
											$qbd_price = $qp_info_arr['Price2'];
										}
									}
									
									/**/
									$ItemNumber = (isset($qp_info_arr['ItemNumber']))?$qp_info_arr['ItemNumber']:'';
									$DepartmentCode = (isset($qp_info_arr['DepartmentCode']))?$qp_info_arr['DepartmentCode']:'';
									$DepartmentListID = (isset($qp_info_arr['DepartmentListID']))?$qp_info_arr['DepartmentListID']:'';
									
									$ItemType = (isset($qp_info_arr['ItemType']))?$qp_info_arr['ItemType']:'';
									
									$QuantityOnHand = (isset($qp_info_arr['QuantityOnHand']))?$qp_info_arr['QuantityOnHand']:0;
									$Qty_title = '';//Quantity On Hand
									if($MWQDC_LB->get_option('mw_wc_qbo_desk_pull_invnt_qty_field') == 'AvailableQuantity'){
										$QuantityOnOrder  = (isset($qp_info_arr['QuantityOnOrder ']))?$qp_info_arr['QuantityOnOrder ']:0;
										
										$QuantityOnCustomerOrder  = (isset($qp_info_arr['QuantityOnCustomerOrder ']))?$qp_info_arr['QuantityOnCustomerOrder ']:0;
										
										$QuantityOnPendingOrder = (isset($qp_info_arr['QuantityOnPendingOrder']))?$qp_info_arr['QuantityOnPendingOrder']:0;
										
										$Qty = ($QuantityOnHand-$QuantityOnOrder-$QuantityOnCustomerOrder-$QuantityOnPendingOrder);
										$Qty_title = 'Available Quantity';
									}else{
										$Qty = $QuantityOnHand;
									}
								}
							}
							
							$Qty = (int) $Qty;
							if($product_stock_srch == 'instock'){
								if($Qty < 1){
									$qmhi++;
									continue;
								}
							}
							
							if($product_stock_srch == 'outofstock'){
								if($Qty > 0){
									$qmhi++;
									continue;
								}
							}
							
							?>
							<tr>
								<td><input <?php echo $chk_dsbld;?> type="checkbox" id="product_pull_<?php echo $p_val['id']?>"></td>
								<td><?php echo $ItemNumber;?></td>
								<td><?php _e( $p_val['name'], 'mw_wc_qbo_desk' );?></td>
								
								<td><?php echo $ItemType;?></td>
								
								<td><?php echo (!empty($DepartmentListID) && isset($all_dept_arr[$DepartmentListID]))?$all_dept_arr[$DepartmentListID]:'';?></td>
								
								<td>
									<?php										
										echo ($qbd_price!='')?$cs.$qbd_price:$qbd_price;
									?>
								</td>
								
								<td title="<?php echo $Qty_title;?>"><?php echo $Qty;?></td>
								
								<td><?php echo $sync_status_html;?></td>
							</tr>
							<?php endforeach;?>									
							</tbody>
						</table>
					</div>
					<?php echo $pagination_links?>
					<?php else:?>
					<p><?php _e( 'No products found.', 'mw_wc_qbo_desk' );?></p>
					<?php endif;?>
									 
				</div>
			</div>
		</div>
	</div>
</div>

<?php $sync_window_url = $MWQDC_LB->get_sync_window_url();?>
 <script type="text/javascript">
	function search_item(){		
		var product_pull_search = jQuery('#product_pull_search').val();
		product_pull_search = jQuery.trim(product_pull_search);
		
		var product_pull_dept_search = jQuery('#product_pull_dept_search').val();
		product_pull_dept_search = jQuery.trim(product_pull_dept_search);
		
		var product_stock_srch = jQuery('#product_stock_srch').val();
		product_stock_srch = jQuery.trim(product_stock_srch);
		
		if(product_pull_search!='' || product_pull_dept_search!='' || product_stock_srch!=''){
			window.location = '<?php echo $page_url;?>&product_pull_search='+product_pull_search+'&product_pull_dept_search='+product_pull_dept_search+'&product_stock_srch='+product_stock_srch;
		}else{
			alert('<?php echo __('Please enter search keyword or select department or stock status','mw_wc_qbo_desk')?>');
		}
	}

	function reset_item(){		
		window.location = '<?php echo $page_url;?>&product_pull_search=&product_pull_dept_search=&product_stock_srch=';
	}
	
	jQuery(document).ready(function($) {
		var item_type = 'product';
		$('#pull_selected_product_btn').click(function(){
			var item_ids = '';
			var item_checked = 0;
			
			jQuery( "input[id^='product_pull_']" ).each(function(){
				if(jQuery(this).is(":checked")){
					item_checked = 1;
					var only_id = jQuery(this).attr('id').replace('product_pull_','');
					only_id = parseInt(only_id);
					if(only_id>0){
						item_ids+=only_id+',';
					}					
				}
			});
			
			if(item_ids!=''){
				item_ids = item_ids.substring(0, item_ids.length - 1);
			}
			
			if(item_checked==0){
				alert('<?php echo __('Please select at least one item.','mw_wc_qbo_desk');?>');
				return false;
			}
			
			popUpWindowDesk('<?php echo $sync_window_url;?>&sync_type=pull&item_ids='+item_ids+'&item_type='+item_type,'mw_qs_product_pull_desk',0,0,650,350);
			return false;
		});
		
		$('#pull_all_product_btn').click(function(){
			popUpWindowDesk('<?php echo $sync_window_url;?>&sync_type=pull&sync_all=1&item_type='+item_type,'mw_qs_product_pull_desk',0,0,650,350);
			return false;
		});
		
		<?php if($qmhi):?>
		 $('.mwqspd_si_txt').append(' ('+'<?php echo $qmhi;?>'+' Hidden)');
		<?php endif;?>
	});
 </script>
 <?php echo $MWQDC_LB->get_tablesorter_js('#mwqs_product_pull_table_desk');?>
