<?php
if ( ! defined( 'ABSPATH' ) ) exit;
/**
 * Fired during plugin activation
 *
 * @link       http://myworks.design/software/wordpress/woocommerce/myworks-wc-qbo-sync
 * @since      1.0.0
 *
 * @package    MW_QBO_Desktop
 * @subpackage MW_QBO_Desktop/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    MW_QBO_Desktop
 * @subpackage MW_QBO_Desktop/includes
 * @author     My Works <support@myworks.design>
 */

class MW_QBO_Desktop_Sync_Qwc_Server_Lib extends MW_QBO_Desktop_Sync_Lib{
	private $qbd_timezone;
	private $debug_queue;
	public function __construct($dsn){
		if(!session_id()) {
			session_start();
		}
		
		parent::__construct();
		
		if($this->dsn && QuickBooks_Utilities::initialized($this->dsn)){
			QuickBooks_WebConnector_Queue_Singleton::initialize($this->dsn);
		}

		if (function_exists('date_default_timezone_set')){			
			$qbd_tz_setting = $this->get_qbd_timezone();
			//$qbd_tz_setting = 'America/New_York';
			date_default_timezone_set($qbd_tz_setting);
			$this->qbd_timezone = $qbd_tz_setting;
		}
		
		if(isset($_GET['debug'])){
			$this->debug();
		}
		
		//$this->debug_queue = true;
	}
	
	public function debug(){
		$order_id = 167;
		$order_id_ext = 0;
		//echo $this->GetProductQbxml(30,'Inventory',0,'','',array('requestID'=>'54548748978988'));
		//echo $this->GetProductQbxml(30,'NonInventory',0,'','',array('requestID'=>'54548748978988'));
		//echo $this->GetSalesReceiptQbxml($order_id) .PHP_EOL;
		//echo $this->GetSalesReceiptQbxml_GPI($order_id_ext);
		//echo $this->GetSalesOrderQbxml($order_id);
		//echo $this->GetEstimateQbxml($order_id);
		//$this->_p($this->get_order_base_currency_total_from_order_id(0));		
		//$this->_p($this->get_wc_order_details_from_order($order_id,get_post($order_id)));
		//$this->_p($this->get_wc_order_details_from_order(346,get_post(346)));
		//$this->_p($this->get_wc_country_list());
		//echo $this->GetInvoiceQbxml($order_id);
		//echo $this->GetPurchaseOrderQbxml($order_id);
		//echo $this->GetCustomerQbxml(1);
		//echo $this->GetCustomerQbxml($order_id,true);
		
		/*
		$customer_data = $this->get_wc_customer_info_from_order($order_id);
		$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
		$this->_p($customer_data);
		$this->_p($qbo_cus_id,true);
		*/
		
		//$this->_p($this->get_wc_customer_info(11));
		//$this->_p($this->get_wc_customer_info_from_order(305));
		
		//echo $this->GetPaymentQbxml(10969);
		//echo $this->GetInventoryAdjustmentAddQbxml(76);
		//$this->_p($this->get_wc_variation_info(86));
		//echo $this->GetProductQbxml(361,'NonInventory',1,'','',array('requestID'=>'54548748978988'));
		//echo $this->server_timezone;
		//echo $this->get_auto_inventory_pull_m_dt_from();
		//echo $this->get_prd_pull_m_dt_from();
		//$user_data = get_userdata(17);
		//$this->_p($user_data);		
		//echo $this->GetRefundQbxml_Check(284,283);
		//die;
		
		/*
		if($this->check_cg_ibn($this->get_wc_customer_info_from_order(310))){
			echo 'Testing...';
		}
		*/
		
		/*
		if($this->check_cf_map_data_ext_field_value_exists(317,'Invoice')){
			echo 'Testing...';
		}
		*/
		//echo $this->GetOrderDataExtAddQbxml(317,array('Qos_Type'=>'Invoice','TxnID'=>'000-000000000000'));
		//$this->_p($this->get_wc_product_info(30));
		//$this->_p($this->get_post_img_data_by_id(212));
		
		//$this->_p($this->get_post_img_data_by_id(83));
		//$this->_p($this->img_to_base64(''));
		
		/*
		$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
		$extra = array('ListID'=>'3663909663125963009');
		$Queue->enqueue('POS_P_IMG_PULL', 124,124,$extra,$this->get_qbun());
		*/
		
		/*
		$arr = array(
			'ListID' => '2454382370367635713',
			'Desc1' => 'RSHSUB-3S',
			'Desc2' => '',
			'ALU' => '',
			'ItemNumber' => '9146',
			'UPC' => '',
			'TaxCode' => 'Tax',
			'Price1' => 50.00,
			'Price2' => 47.50,
			'ItemType' => 'Inventory',
			'QuantityOnHand' => 1.00,
			'Weight' => '',
			'DepartmentListID' => '3543481296543973633'
		);
		$this->_p($this->Qbd_pull_product($arr));
		*/
		
		//$this->_p($this->get_ii_ire_f_xml());
		
		$this->oth_debug_function();	
	}
	
	private function oth_debug_function(){
		//
		$xml = '';
		$err = '';
		//$this->Product_Pull_Response(0, '', '', 0, null, $err, '', '', $xml, 0);
		//$this->Recent_Product_Pull_Response(0, '', '', 0, array('is_product_update'=>1), $err, '', '', $xml, 0);
		//echo $this->PosProductImgAddRequest(0, '', '', 28, array('ListID'=>'1234567890'), $err, '', '', '', '');
		
	}
	
	public function Debug_Queue_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		// Build the request
		$q = '
			<CompanyQueryRq  requestID="' . $requestID . '">		
			</CompanyQueryRq>
		';
		
		$q = '
			<ItemInventoryPicturesQueryRq  requestID="' . $requestID . '">
				<ListID >3645384592879157505</ListID>
			</ItemInventoryPicturesQueryRq>
		';
		
		$xml = '<?xml version="1.0" encoding="utf-8"?>
		<?qbposxml version="' . $version . '"?>
		<QBPOSXML>
			<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
				'.$q.'
			</QBPOSXMLMsgsRq>
		</QBPOSXML>';
		
		$this->add_test_log($xml);
		return $xml;
	}
	
	public function Debug_Queue_response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$this->add_test_log($xml);
	}
	
	private function getonError(){
		$onError = 'continueOnError';//stopOnError
		return $onError;
	}
	private function get_qbxml_version($version='6.0'){
		return '3.0';
	}
	
	private function get_xml_encoding(){
		$xml_encoding = $this->get_option('mw_wc_qbo_desk_xml_req_encoding');
		if($xml_encoding!='utf-8' && $xml_encoding!='ISO-8859-1'){
			$xml_encoding = 'utf-8';
		}
		return $xml_encoding;
	}
	
	private function get_qbxml_prefix($version='6.0'){
		$version = $this->get_qbxml_version($version);
		$xml_encoding = $this->get_xml_encoding();
		//qbxml version="2.0"
		return '
			<?xml version="1.0" encoding="'.$xml_encoding.'"?>
			<?qbposxml version="'.$version.'"?>
			<QBPOSXML>
			<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
		';
		//continueOnError#stopOnError
	}
	
	private function get_qbxml_suffix(){
		return '
			</QBPOSXMLMsgsRq>
			</QBPOSXML>
		';
	}
	
	public function get_qbxml_locale(){
		$sl = trim($this->get_option('mw_wc_qbo_desk_xml_req_locale'));
		if($sl==''){$sl = 'US';}
		return $sl;
	}
	
	/*QBXML Functions*/
	
	/*PurchaseOrderQbxml*/	
	
	/*Invoice QBXML*/
	
	public function formatXmlString($xml){
		$xml = preg_replace('/(>)(<)(\/*)/', "$1\n$2$3", $xml);
		$token      = strtok($xml, "\n");
		$result     = '';
		$pad        = 0; 
		$matches    = array();
		while ($token !== false) : 
			if (preg_match('/.+<\/\w[^>]*>$/', $token, $matches)) : 
			  $indent=0;
			elseif (preg_match('/^<\/\w/', $token, $matches)) :
			  $pad -= 3;
			  $indent = 0;
			elseif (preg_match('/^<\w[^>]*[^\/]>.*$/', $token, $matches)) :
			  $indent=1;
			else :
			  $indent = 0; 
			endif;
			$line    = str_pad($token, strlen($token)+$pad, ' ', STR_PAD_LEFT);
			$result .= $line . "\n";
			$token   = strtok("\n");
			$pad    += $indent;
		endwhile; 
		return $result;
	}
	
	public function format_xml($xml){
		return $xml; // For Now
		$xml = trim($xml);
		if(!empty($xml)){
			//$xml = htmlspecialchars_decode($xml,ENT_QUOTES);
			//$xml = html_entity_decode($xml,ENT_QUOTES);
			
			$dom = new DOMDocument;
			$dom->preserveWhiteSpace = FALSE;
			$dom->loadXML($xml);
			$dom->formatOutput = TRUE;
			$xml = $dom->saveXml();
		}
		return $xml;
	}	
	
	/*SalesReceipt*/	
	
	public function GetSalesReceiptQbxml($order_id,$extra=null){
		if($this->is_qwc_connected()){
			$order = get_post($order_id);
			$invoice_data = $this->get_wc_order_details_from_order($order_id,$order);
			//$this->_p($invoice_data);
			
			if(is_array($invoice_data) && count($invoice_data)){
				global $wpdb;
				$wc_cus_id = (int) $this->get_array_isset($invoice_data,'wc_cus_id',0);
				$qbo_cus_id = '';
				
				$wc_inv_id = (int) $this->get_array_isset($invoice_data,'wc_inv_id',0);
				$wc_inv_num = $this->get_array_isset($invoice_data,'wc_inv_num','');
				
				$_order_currency = $this->get_array_isset($invoice_data,'_order_currency','',true);				
			
				if($this->is_plugin_active('woocommerce-aelia-currencyswitcher') && $this->option_checked('mw_wc_qbo_desk_wacs_satoc_cb')){				
					if($_order_currency!=''){
						$aelia_cur_cus_map = get_option('mw_wc_qbo_desk_wacs_satoc_map_cur_cus');
						if(is_array($aelia_cur_cus_map) && count($aelia_cur_cus_map)){
							if(isset($aelia_cur_cus_map[$_order_currency]) && trim($aelia_cur_cus_map[$_order_currency])!=''){
								$qbo_cus_id = trim($aelia_cur_cus_map[$_order_currency]);
							}
						}
					}					
				}
				
				/*
				if($this->is_plugin_active('myworks-quickbooks-desktop-sync-compatibility') && $this->is_plugin_active('myworks-quickbooks-desktop-shipping-us-state-quickbooks-customer-map-compt') && $this->option_checked('mw_wc_qbo_desk_compt_sus_qb_cus_map_ed')){					
					if($wc_cus_id>0){						
						$shipping_country = get_user_meta($wc_cus_id,'shipping_country',true);						
					}else{					
						$shipping_country = $this->get_array_isset($invoice_data,'_shipping_country','');
					}
					
					if($shipping_country == 'US'){
						if($wc_cus_id>0){
							$shipping_state = get_user_meta($wc_cus_id,'shipping_state',true);
						}else{
							$shipping_state = $this->get_array_isset($invoice_data,'_shipping_state','');
						}
						
						if($shipping_state!=''){
							$sus_qb_cus_map = get_option('mw_wc_qbo_desk_ship_us_st_qb_cus_map');
							if(is_array($sus_qb_cus_map) && count($sus_qb_cus_map)){
								if(isset($sus_qb_cus_map[$shipping_state]) && trim($sus_qb_cus_map[$shipping_state])!=''){
									$qbo_cus_id = trim($sus_qb_cus_map[$shipping_state]);
								}
							}
						}
					}else{
						$qbo_cus_id = $this->get_option('mw_wc_qbo_desk_sus_fb_qb_cus_foc');
					}
				}
				*/
				
				if(empty($qbo_cus_id)){
					if(!$this->option_checked('mw_wc_qbo_desk_all_order_to_customer')){
						if($wc_cus_id>0){							
							if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
								$customer_data = $this->get_wc_customer_info_from_order($order_id);
							}else{
								$customer_data = $this->get_wc_customer_info($wc_cus_id);
							}
							
							$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
						}else{
							$customer_data = $this->get_wc_customer_info_from_order($order_id);
							$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
						}
					}else{						
						/**/
						$wc_user_role = '';
						if($wc_cus_id>0){
							$user_info = get_userdata($wc_cus_id);
							if(isset($user_info->roles) && is_array($user_info->roles)){
								$wc_user_role = $user_info->roles[0];
							}
						}else{
							$wc_user_role = 'wc_guest_user';
						}
						
						if(!empty($wc_user_role)){
							$io_cs = true;
							$mw_wc_qbo_desk_aotc_rcm_data = get_option('mw_wc_qbo_desk_aotc_rcm_data');
							if(is_array($mw_wc_qbo_desk_aotc_rcm_data) && !empty($mw_wc_qbo_desk_aotc_rcm_data)){
								if(isset($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role]) && !empty($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role])){
									if($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role] != 'Individual'){
										$io_cs = false;
									}
								}
							}
							
							if($io_cs){
								if($wc_cus_id>0){
									if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
										$customer_data = $this->get_wc_customer_info_from_order($order_id);
									}else{
										$customer_data = $this->get_wc_customer_info($wc_cus_id);
									}							
									$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
								}else{
									$customer_data = $this->get_wc_customer_info_from_order($order_id);
									$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
								}
							}else{
								$qbo_cus_id = $mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role];
							}
						}						
					}
					
					if(empty($qbo_cus_id)){
						$this->save_log(array('log_type'=>'Order','log_title'=>'Export Order Error #'.$order_id,'details'=>'QuickBooks Customer Not Found','status'=>0));
						return false;
					}
					
					if($qbo_cus_id!=''){
						$DocNumber = ($wc_inv_num!='')?$wc_inv_num:$wc_inv_id;
						
						/*
						CustomerListID
						TxnDate
						
						Associate
						Cashier
						Comments
						Discount
						DiscountPercent
						PriceLevelNumber 
						PromoCode
						SalesOrderTxnID
						SalesReceiptType
						ShipDate
						StoreNumber
						TaxCategory
						TipReceiver
						TrackingNumber
						TxnDate
						TxnState(Normal, Held)
						Workstation
						*/
						
						$wc_inv_date = $this->get_array_isset($invoice_data,'wc_inv_date','');
						$wc_inv_date = $this->format_date($wc_inv_date);

						
						
						$WC_Order	= new WC_Order( $order_id );
						//$this->_p($invoice_data);
						
						$_payment_method = $this->get_array_isset($invoice_data,'_payment_method','',true);
						$_payment_method_title = $this->get_array_isset($invoice_data,'_payment_method_title','',true);
						
						/*Count Total Amounts*/
						$_cart_discount = $this->get_array_isset($invoice_data,'_cart_discount',0);
						$_cart_discount_tax = $this->get_array_isset($invoice_data,'_cart_discount_tax',0);

						$_order_tax = (float) $this->get_array_isset($invoice_data,'_order_tax',0);
						$_order_shipping_tax = (float) $this->get_array_isset($invoice_data,'_order_shipping_tax',0);
						$_order_total_tax = ($_order_tax+$_order_shipping_tax);
						
						$order_shipping_total = $this->get_array_isset($invoice_data,'order_shipping_total',0);
						$_order_total = $this->get_array_isset($invoice_data,'_order_total',0);
						//$_order_total = (float) $this->get_order_total_from_order_data($invoice_data);
						
						if($this->wacs_base_cur_enabled()){					
							$base_currency = get_woocommerce_currency();
							$pm_map_data = $this->get_mapped_payment_method_data($_payment_method,$base_currency);
						}else{
							$pm_map_data = $this->get_mapped_payment_method_data($_payment_method,$_order_currency);
						}
						
						$qb_p_method_id = $this->get_array_isset($pm_map_data,'qb_p_method_id','',true);
						
						$cust_ident = '<CustomerListID>'.$qbo_cus_id.'</CustomerListID>';
						$line_items = '';
						$tender = '';
						
						$is_so_tax_as_li = false;
						$qbo_is_sales_tax = true;
						if($this->option_checked('mw_wc_qbo_desk_odr_tax_as_li')){
							$is_so_tax_as_li = true;
							$qbo_is_sales_tax = false;
						}
						
						$tax_details = (isset($invoice_data['tax_details']))?$invoice_data['tax_details']:array();
						
						$qb_tax_category_id = '';
						$qb_tax_code = '';
						if($qbo_is_sales_tax && $_order_tax > 0){
							$tax_rate_id = 0;
							$tax_rate_id_2 = 0;
							
							if(count($tax_details)){
								$tax_rate_id = $tax_details[0]['rate_id'];
							}

							if(count($tax_details)>1){
								if($tax_details[1]['tax_amount']>0){
									$tax_rate_id_2 = $tax_details[1]['rate_id'];
								}
							}
							
							$qb_mapped_tax_d = $this->get_qbo_mapped_tax_code($tax_rate_id,$tax_rate_id_2);
							if(!empty($qb_mapped_tax_d)){
								$qmtd_a = explode('__',$qb_mapped_tax_d);
								if(is_array($qmtd_a) && count($qmtd_a) == 3){
									$qb_tax_category_id = $qmtd_a[1];
									$qb_tax_code = $qmtd_a[0];
									$qb_tax_category_id = str_replace('_',' ',$qb_tax_category_id);
								}
							}					
						}
						
						//$qbtc_sv = $this->get_option('mw_wc_qbo_desk_tax_rule_taxable');
						$qbntc_sv = $this->get_option('mw_wc_qbo_desk_tax_rule');
						if((!$qbo_is_sales_tax || empty($qb_tax_category_id)) && !empty($qbntc_sv)){
							$qmtd_a = explode('__',$qbntc_sv);
							if(is_array($qmtd_a) && count($qmtd_a) == 3){
								$qb_tax_category_id = $qmtd_a[1];
								$qb_tax_code = $qmtd_a[0];
								$qb_tax_category_id = str_replace('_',' ',$qb_tax_category_id);
							}
						}
						
						$non_tax_code = 'Non';
						
						/*
						TenderAccountAdd
						TenderDebitCardAdd
						TenderDepositAdd
						TenderGiftAdd
						TenderGiftCardAdd
						*/
						
						switch ($qb_p_method_id){
							case"Cash":
								$tender = '<TenderCashAdd> 
												<TenderAmount>'.$_order_total.'</TenderAmount>
											</TenderCashAdd>';
								break;
							case"Check":
								$tender = '<TenderCheckAdd> 
												<CheckNumber>'.$order_id.'</CheckNumber>
												<TenderAmount>'.$_order_total.'</TenderAmount>
											</TenderCheckAdd>';
								break;	
							case"Visa":
							case"Mastercard":
							case"Discover Card":
							case"American Express":
							case"Diners Club":
							case"JCB":
								$tender = '<TenderCreditCardAdd> 
												<CardName>'.$qb_p_method_id.'</CardName>
												<TenderAmount>'.$_order_total.'</TenderAmount>
											</TenderCreditCardAdd>';
							break;
						}
						
						//$_payment_method_title
						if(empty($tender)){
							/*
							$tender = '<TenderCashAdd>
										<TenderAmount>'.$_order_total.'</TenderAmount>
									</TenderCashAdd>';
							*/
							
							$tender = '<TenderCreditCardAdd> 
										<CardName>Visa</CardName>
										<TenderAmount>'.$_order_total.'</TenderAmount>
									</TenderCreditCardAdd>';
							
						}
						
						if(!empty($tender)){
							$tender = PHP_EOL . $tender . PHP_EOL;
						}
						
						/**/
						$cf_map_data = array();
						if($this->is_plugin_active('myworks-quickbooks-desktop-custom-field-mapping') && $this->check_sh_cfm_hash()){
							$cf_map_data = $this->get_cf_map_data();
						}
						
						$qbo_inv_items = (isset($invoice_data['qbo_inv_items']))?$invoice_data['qbo_inv_items']:array();
						if(is_array($qbo_inv_items) && count($qbo_inv_items)){
							foreach($qbo_inv_items as $qbo_item){
								$line_items .= '<SalesReceiptItemAdd>'. PHP_EOL .$this->get_qbsr_item_info($qbo_item, $invoice_data,$qb_tax_code,$qbo_is_sales_tax,$cf_map_data). PHP_EOL .'</SalesReceiptItemAdd>' .PHP_EOL;
							}
						}
						
						/**/
						if($this->get_wc_fee_plugin_check()){
							$dc_gt_fees = (isset($invoice_data['dc_gt_fees']))?$invoice_data['dc_gt_fees']:array();
							if(is_array($dc_gt_fees) && count($dc_gt_fees)){
								foreach($dc_gt_fees as $df){
									$df_ItemRef = $this->get_wc_fee_qbo_product($df['name'],'',$invoice_data);
									$fee_tax_code = ($df['_line_tax'] > 0 && $qb_tax_code != '')?$qb_tax_code:$non_tax_code;
									
									$line_items .= '<SalesReceiptItemAdd>'. PHP_EOL .
									'<ListID>'. $df_ItemRef. '</ListID>'. PHP_EOL .
									'<ExtendedPrice>'.number_format($df['_line_total'],2,'.','').'</ExtendedPrice>'. PHP_EOL .
									//'<Qty>1</Qty>'. PHP_EOL .
									'<TaxCode>'.$fee_tax_code.'</TaxCode>'. PHP_EOL .
									'</SalesReceiptItemAdd>' .PHP_EOL;
								}
							}
						}
						
						/**/
						if($is_so_tax_as_li && count($tax_details) && $_order_total_tax >0){
							$otli_item = $this->get_option('mw_wc_qbo_desk_otli_qbd_product');
							if(empty($otli_item)){
								$otli_item = $this->get_option('mw_wc_qbo_desk_default_qbo_item');
							}
							
							$line_items .= '<SalesReceiptItemAdd>'. PHP_EOL .
							'<ListID>'. $otli_item. '</ListID>'. PHP_EOL .
							'<ExtendedPrice>'.number_format($_order_total_tax,2,'.','').'</ExtendedPrice>'. PHP_EOL .
							//'<Qty>1</Qty>'. PHP_EOL .
							'<TaxCode>Non</TaxCode>'. PHP_EOL .
							'</SalesReceiptItemAdd>' .PHP_EOL;
						}
						
						$qbxml_file = 'add-salesreceipt';
						$qbxml_template_path = plugin_dir_path( __FILE__ ) . 'qbxml-templates'. DIRECTORY_SEPARATOR . $qbxml_file. '.php';
						if(file_exists($qbxml_template_path)){
							$qbxml = include( $qbxml_template_path );
							$qbxml = $this->format_xml($qbxml);
							//$qbxml = $this->formatXmlString($qbxml);
							return $qbxml;
						}
						
					}
				}
			}
		}
	}
	
	private function get_qbsr_item_info($qbo_item,$invoice_data,$qb_tax_code='',$qbo_is_sales_tax=true,$cf_map_data=array()){
		global $wpdb;
		$ident ='<ListID>'. $qbo_item['ItemRef']. '</ListID>';
		
		$tax_line="";
		if($qbo_is_sales_tax && $qbo_item['Taxed'] > 0){ // && !empty($qbo_item['tax_class'])
			//$tax_line ='<TaxCode>'.$qbo_item['tax_class'].'</TaxCode>';
			//$tax_line="<TaxCode>Non</TaxCode>";
			if($qb_tax_code!=''){
				$tax_line="<TaxCode>".$qb_tax_code."</TaxCode>";
			}else{
				$qi_info = $this->get_field_by_val($wpdb->prefix.'mw_wc_qbo_desk_qbd_items','info_arr','qbd_id',$qbo_item['ItemRef']);
				if(!empty($qi_info)){
					$qi_info = unserialize($qi_info);				
					if(is_array($qi_info) && isset($qi_info['TaxCode'])){
						$tax_line="<TaxCode>".$qi_info['TaxCode']."</TaxCode>";
					}
				}
			}			
		}else{
			//$tax_line ='';
			$tax_line="<TaxCode>Non</TaxCode>";
		}		
		
		$ext_line = '';		
		if(is_array($cf_map_data) && count($cf_map_data)){			
			$qacfm = $this->get_qbo_avl_cf_map_fields();
			foreach($cf_map_data as $wcfm_k => $wcfm_v){
				$wcfm_k = trim($wcfm_k);
				$wcfm_v = trim($wcfm_v);
				
				if(!empty($wcfm_v)){
					$wcf_val = '';
					switch ($wcfm_k) {									
						case "wc_order_shipping_method_name":
							$wcf_val = $shipping_method_name;
							break;
						case "wc_order_phone_number":
							$wcf_val = $this->get_array_isset($invoice_data,'_billing_phone','',true);
							break;
						default:
							if(isset($invoice_data[$wcfm_k])){								
								//is_string
								if(!is_array($invoice_data[$wcfm_k]) && !is_object($invoice_data[$wcfm_k])){
									$wcf_val = $this->get_array_isset($invoice_data,$wcfm_k,'',true);
								}										
							}
					}
					
					if(!empty($wcf_val) && isset($qacfm[$wcfm_v])){						
						$qbo_cf_arr = array();
						switch ($wcfm_v) {
							case "":								
								break;								
							default:
							try {
								if(is_array($qbo_cf_arr) && count($qbo_cf_arr) && isset($qbo_cf_arr[$wcfm_v])){
									//
								}else{
									$qacfm_naf = $this->get_qbo_avl_cf_map_fields(true);
									$ivqf = true;
									if(is_array($qacfm_naf) && count($qacfm_naf) && isset($qacfm_naf[$wcfm_v])){
										$ivqf = false;
									}
									if($ivqf){
										//
									}else{
										if($wcfm_v == 'SerialNumber'){
											$ext_line= PHP_EOL ."<SerialNumber>{$wcf_val}</SerialNumber>";
										}
									}
								}
							}catch(Exception $e) {
								$cfm_err = $e->getMessage();
							}
						}
					}
				}
			}
		}
		
		$line_item = $ident. PHP_EOL . '<ExtendedPrice>'.number_format($qbo_item['line_subtotal'],2,'.','').'</ExtendedPrice>'. PHP_EOL .'<Qty>'.$qbo_item['Qty'].'</Qty>'. PHP_EOL .$tax_line.$ext_line;
		return $line_item;
	}
	
	/*SalesOrder QBXML*/
	public function GetSalesOrderQbxml($order_id,$extra=null){
		if($this->is_qwc_connected()){
			$order = get_post($order_id);
			$invoice_data = $this->get_wc_order_details_from_order($order_id,$order);
			//$this->_p($invoice_data);
			
			if(is_array($invoice_data) && count($invoice_data)){
				global $wpdb;
				$wc_cus_id = (int) $this->get_array_isset($invoice_data,'wc_cus_id',0);
				$qbo_cus_id = '';
				
				$wc_inv_id = (int) $this->get_array_isset($invoice_data,'wc_inv_id',0);
				$wc_inv_num = $this->get_array_isset($invoice_data,'wc_inv_num','');
				
				$_order_currency = $this->get_array_isset($invoice_data,'_order_currency','',true);				
				
				/**/
				$is_update = false;
				if(is_array($extra) && isset($extra['is_update']) && $extra['is_update']){
					$is_update = true;
					//$qbo_cus_id = 'NOT_REQUIRED';
				}
				
				if(empty($qbo_cus_id) && $this->is_plugin_active('woocommerce-aelia-currencyswitcher') && $this->option_checked('mw_wc_qbo_desk_wacs_satoc_cb')){				
					if($_order_currency!=''){
						$aelia_cur_cus_map = get_option('mw_wc_qbo_desk_wacs_satoc_map_cur_cus');
						if(is_array($aelia_cur_cus_map) && count($aelia_cur_cus_map)){
							if(isset($aelia_cur_cus_map[$_order_currency]) && trim($aelia_cur_cus_map[$_order_currency])!=''){
								$qbo_cus_id = trim($aelia_cur_cus_map[$_order_currency]);
							}
						}
					}					
				}
				
				if(empty($qbo_cus_id)){
					if(!$this->option_checked('mw_wc_qbo_desk_all_order_to_customer')){
						if($wc_cus_id>0){							
							if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
								$customer_data = $this->get_wc_customer_info_from_order($order_id);
							}else{
								$customer_data = $this->get_wc_customer_info($wc_cus_id);
							}
							
							$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
						}else{
							$customer_data = $this->get_wc_customer_info_from_order($order_id);
							$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
						}
					}else{						
						/**/
						$wc_user_role = '';
						if($wc_cus_id>0){
							$user_info = get_userdata($wc_cus_id);
							if(isset($user_info->roles) && is_array($user_info->roles)){
								$wc_user_role = $user_info->roles[0];
							}
						}else{
							$wc_user_role = 'wc_guest_user';
						}
						
						if(!empty($wc_user_role)){
							$io_cs = true;
							$mw_wc_qbo_desk_aotc_rcm_data = get_option('mw_wc_qbo_desk_aotc_rcm_data');
							if(is_array($mw_wc_qbo_desk_aotc_rcm_data) && !empty($mw_wc_qbo_desk_aotc_rcm_data)){
								if(isset($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role]) && !empty($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role])){
									if($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role] != 'Individual'){
										$io_cs = false;
									}
								}
							}
							
							if($io_cs){
								if($wc_cus_id>0){
									if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
										$customer_data = $this->get_wc_customer_info_from_order($order_id);
									}else{
										$customer_data = $this->get_wc_customer_info($wc_cus_id);
									}							
									$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
								}else{
									$customer_data = $this->get_wc_customer_info_from_order($order_id);
									$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
								}
							}else{
								$qbo_cus_id = $mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role];
							}
						}						
					}
				}
				
				if(empty($qbo_cus_id)){
					$this->save_log(array('log_type'=>'Order','log_title'=>'Export Order Error #'.$order_id,'details'=>'QuickBooks Customer Not Found','status'=>0));
					return false;
				}
				
				if($qbo_cus_id!=''){
					$DocNumber = ($wc_inv_num!='')?$wc_inv_num:$wc_inv_id;
					$SalesOrderNumber_Xml = (!empty($DocNumber))?'<SalesOrderNumber>'.$DocNumber.'</SalesOrderNumber>':'';
					
					$wc_inv_date = $this->get_array_isset($invoice_data,'wc_inv_date','');
					$wc_inv_date = $this->format_date($wc_inv_date);

					
					
					$WC_Order	= new WC_Order( $order_id );
					//$this->_p($invoice_data);
					
					$_payment_method = $this->get_array_isset($invoice_data,'_payment_method','',true);
					$_payment_method_title = $this->get_array_isset($invoice_data,'_payment_method_title','',true);
					
					/*Count Total Amounts*/
					$_cart_discount = $this->get_array_isset($invoice_data,'_cart_discount',0);
					$_cart_discount_tax = $this->get_array_isset($invoice_data,'_cart_discount_tax',0);

					$_order_tax = (float) $this->get_array_isset($invoice_data,'_order_tax',0);
					$_order_shipping_tax = (float) $this->get_array_isset($invoice_data,'_order_shipping_tax',0);
					$_order_total_tax = ($_order_tax+$_order_shipping_tax);
					
					$order_shipping_total = $this->get_array_isset($invoice_data,'order_shipping_total',0);
					$_order_total = $this->get_array_isset($invoice_data,'_order_total',0);
					//$_order_total = (float) $this->get_order_total_from_order_data($invoice_data);
					
					if($this->wacs_base_cur_enabled()){					
						$base_currency = get_woocommerce_currency();
						$pm_map_data = $this->get_mapped_payment_method_data($_payment_method,$base_currency);
					}else{
						$pm_map_data = $this->get_mapped_payment_method_data($_payment_method,$_order_currency);
					}
					
					$qb_p_method_id = $this->get_array_isset($pm_map_data,'qb_p_method_id','',true);
					
					$cust_ident = '<CustomerListID>'.$qbo_cus_id.'</CustomerListID>';
					$line_items = '';
					$tender = '';
					
					$TxnID_ident = '';
					if($is_update){
						$TxnID_ident = '<TxnID>'.$extra['TxnID'].'</TxnID>';
						//$cust_ident = '';
					}
					
					$is_so_tax_as_li = false;
					$qbo_is_sales_tax = true;
					if($this->option_checked('mw_wc_qbo_desk_odr_tax_as_li')){
						$is_so_tax_as_li = true;
						$qbo_is_sales_tax = false;
					}
					
					$tax_details = (isset($invoice_data['tax_details']))?$invoice_data['tax_details']:array();
					
					$qb_tax_category_id = '';
					$qb_tax_code = '';
					if($qbo_is_sales_tax && $_order_tax > 0){
						$tax_rate_id = 0;
						$tax_rate_id_2 = 0;
						
						if(count($tax_details)){
							$tax_rate_id = $tax_details[0]['rate_id'];
						}

						if(count($tax_details)>1){
							if($tax_details[1]['tax_amount']>0){
								$tax_rate_id_2 = $tax_details[1]['rate_id'];
							}
						}
						
						$qb_mapped_tax_d = $this->get_qbo_mapped_tax_code($tax_rate_id,$tax_rate_id_2);
						if(!empty($qb_mapped_tax_d)){
							$qmtd_a = explode('__',$qb_mapped_tax_d);
							if(is_array($qmtd_a) && count($qmtd_a) == 3){
								$qb_tax_category_id = $qmtd_a[1];
								$qb_tax_code = $qmtd_a[0];
								$qb_tax_category_id = str_replace('_',' ',$qb_tax_category_id);
							}
						}					
					}
					
					/**/
					
					
					//$qbtc_sv = $this->get_option('mw_wc_qbo_desk_tax_rule_taxable');
					$qbntc_sv = $this->get_option('mw_wc_qbo_desk_tax_rule');
					if((!$qbo_is_sales_tax || empty($qb_tax_category_id)) && !empty($qbntc_sv)){
						$qmtd_a = explode('__',$qbntc_sv);
						if(is_array($qmtd_a) && count($qmtd_a) == 3){
							$qb_tax_category_id = $qmtd_a[1];
							$qb_tax_code = $qmtd_a[0];
							$qb_tax_category_id = str_replace('_',' ',$qb_tax_category_id);
						}
					}
					
					/**/
					$cf_map_data = array();
					if($this->is_plugin_active('myworks-quickbooks-desktop-custom-field-mapping') && $this->check_sh_cfm_hash()){
						$cf_map_data = $this->get_cf_map_data();
					}
					
					$qbo_inv_items = (isset($invoice_data['qbo_inv_items']))?$invoice_data['qbo_inv_items']:array();
					if(is_array($qbo_inv_items) && count($qbo_inv_items)){
						foreach($qbo_inv_items as $qbo_item){
							$line_items .= '<SalesOrderItemAdd>'. PHP_EOL .$this->get_qbsr_item_info($qbo_item, $invoice_data,$qb_tax_code,$qbo_is_sales_tax,$cf_map_data). PHP_EOL .'</SalesOrderItemAdd>' .PHP_EOL;
						}
					}
					
					/**/
					if($this->get_wc_fee_plugin_check()){
						$dc_gt_fees = (isset($invoice_data['dc_gt_fees']))?$invoice_data['dc_gt_fees']:array();
						if(is_array($dc_gt_fees) && count($dc_gt_fees)){
							foreach($dc_gt_fees as $df){
								$df_ItemRef = $this->get_wc_fee_qbo_product($df['name'],'',$invoice_data);
								$fee_tax_code = ($df['_line_tax'] > 0 && $qb_tax_code != '')?$qb_tax_code:$non_tax_code;
								
								$line_items .= '<SalesReceiptItemAdd>'. PHP_EOL .
								'<ListID>'. $df_ItemRef. '</ListID>'. PHP_EOL .
								'<ExtendedPrice>'.number_format($df['_line_total'],2,'.','').'</ExtendedPrice>'. PHP_EOL .
								//'<Qty>1</Qty>'. PHP_EOL .
								'<TaxCode>'.$fee_tax_code.'</TaxCode>'. PHP_EOL .
								'</SalesReceiptItemAdd>' .PHP_EOL;
							}
						}
					}
					
					/**/
					if($is_so_tax_as_li && count($tax_details) && $_order_total_tax >0){
						$otli_item = $this->get_option('mw_wc_qbo_desk_otli_qbd_product');
						if(empty($otli_item)){
							$otli_item = $this->get_option('mw_wc_qbo_desk_default_qbo_item');
						}
						
						$line_items .= '<SalesOrderItemAdd>'. PHP_EOL .
						'<ListID>'. $otli_item. '</ListID>'. PHP_EOL .
						'<ExtendedPrice>'.number_format($_order_total_tax,2,'.','').'</ExtendedPrice>'. PHP_EOL .
						//'<Qty>1</Qty>'. PHP_EOL .
						'<TaxCode>Non</TaxCode>'. PHP_EOL .
						'</SalesOrderItemAdd>' .PHP_EOL;
					}
					
					$qbxml_file = 'add-salesorder';
					if($is_update){
						$qbxml_file = 'mod-salesorder';
					}
					
					$qbxml_template_path = plugin_dir_path( __FILE__ ) . 'qbxml-templates'. DIRECTORY_SEPARATOR . $qbxml_file. '.php';
					if(file_exists($qbxml_template_path)){
						$qbxml = include( $qbxml_template_path );
						$qbxml = $this->format_xml($qbxml);
						//$qbxml = $this->formatXmlString($qbxml);
						
						if($is_update){
							$qbxml = str_replace(array('<SalesOrderItemAdd>','</SalesOrderItemAdd>'),array('<SalesOrderItemMod>','</SalesOrderItemMod>'),$qbxml);
						}
						
						return $qbxml;
					}
				}
			}
		}
	}
	
	//31-10-2017
	public function get_ord_baf_addrs($ba_data){
		//$f_ba_data = array('line1'=>'','line2'=>'','line3'=>'','line4'=>'','line5'=>'');
		$f_ba_data = array();
		if(is_array($ba_data) && count($ba_data)){				
			$mw_wc_qbo_desk_ord_bill_addr_map = $this->get_option('mw_wc_qbo_desk_ord_bill_addr_map');
			if(empty($mw_wc_qbo_desk_ord_bill_addr_map)){
				$mw_wc_qbo_desk_ord_bill_addr_map = $this->get_default_ord_ba();
			}
			$fs_srch_arr = array('{_billing_first_name}','{_billing_last_name}','{_billing_company}','{_billing_address_1}','{_billing_address_2}','{_billing_city}','{_billing_state}','{_billing_postcode}','{_billing_phone}','{_billing_country}');
			$fsa_arr = explode(PHP_EOL,$mw_wc_qbo_desk_ord_bill_addr_map);
			
			//$this->_p($fs_srch_arr);
			//$this->_p($fsa_arr);
			//$this->_p($ba_data);
			
			//United States (US) Minor Outlying Islands
			//United States (US) Virgin Islands
			$skip_us_country = $this->option_checked('mw_wc_qbo_desk_cus_skip_usa_country');
			if($skip_us_country && (end($ba_data) == 'United States (US)' || end($ba_data) == 'US')){				
				$l_key = key($ba_data);
				if(isset($ba_data[$l_key])){
					$ba_data[$l_key] = '';
				}
			}
			
			if(is_array($fsa_arr) && count($fsa_arr)){
				foreach($fsa_arr as $sk => $sd){
					if($sk>4){break;}
					//$sk_c = $sk+1;
					$sd = trim($sd);
					$fxa = str_replace($fs_srch_arr,$ba_data,$sd);
					$fxa = trim($fxa);
					//$f_ba_data['line'.$sk_c] = $fxa;
					$f_ba_data[] = $fxa;
				}
			}
		}
		$f_ba_data = array_filter($f_ba_data);
		$f_ba_data = array_values($f_ba_data);
		//$this->_p($f_ba_data);
		return $f_ba_data;
	}
	
	public function get_ord_saf_addrs($sa_data){		
		//$f_sa_data = array('line1'=>'','line2'=>'','line3'=>'','line4'=>'','line5'=>'');
		$f_sa_data = array();
		if(is_array($sa_data) && count($sa_data)){
			$mw_wc_qbo_desk_ord_ship_addr_map = $this->get_option('mw_wc_qbo_desk_ord_ship_addr_map');
			if(empty($mw_wc_qbo_desk_ord_ship_addr_map)){
				$mw_wc_qbo_desk_ord_ship_addr_map = $this->get_default_ord_sa();
			}
			
			$fs_srch_arr = array('{_shipping_first_name}','{_shipping_last_name}','{_shipping_company}','{_shipping_address_1}','{_shipping_address_2}','{_shipping_city}','{_shipping_state}','{_shipping_postcode}','{_shipping_country}');
			$fsa_arr = explode(PHP_EOL,$mw_wc_qbo_desk_ord_ship_addr_map); 
			
			//$this->_p($fs_srch_arr);
			//$this->_p($fsa_arr);
			//$this->_p($sa_data);
			
			$skip_us_country = $this->option_checked('mw_wc_qbo_desk_cus_skip_usa_country');
			if($skip_us_country && (end($sa_data) == 'United States (US)' || end($sa_data) == 'US')){				
				$l_key = key($sa_data);
				if(isset($sa_data[$l_key])){
					$sa_data[$l_key] = '';
				}
			}
			
			if(is_array($fsa_arr) && count($fsa_arr)){
				foreach($fsa_arr as $sk => $sd){
					if($sk>4){break;}
					//$sk_c = $sk+1;
					$sd = trim($sd);
					$fxa = str_replace($fs_srch_arr,$sa_data,$sd);
					$fxa = trim($fxa);
					//$f_sa_data['line'.$sk_c] = $fxa;
					$f_sa_data[] = $fxa;
				}
			}
		}
		$f_sa_data = array_filter($f_sa_data);
		$f_sa_data = array_values($f_sa_data);
	
		//$this->_p($f_sa_data);
		return $f_sa_data;
	}
	
	//
	public function get_owner_id(){
		return '0';
	}
	
	public function qbd_dext_type_str(){
		return 'STR255TYPE';
	}
	
	//
	public function GetCustomerQbxml($id,$is_guest=false,$edit_sequence='',$qb_list_id=''){
		if($is_guest){
			$edit_sequence = '';
		}
		
		if(!empty($edit_sequence) && empty($qb_list_id)){
			return false;
		}
		
		if($this->is_qwc_connected()){
			$ext_qbxml = '';
			if($is_guest){
				$order_id = (int) $id;
				$customer_data = $this->get_wc_customer_info_from_order($order_id);
			}else{
				$customer_id = (int) $id;
				$customer_data = $this->get_wc_customer_info($customer_id);
			}
			
			if(is_array($customer_data) && count($customer_data)){
				$Customer = new QuickBooks_QBXML_Object_Customer();
				
				$Customer->setFirstName($customer_data['firstname']);
				$Customer->setLastName($customer_data['lastname']);
				//CustomerID
				
				$display_name = $customer_data['display_name'];
				global $wpdb;
				
				if($this->option_checked('mw_wc_qbo_desk_cus_push_append_client_id')){
					if($this->get_field_by_val($wpdb->prefix.'mw_wc_qbo_desk_qbd_customers','qbd_customerid','d_name',$display_name)){
						if($is_guest){
							if($customer_data['email']!=''){
								$display_name.= '-'.$order_id;
							}							
						}else{
							$display_name.= '-'.$customer_id;
						}						
					}
				}				
				
				//$Customer->set('FullName',$display_name);
				$Customer->setCompanyName($customer_data['company']);
				
				$Customer->set('EMail',$customer_data['email']);
				
				$f_l_name = $customer_data['firstname'].' '.$customer_data['lastname'];
				
				$phone = $this->get_array_isset($customer_data,'billing_phone','',true,21);
				if($phone!=''){
					$Customer->setPhone($phone);
				}
				
				//<CustomerType >STRTYPE</CustomerType>
				
				$skip_us_country = $this->option_checked('mw_wc_qbo_desk_cus_skip_usa_country');
				
				$address = $this->get_array_isset($customer_data,'billing_address_1','',true);
				if($address!=''){
					$country = $this->get_array_isset($customer_data,'billing_country','',true);
					$country = $this->get_country_name_from_code($country);
					
					if($skip_us_country && ($country == 'United States (US)' || $country == 'US')){
						$country = '';
					}
					
					$Customer->set('BillAddress City', $this->get_array_isset($customer_data,'billing_city','',true));
					$Customer->set('BillAddress Country', $country);
					$Customer->set('BillAddress PostalCode', $this->get_array_isset($customer_data,'billing_postcode','',true));
					$Customer->set('BillAddress State', $this->get_array_isset($customer_data,'billing_state','',true));
					$Customer->set('BillAddress Street', $address);
					$Customer->set('BillAddress Street2', $this->get_array_isset($customer_data,'billing_address_2','',true));					
				}				
				
				$sh_addr_name = 'Shipping Address 1';
				$shipping_address = $this->get_array_isset($customer_data,'shipping_address_1','',true);
				if($shipping_address!=''){
					$Customer->set('DefaultShipAddress',$sh_addr_name);
					
					$country = $this->get_array_isset($customer_data,'shipping_country','',true);
					$country = $this->get_country_name_from_code($country);
					
					if($skip_us_country && ($country == 'United States (US)' || $country == 'US')){
						$country = '';
					}
					
					$Customer->set('ShipAddress AddressName', $sh_addr_name);
					$Customer->set('ShipAddress CompanyName', $customer_data['company']);
					$Customer->set('ShipAddress FullName', $display_name);
					$Customer->set('ShipAddress City', $this->get_array_isset($customer_data,'shipping_city','',true));
					$Customer->set('ShipAddress Country', $country);
					$Customer->set('ShipAddress PostalCode', $this->get_array_isset($customer_data,'shipping_postcode','',true));
					$Customer->set('ShipAddress State', $this->get_array_isset($customer_data,'shipping_state','',true));
					$Customer->set('ShipAddress Street', $address);
					$Customer->set('ShipAddress Street2', $this->get_array_isset($customer_data,'shipping_address_2','',true));
				}
				
				/**/
				$Qbxml_Type = QUICKBOOKS_ADD_CUSTOMER;
				if(!empty($edit_sequence)){
					$Customer->set('ListID',$qb_list_id);
					//$Customer->set('EditSequence',$edit_sequence);
					$Qbxml_Type = QUICKBOOKS_MOD_CUSTOMER;
				}
				
				//$this->_p($customer_data);
				//$this->_p($Customer);
				
				$qbxml = $Customer->asQBXML($Qbxml_Type,null,$this->get_qbxml_locale());
				$qbxml.= $ext_qbxml;
				
				$qbxml = $this->get_qbxml_prefix().$qbxml. $this->get_qbxml_suffix();
				return $qbxml;
			}
		}
	}
		
	/**/
	public function GetProductQbxml($id,$item_type,$is_variation=0,$edit_sequence='',$qb_list_id='',$req_qf_data=array()){
		if($this->is_qwc_connected() && is_array($req_qf_data) && isset($req_qf_data['requestID'])){
			global $wpdb;
			if($is_variation){
				$product_data = $this->get_wc_variation_info($id);
			}else{
				$product_data = $this->get_wc_product_info($id);
			}
			
			//$this->_p($product_data);
			
			if(is_array($product_data) && count($product_data)){
				
				$name_replace_chars = array(':');
				//$name = $this->get_array_isset($product_data,'name','',true,100,false,$name_replace_chars);
				$name = $this->get_array_isset($product_data,'name','',true,30,false,$name_replace_chars);
				$sku = $this->get_array_isset($product_data,'_sku','',true,30);
				
				/**/
				$qb_p_name = $name;
				if($this->get_option('mw_wc_qbo_desk_qb_prd_name_dsc1_v_opt') == 'sku' && !empty($sku)){
					$qb_p_name = $sku;
				}
				
				$desc = $this->get_array_isset($product_data,'short_description','',true,4000);
				/**/
				if($this->get_option('mw_wc_qbo_desk_qb_prd_dsc_dsc2_v_opt') == 'name' && !empty($name)){
					$desc = $name;
				}
				
				if($this->get_option('mw_wc_qbo_desk_qb_prd_dsc_dsc2_v_opt') == 'sku' && !empty($sku)){
					$desc = $sku;
				}
				
				/*
				if($desc==''){
					$desc = $this->get_array_isset($product_data,'description','',true,4000);
				}
				*/
				
				if($this->get_option('mw_wc_qbo_desk_qb_prd_dsc_dsc2_v_opt') == 'desc' && isset($product_data['description']) && !empty($product_data['description'])){
					$desc = $this->get_array_isset($product_data,'description','',true,4000);
				}
				
				if(isset($product_data['_price'])){
					$_price = $this->get_array_isset($product_data,'_price',0);
				}else{
					$_price = $this->get_array_isset($product_data,'_regular_price',0);
				}
				
				$_price = str_replace(',','',$_price);
				$_price = floatval($_price);
				
				$price1 = '<Price1>'.$_price.'</Price1>';				
				
				$price2 = '';
				if(isset($product_data['_sale_price'])){
					$_sale_price = $this->get_array_isset($product_data,'_sale_price',0);
					$_sale_price = str_replace(',','',$_sale_price);
					$_sale_price = floatval($_sale_price);
					
					$price2 = '<Price2>'.$_sale_price.'</Price2>';
				}
				
				$requestID = $req_qf_data['requestID'];
				
				$tax_code = 'NON';
				if(isset($product_data['_tax_status']) && $product_data['_tax_status'] == 'taxable'){
					$tax_code = 'TAX';
				}				
				
				$_stock = $this->get_array_isset($product_data,'_stock',0,true);
				if($_stock==''){$_stock=0;}
				
				$alu = '';
				if($sku!=''){
					$alu = '<ALU>'.$sku.'</ALU>';
				}
				
				//UPC ItemNumber 
				
				$item_number = '';
				
				$dept = $this->get_option('mw_wc_qbo_desk_default_department');
				/**/
				if(!$is_variation){
					$wp_cats = get_the_terms ( $id, 'product_cat' );
					if(is_array($wp_cats) && !empty($wp_cats)){
						$wp_cats = $wp_cats[0];
						$wp_cat_id = (int) $wp_cats->term_id;
						if($wp_cat_id > 0){
							$qmd = $this->get_field_by_val($wpdb->prefix.'mw_wc_qbo_desk_qbd_map_departments','qbo_department_id','wc_category_id',$wp_cat_id);
							if(!empty($qmd)){
								$dept = $qmd;
							}
						}
					}					
				}
				
				$department = '<DepartmentListID>'.$dept.'</DepartmentListID>';
				
				//
				$Attribute_xml = '';
				$Size_xml = '';
				if($is_variation){
					/**/
					$p_attr_fld = $this->get_option('mw_wc_qbo_desk_prd_pull_attr_fld_map');
					$p_size_fld = $this->get_option('mw_wc_qbo_desk_prd_pull_size_fld_map');
					
					if(!empty($p_attr_fld) || !empty($p_size_fld)){						
					    $variation          = new WC_Product_Variation($id);
					    $v_attributes       = $variation->get_variation_attributes();
						//$this->_p($v_attributes);
						
						if(is_array($v_attributes) && !empty($v_attributes)){
							if(!empty($p_attr_fld)){								
								if(isset($v_attributes['attribute_pa_'.$p_attr_fld])){
									$attr_fld_k = 'attribute_pa_'.$p_attr_fld;
								}elseif(isset($v_attributes['attribute_'.$p_attr_fld])){
									$attr_fld_k = 'attribute_'.$p_size_fld;
								}elseif(isset($v_attributes['pa_'.$p_attr_fld])){
									$attr_fld_k = 'pa_'.$p_attr_fld;
								}elseif(isset($v_attributes[$p_attr_fld])){
									$attr_fld_k = $p_attr_fld;
								}else{
									$attr_fld_k = '';
								}
								
								if(!empty($attr_fld_k)){
									if(!empty($v_attributes[$attr_fld_k])){
										$Attribute_xml = '<Attribute>'.$v_attributes[$attr_fld_k].'</Attribute>';
									}
								}								
							}
							
							if(!empty($p_size_fld)){
								if(isset($v_attributes['attribute_pa_'.$p_size_fld])){
									$size_fld_k = 'attribute_pa_'.$p_size_fld;
								}elseif(isset($v_attributes['attribute_'.$p_size_fld])){
									$size_fld_k = 'attribute_'.$p_size_fld;
								}elseif(isset($v_attributes['pa_'.$p_size_fld])){
									$size_fld_k = 'pa_'.$p_size_fld;
								}elseif(isset($v_attributes[$p_size_fld])){
									$size_fld_k = $p_size_fld;
								}else{
									$size_fld_k = '';
								}
								
								if(!empty($size_fld_k)){
									if(!empty($v_attributes[$size_fld_k])){
										$Size_xml = '<Size>'.$v_attributes[$size_fld_k].'</Size>';
									}
								}
							}
							
						}
					}
				}
				
				$qbxml_file = 'add-inventory';
				$qbxml_template_path = plugin_dir_path( __FILE__ ) . 'qbxml-templates'. DIRECTORY_SEPARATOR . $qbxml_file. '.php';
				if(file_exists($qbxml_template_path)){
					$qbxml = include( $qbxml_template_path );
					$qbxml = $this->format_xml($qbxml);
					//$qbxml = $this->formatXmlString($qbxml);
					return $qbxml;
				}
			}
		}
	}
		
	public function GetInventoryAdjustmentAddQbxml($id,$is_variation=0){
		if($this->is_qwc_connected()){
			if($is_variation){
				$product_data = $this->get_wc_variation_info($id);
			}else{
				$product_data = $this->get_wc_product_info($id);
			}
			
			if(is_array($product_data) && count($product_data)){
				$quickbook_product_id = $this->if_qbo_product_exists($product_data,true);
				if(!empty($quickbook_product_id)){
					$InventoryAdjustment = new QuickBooks_QBXML_Object_InventoryAdjustment();
					
					$_stock = $this->get_array_isset($product_data,'_stock',0,true);
					if($_stock==''){$_stock=0;}
					
					$qbo_product_account_asset = $this->get_option('mw_wc_qbo_desk_default_qbo_asset_account');
					$InventoryAdjustment->setAccountListID($qbo_product_account_asset);
					
					$InventoryAdjustmentLine = new QuickBooks_QBXML_Object_InventoryAdjustment_InventoryAdjustmentLine();
					$InventoryAdjustmentLine->setLineItemListID($quickbook_product_id);
					$InventoryAdjustmentLine->setLineQuantityNew($_stock);
					
					$InventoryAdjustment->addInventoryAdjustmentLine($InventoryAdjustmentLine);
					
					$qbxml = $InventoryAdjustment->asQBXML('InventoryAdjustmentAdd',null,$this->get_qbxml_locale());
					$qbxml = str_replace('<NewQuantity></NewQuantity>','<NewQuantity>0</NewQuantity>',$qbxml);
					$qbxml = $this->get_qbxml_prefix('13.0').$qbxml. $this->get_qbxml_suffix();
					return $qbxml;
				}				
			}
		}
	}
	
	/*Sync Functions*/
	
	public function AddInventoryItemRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$is_variation = $this->get_array_isset($extra,'is_variation',0,true);
		$req_qf_data = array();
		$req_qf_data['requestID'] = $requestID;
		$qbxml = $this->GetProductQbxml($ID,'Inventory',$is_variation,'','',$req_qf_data);
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			if($is_variation){
				$dlog_txt = PHP_EOL .'Product Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}else{
				$dlog_txt = PHP_EOL .'Variation Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		
		return $qbxml;
	}
	
	public function AddNonInventoryRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$is_variation = $this->get_array_isset($extra,'is_variation',0,true);
		$req_qf_data = array();
		$req_qf_data['requestID'] = $requestID;
		$qbxml = $this->GetProductQbxml($ID,'NonInventory',$is_variation,'','',$req_qf_data);
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			if($is_variation){
				$dlog_txt = PHP_EOL .'Product Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}else{
				$dlog_txt = PHP_EOL .'Variation Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}			
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}
	
	public function AddServiceItemRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$is_variation = $this->get_array_isset($extra,'is_variation',0,true);
		$req_qf_data = array();
		$req_qf_data['requestID'] = $requestID;
		$qbxml = $this->GetProductQbxml($ID,'Service',$is_variation,'','',$req_qf_data);
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			if($is_variation){
				$dlog_txt = PHP_EOL .'Product Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}else{
				$dlog_txt = PHP_EOL .'Variation Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}
	
	public function AddInventoryItemResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$this->AddProductResponse($requestID, $user, $action, $ID, $extra, $err, $last_action_time, $last_actionident_time, $xml, $idents);
		return true;
	}
	
	public function AddNonInventoryResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$this->AddProductResponse($requestID, $user, $action, $ID, $extra, $err, $last_action_time, $last_actionident_time, $xml, $idents);
		return true;
	}
	
	public function AddServiceItemResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$this->AddProductResponse($requestID, $user, $action, $ID, $extra, $err, $last_action_time, $last_actionident_time, $xml, $idents);
		return true;
	}
	
	public function AddProductResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));
		$is_variation = $this->get_array_isset($extra,'is_variation',0,true);
		
		if(is_array($idents) && isset($idents['ListID']) && $idents['ListID']!=''){
			if($is_variation){
				$this->save_data_pair('Variation',$ID,$idents['ListID']);
			}else{
				$this->save_data_pair('Product',$ID,$idents['ListID']);
			}
			$lg_type = ($is_variation)?'Variation':'Product';
			
			$this->save_item_map($ID,$idents['ListID'],$is_variation);
			$this->save_qbo_item_local($idents['ListID'],$ID,$is_variation);
			
			/**/
			if($this->option_checked('mw_wc_qbo_desk_product_img_pull_push_ed') && !empty($this->get_post_img_data_by_id($ID))){
				$extra['ListID'] = $idents['ListID'];
				$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
				$Queue->enqueue('POS_P_IMG_ADD', $ID,$ID,$extra,$this->get_qbun());
			}
			
			$details = "{$lg_type} #{$ID} added into quickbooks successfully".PHP_EOL;
			$details.="QuickBooks List ID #".$idents['ListID'];
			$this->save_log(array('log_type'=>$lg_type,'log_title'=>'Export '.$lg_type.' #'.$ID,'details'=>$details,'status'=>1),true);
		}else{
			$details = "Error:$err";
			$this->save_log(array('log_type'=>$lg_type,'log_title'=>'Export '.$lg_type.' Error #'.$ID,'details'=>$details,'status'=>0),true);
		}
		return true;
	}
	
	/**/
	public function PosProductImgAddRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$is_variation = $this->get_array_isset($extra,'is_variation',0,true);
		$ListID = $this->get_array_isset($extra,'ListID','',true);
		$img_data = $this->get_post_img_data_by_id($ID);
		
		if(empty($ListID)){
			return false;
		}
		
		$EncodedPicture = '';
		$PictureName = '';
		
		if(!empty($img_data)){
			$wp_f_img = $img_data[0];
			$EncodedPicture = $this->img_to_base64($wp_f_img);
			//$PictureName = pathinfo($wp_f_img, PATHINFO_BASENAME);			
			$PictureName = pathinfo($wp_f_img, PATHINFO_FILENAME);			
		}
		
		if(empty($EncodedPicture)){
			return false;
		}
		
		$q = '
			<ItemInventoryPicturesModRq  requestID="' . $requestID . '">
				<ItemInventoryPicturesMod>
					<ListID >'.$ListID.'</ListID>
					<ItemInventoryPicture>
						<EncodedPicture>'.$EncodedPicture.'</EncodedPicture>
						<PictureName>'.$PictureName.'</PictureName>
					</ItemInventoryPicture>
				</ItemInventoryPicturesMod>
			</ItemInventoryPicturesModRq>
		';
		
		$qbxml = $this->get_qbxml_prefix().$q. $this->get_qbxml_suffix();
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			if($is_variation){
				$dlog_txt = PHP_EOL .'Variation Image Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}else{
				$dlog_txt = PHP_EOL .'Product Image Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}
			
			$dlog_txt.=$qbxml;
			//$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}
	
	public function PosProductImgPullRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$is_variation = $this->get_array_isset($extra,'is_variation',0,true);
		$ListID = $this->get_array_isset($extra,'ListID','',true);
		$img_data = $this->get_post_img_data_by_id($ID);
		
		if(empty($ListID)){
			return false;
		}
		
		// Build the request
		$qbxml = '<?xml version="1.0" encoding="utf-8"?>
				<?qbposxml version="' . $version . '"?>
				<QBPOSXML>
					<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
						<ItemInventoryPicturesQueryRq requestID="' . $requestID . '">							
							<OwnerID>0</OwnerID>
							<ListID >'.$ListID.'</ListID>
						</ItemInventoryPicturesQueryRq>
					</QBPOSXMLMsgsRq>
				</QBPOSXML>';
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'POS Image Pull Request For WooCommerce Product #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$qbxml;
			//$this->add_test_log($dlog_txt);
		}
		
		return $qbxml;
	}
	
	public function PosProductImgAddResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}		
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));
		
		return true;
	}
	
	/**/
	public function PosProductImgPullResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}		
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));
		
		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);
		
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/ItemInventoryPicturesQueryRs');
			
			$EncodedPicture = '';
			$PictureName = '';
			$ListID = '';
			
			foreach ($List->children() as $Item){
				$ret = $Item->name();
				/*
				foreach ($Item->children() as $Item_C){
					if($Item_C->name() == 'ItemInventoryPicture'){}
				}
				*/
				
				$ListID = $Item->getChildDataAt($ret.' ListID');
				
				$EncodedPicture = $Item->getChildDataAt($ret.' ItemInventoryPicture EncodedPicture');
				$PictureName = $Item->getChildDataAt($ret.' ItemInventoryPicture PictureName');
				
				break;
			}
			
			if(empty($PictureName)){
				$PictureName = 'Pos_'.$ID;
			}
			
			if(!empty($EncodedPicture) && !empty($PictureName) && !empty($ListID) && $ID > 0){
				$is_product_update = (is_array($extra) && isset($extra['is_product_update']))?$extra['is_product_update']:false;
				$return = $this->Qbd_pull_product_image($ID,$ListID,$EncodedPicture,$PictureName,$is_product_update);
			}
		}
		
		return true;
	}
	
	public function InventoryAdjustmentAddRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$is_variation = $this->get_array_isset($extra,'is_variation',0,true);
		$qbxml = $this->GetInventoryAdjustmentAddQbxml($ID,$is_variation);
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			if($is_variation){
				$dlog_txt = PHP_EOL .'Variation Inventiory Update Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}else{
				$dlog_txt = PHP_EOL .'Inventiory Update Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			}
			
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}
	
	public function InventoryAdjustmentAddResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}		
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));
		
		if(is_array($idents) && isset($idents['ListID']) && $idents['ListID']!=''){
			$is_variation = $this->get_array_isset($extra,'is_variation',0,true);
			$ext_lt = ($is_variation)?'Variation ':'';
			
			$details = "{$ext_lt}Inventory #{$ID} updated into quickbooks successfully".PHP_EOL;
			$details.="QuickBooks List ID #".$idents['ListID'];
			$this->save_log(array('log_type'=>'Inventory','log_title'=>'Update '.$ext_lt.'Inventory #'.$ID,'details'=>$details,'status'=>1),true);
		}else{
			$details = "Error:$err";
			$this->save_log(array('log_type'=>'Inventory','log_title'=>'Update '.$ext_lt.'Inventory Error #'.$ID,'details'=>$details,'status'=>0),true);
		}
		return true;
	}
	
	/**/
	public function UpdateCustomerRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$EditSequence = '';
		$ListID = '';		
		if(is_array($extra) && !empty($extra) && isset($extra['EditSequence'])  && isset($extra['ListID'])){
			$EditSequence = $extra['EditSequence'];
			$ListID = $extra['ListID'];
		}
		
		if(empty($EditSequence) || empty($ListID)){
			return false;
		}
		
		$qbxml = $this->GetCustomerQbxml($ID,false,$EditSequence,$ListID);
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'Customer Update Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}
	
	public function AddCustomerRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$qbxml = $this->GetCustomerQbxml($ID);
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'Customer Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}
	
	public function UpdateCustomerResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		if(is_array($idents) && isset($idents['ListID']) && $idents['ListID']!=''){
			//$this->save_data_pair('Customer',$ID,$idents['ListID']);
			//$this->save_customer_map($ID,$idents['ListID']);
			$this->save_qbo_customer_local($idents['ListID'],$ID);
			$details = "Customer #{$ID} updated into quickbooks successfully".PHP_EOL;
			$details.="QuickBooks List ID #".$idents['ListID'];
			$this->save_log(array('log_type'=>'Customer','log_title'=>'Update Customer #'.$ID,'details'=>$details,'status'=>1),true);
		}else{
			$details = "Error:$err";
			$this->save_log(array('log_type'=>'Customer','log_title'=>'Update Customer Error #'.$ID,'details'=>$details,'status'=>0),true);
		}
		return true;
		
	}
	
	public function AddCustomerResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));

		if(is_array($idents) && isset($idents['ListID']) && $idents['ListID']!=''){
			$this->save_data_pair('Customer',$ID,$idents['ListID']);
			$this->save_customer_map($ID,$idents['ListID']);
			$this->save_qbo_customer_local($idents['ListID'],$ID);
			$details = "Customer #{$ID} added into quickbooks successfully".PHP_EOL;
			$details.="QuickBooks List ID #".$idents['ListID'];
			$this->save_log(array('log_type'=>'Customer','log_title'=>'Export Customer #'.$ID,'details'=>$details,'status'=>1),true);
		}else{
			$details = "Error:$err";
			$this->save_log(array('log_type'=>'Customer','log_title'=>'Export Customer Error #'.$ID,'details'=>$details,'status'=>0),true);
		}
		return true;
	}

	public function AddGuestRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$qbxml = $this->GetCustomerQbxml($ID,true);
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'Customer/Guest Add Request Order #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}

	public function AddGuestResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));

		if(is_array($idents) && isset($idents['ListID']) && $idents['ListID']!=''){
			$customer_data = $this->get_wc_customer_info_from_order($ID);
			$this->save_qbo_customer_local($idents['ListID'],null,$customer_data);

			$details = "Customer added into quickbooks successfully".PHP_EOL;
			$details.="QuickBooks List ID #".$idents['ListID'].PHP_EOL;
			$details.="Order ID #{$ID}";
			$this->save_log(array('log_type'=>'Customer','log_title'=>'Export Guest/Customer','details'=>$details,'status'=>1),true);
		}else{
			$details = "Error:$err".PHP_EOL;
			$details.="Order ID #{$ID}";
			$this->save_log(array('log_type'=>'Customer','log_title'=>'Export Guest/Customer Error','details'=>$details,'status'=>0),true);
		}
		return true;
	}
	
	public function AddSalesReceiptRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$qbxml = $this->GetSalesReceiptQbxml($ID,$extra);
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'SalesReceipt Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}
	
	public function AddSalesOrderRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$qbxml = $this->GetSalesOrderQbxml($ID,$extra);
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'SalesOrder Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}
	
	public function ModSalesOrderRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$allow_update = false;
		if(is_array($extra) && isset($extra['TxnID']) && !empty($extra['TxnID'])){
			$allow_update = true;
			$extra['is_update'] = true;
		}
		
		if(!$allow_update){
			return false;
		}
		
		$qbxml = $this->GetSalesOrderQbxml($ID,$extra);
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'SalesOrder Update Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}	
	
	public function AddPurchaseOrderRequest($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$qbxml = $this->GetPurchaseOrderQbxml($ID);
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'PurchaseOrder Add Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$qbxml;
			$this->add_test_log($dlog_txt);
		}
		return $qbxml;
	}
	
	/**/
	private function Wc_Order_Status_Update_After_Sync($order_id,$status=''){
		$order_id = (int) $order_id;
		$oaqs_status = $this->get_option('mw_wc_qbo_desk_order_status_after_qbd_sync');
		if($order_id >0 && !empty($oaqs_status)){
			$_order = new WC_Order( $order_id );
			if (!empty($_order)) {
				$_order->update_status($oaqs_status);
			}			
		}
	}	
	
	public function AddSalesReceiptResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));
		
		if(is_array($idents) && isset($idents['TxnID']) && $idents['TxnID']!=''){
			/**/
			$dp_ed_arr = array();
			$errnum = 0;
			$errmsg = '';
			$Parser = new QuickBooks_XML_Parser($xml);
			
			if ($Doc = $Parser->parse($errnum, $errmsg)){
				$Root = $Doc->getRoot();
				$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/SalesReceiptAddRs');
				
				foreach ($List->children() as $Item){
					$dp_ed_arr = array(
					'TxnID' => $Item->getChildDataAt('SalesReceiptRet TxnID'),
					'TimeCreated' => $Item->getChildDataAt('SalesReceiptRet TimeCreated'),
					'SalesReceiptNumber'=>$Item->getChildDataAt('SalesReceiptRet SalesReceiptNumber'),
					'TxnDate'=>$Item->getChildDataAt('SalesReceiptRet TxnDate')
					);
				}
			}
			
			$this->save_data_pair('Order',$ID,$idents['TxnID'],$dp_ed_arr);
			$details = "Order #{$ID} added into quickbooks successfully".PHP_EOL;
			$details.="QuickBooks TxnID #".$idents['TxnID'];
			$this->save_log(array('log_type'=>'Order','log_title'=>'Export Order #'.$ID,'details'=>$details,'status'=>1),true);
			
			/*Wc Order Status Update*/
			$this->Wc_Order_Status_Update_After_Sync($ID);
			
		}else{
			$details = "Error:$err";
			$this->save_log(array('log_type'=>'Order','log_title'=>'Export Order Error #'.$ID,'details'=>$details,'status'=>0),true);
		}
		return true;
	}
	
	public function AddSalesOrderResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));

		if(is_array($idents) && isset($idents['TxnID']) && $idents['TxnID']!=''){
			/**/
			$dp_ed_arr = array();
			$errnum = 0;
			$errmsg = '';
			$Parser = new QuickBooks_XML_Parser($xml);
			
			if ($Doc = $Parser->parse($errnum, $errmsg)){
				$Root = $Doc->getRoot();
				$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/SalesOrderAddRs');
				
				foreach ($List->children() as $Item){
					$dp_ed_arr = array(
					'TxnID' => $Item->getChildDataAt('SalesOrderRet TxnID'),
					'TimeCreated' => $Item->getChildDataAt('SalesOrderRet TimeCreated'),
					'SalesOrderNumber'=>$Item->getChildDataAt('SalesOrderRet SalesOrderNumber'),
					'TxnDate'=>$Item->getChildDataAt('SalesOrderRet TxnDate')
					);
				}
			}
			
			$this->save_data_pair('Order',$ID,$idents['TxnID'],$dp_ed_arr);
			$details = "Order #{$ID} added into quickbooks successfully".PHP_EOL;
			$details.="QuickBooks TxnID #".$idents['TxnID'];
			$this->save_log(array('log_type'=>'Order','log_title'=>'Export Order #'.$ID,'details'=>$details,'status'=>1),true);
			
			/*Wc Order Status Update*/
			$this->Wc_Order_Status_Update_After_Sync($ID);			
			
		}else{
			$details = "Error:$err";
			$this->save_log(array('log_type'=>'Order','log_title'=>'Export Order Error #'.$ID,'details'=>$details,'status'=>0),true);
		}
		return true;
	}
	
	public function ModSalesOrderResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));
		
		if(is_array($idents) && isset($idents['TxnID']) && $idents['TxnID']!=''){
			/**/
			$dp_ed_arr = array();
			$errnum = 0;
			$errmsg = '';
			$Parser = new QuickBooks_XML_Parser($xml);
			
			if ($Doc = $Parser->parse($errnum, $errmsg)){
				$Root = $Doc->getRoot();
				$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/SalesOrderModRs');
				
				foreach ($List->children() as $Item){
					$dp_ed_arr = array(
					'TxnID' => $Item->getChildDataAt('SalesOrderRet TxnID'),
					'TimeCreated' => $Item->getChildDataAt('SalesOrderRet TimeCreated'),
					'TimeModified' => $Item->getChildDataAt('SalesOrderRet TimeModified'),
					'SalesOrderNumber'=>$Item->getChildDataAt('SalesOrderRet SalesOrderNumber'),
					'TxnDate'=>$Item->getChildDataAt('SalesOrderRet TxnDate')
					);
				}
			}
			
			$this->save_data_pair('Order',$ID,$idents['TxnID'],$dp_ed_arr);
			$details = "Order #{$ID} updated into quickbooks successfully".PHP_EOL;
			$details.="QuickBooks TxnID #".$idents['TxnID'];
			$this->save_log(array('log_type'=>'Order','log_title'=>'Update Order #'.$ID,'details'=>$details,'status'=>1),true);
			
			/*Wc Order Status Update*/
			//$this->Wc_Order_Status_Update_After_Sync($ID);			
			
		}else{
			$details = "Error:$err";
			$this->save_log(array('log_type'=>'Order','log_title'=>'Update Order Error #'.$ID,'details'=>$details,'status'=>0),true);
		}
		return true;
	}
	
	
	public function AddPurchaseOrderResponse($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));

		if(is_array($idents) && isset($idents['TxnID']) && $idents['TxnID']!=''){
			$this->save_data_pair('PurchaseOrder',$ID,$idents['TxnID']);
			$details = "PurchaseOrder #{$ID} added into quickbooks successfully".PHP_EOL;
			$details.="QuickBooks TxnID #".$idents['TxnID'];
			$this->save_log(array('log_type'=>'PurchaseOrder','log_title'=>'Export PurchaseOrder #'.$ID,'details'=>$details,'status'=>1),true);
		}else{
			$details = "Error:$err";
			$this->save_log(array('log_type'=>'PurchaseOrder','log_title'=>'Export PurchaseOrder Error #'.$ID,'details'=>$details,'status'=>0),true);
		}
		return true;
	}

	/*Errors And Hooks Function Start*/
	public function Qwc_Catch_All_Errors($requestID, $user, $action, $ID, $extra, &$err, $xml, $errnum, $errmsg){
		//$this->add_test_log($errmsg);
		$log_type = '';$log_status = 0;$log_title = '';$details = '';
		$is_log_error = true;
		
		if(empty($action) || $action == 'DEBUG_QUEUE' || $action == 'CustomerImport_ByName' || $action == 'GuestImport_ByName'){
			$is_log_error = false;
		}
		
		/**/
		$aqrdnf_err = false;
		if($action =='RECENT_PRODUCT_PULL' || $action == 'RECENT_PRODUCT_PULL_U' || $action == 'New_ItemImport' || $action == 'New_CustomerImport'){
			$aqrdnf_err = true;
		}
		
		if($aqrdnf_err && $errnum==1){
			if($this->start_with($errmsg,'A query request did not find')){
				$is_log_error = false;
			}
		}
		
		if(!$is_log_error){
			return true;
		}
		
		switch ($action) {
			case "InvoiceAdd":
				$log_type = 'Order';
				$log_title = 'Export Order Error #'.$ID;
				break;
			case "SalesReceiptAdd":
				$log_type = 'Order';
				$log_title = 'Export Order Error #'.$ID;
				break;
				
			case "SalesOrderAdd":
				$log_type = 'Order';
				$log_title = 'Export Order Error #'.$ID;
				break;
				
			case "EstimateAdd":
				$log_type = 'Order';
				$log_title = 'Export Order Error #'.$ID;
				break;				
				
			case "CustomerAdd":
				$log_type = 'Customer';
				$log_title = 'Export Customer Error #'.$ID;
				break;
			case "CustomerMod":
				$log_type = 'Customer';
				$log_title = 'Update Customer Error #'.$ID;
				break;
				
			case "ItemInventoryAdd":
				$log_type = 'Product';
				$log_title = 'Export Product Error #'.$ID;
				break;
				
			case "ItemNonInventoryAdd":
				$log_type = 'Product';
				$log_title = 'Export Product Error #'.$ID;
				break;
			
			case "ItemServiceAdd":
				$log_type = 'Product';
				$log_title = 'Export Product Error #'.$ID;
				break;
				
			case "ReceivePaymentAdd":
				$log_type = 'Payment';
				$log_title = 'Export Payment Error #'.$ID;
				break;
				
			case "ItemInventoryMod":
				$log_type = 'Inventory';
				$log_title = 'Update Inventory Error #'.$ID;
				break;
			
			/*Import Errors*/
			
			case "CustomerImport":
				$log_type = 'Customer';
				$log_title = 'Recognized Customer Error';
				break;
			case "ItemImport":
				$log_type = 'Product';
				$log_title = 'Recognized Product Error';
				break;
			case "AccountImport":
				$log_type = 'Account';
				$log_title = 'Recognized Account Error';
				break;
			case "TermsImport":
				$log_type = 'Terms';
				$log_title = 'Recognized Terms Error';
				break;
			case "SalesTaxCodeImport":
				$log_type = 'SalesTaxCode';
				$log_title = 'Recognized SalesTaxCode Error';
				break;
			case "ClassImport":
				$log_type = 'Class';
				$log_title = 'Recognized Class Error';
				break;
			case "PaymentMethodImport":
				$log_type = 'PaymentMethod';
				$log_title = 'Recognized PaymentMethod Error';
				break;			
			case "ShipMethodImport":
				$log_type = 'ShipMethod';
				$log_title = 'Recognized ShipMethod Error';
				break;
			case "AUTO_WC_UPDATE_INVENTORY":
				$log_type = 'InventoryPull';
				$log_title = 'Auto Import Inventory Error';
				break;
			case "ALL_WC_UPDATE_INVENTORY":
				$log_type = 'InventoryPull';
				$log_title = 'Auto Import Inventory Error';
				break;
			case "ALL_WC_UPDATE_INVENTORY_A":
				$log_type = 'InventoryPull';
				$log_title = 'Auto Import InventoryAssembly Error';
				break;				
			default:
				$log_type = 'Other';
				$log_title = $action.' Error';
		}

		$details.= "Error Number:{$errnum}".PHP_EOL;
		$details.= "Error:{$errmsg}";
		
		//
		if($log_type=='InventoryPull' && $errnum==1){
			if($this->start_with($errmsg,'A query request did not find')){
				$log_status = 2;
				if($action=='ALL_WC_UPDATE_INVENTORY_A'){
					$log_title = 'All Inventory Assembly products are up to date';
				}else{
					$log_title = 'All Inventory products are up to date';
				}
				
				$details = 'All Inventory levels are up to date';
			}
		}
		
		if($log_title!=''){
			/*
			if($action == QUICKBOOKS_IMPORT_ITEM){
				if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
					$dlog_txt = PHP_EOL .'Product Import Debug - '.$this->get_cdt(). PHP_EOL;
					$dlog_txt.=$xml;
					$this->add_test_log($dlog_txt);
				}
			}
			*/
			
			$this->save_log(array('log_type'=>$log_type,'log_title'=>$log_title,'details'=>$details,'status'=>$log_status),true);
		}
		return true;
	}
	
	/*Auto Queue Add*/
	public function Hook_Login_Success($requestID, $user, $hook, &$err, $hook_data, $callback_config){
		if(!$this->is_qwc_connected()){
			return false;
		}

		$this->save_log(array('log_type'=>'Web Connector','log_title'=>'Web Connector Login Success','details'=>'New Web Connector Request Authenticated Successfully','status'=>1));

		//QuickBooks_Utilities::log($this->dsn, 'User logged in: ' . $user . ', params: ' . print_r($hook_data, true));		

		$qbd_import = false;$extra_import = false;

		if($this->option_checked('mw_wc_qbo_desk_cp_refresh_data_enable')){
			$qbd_import = true;
			$extra_import = true;
		}

		if($this->option_checked('mw_wc_qbo_desk_oth_refresh_data_enable')){
			//$extra_import = true;
		}
		
		if($qbd_import || $extra_import || $this->option_checked('mw_wc_qbo_desk_rt_pull_enable') || $this->debug_queue || $this->option_checked('mw_wc_qbo_desk_auto_refresh_new_cust_prod')){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			//$Queue = new QuickBooks_WebConnector_Queue($this->get_dsn());
			$date = date('Y-m-d H:i:s');
		}
		
		if($this->debug_queue){
			if(!$this->if_queue_exists('DEBUG_QUEUE')){
				$Queue->enqueue('DEBUG_QUEUE', null, 0,null,$this->get_qbun());
			}			
		}
		
		$import_queue_added = false;
		
		if($qbd_import){
			$import_queue_added = true;
			
			if($this->check_refresh_data_enabled_by_item('customer') && !$this->if_queue_exists(QUICKBOOKS_IMPORT_CUSTOMER)){
				if (!$this->_quickbooks_get_last_run($user, QUICKBOOKS_IMPORT_CUSTOMER)){
					$this->_quickbooks_set_last_run($user, QUICKBOOKS_IMPORT_CUSTOMER, $date);
				}
				$Queue->enqueue(QUICKBOOKS_IMPORT_CUSTOMER, null, QB_PRIORITY_REFRESH_DATA_IMPORT,null,$this->get_qbun());
			}
			
			if($this->check_refresh_data_enabled_by_item('product')){
				$rdprdopt_s_departments = $this->get_option('mw_wc_qbo_desk_rdprdopt_s_departments');
				if(!empty($rdprdopt_s_departments)){$rdprdopt_s_departments = explode(',',$rdprdopt_s_departments);}
				
				if(is_array($rdprdopt_s_departments) && !empty($rdprdopt_s_departments)){
					foreach($rdprdopt_s_departments as $department){
						if(!$this->if_queue_exists(QUICKBOOKS_IMPORT_ITEM,0,'q',false,'D_ListId',$department)){
							if (!$this->_quickbooks_get_last_run($user, QUICKBOOKS_IMPORT_ITEM)){
								$this->_quickbooks_set_last_run($user, QUICKBOOKS_IMPORT_ITEM, $date);
							}
							
							$Queue->enqueue(QUICKBOOKS_IMPORT_ITEM, null, QB_PRIORITY_REFRESH_DATA_IMPORT,array('D_ListId'=>$department),$this->get_qbun());
						}
					}
				}else{
					if(!$this->if_queue_exists(QUICKBOOKS_IMPORT_ITEM)){
						if (!$this->_quickbooks_get_last_run($user, QUICKBOOKS_IMPORT_ITEM)){
							$this->_quickbooks_set_last_run($user, QUICKBOOKS_IMPORT_ITEM, $date);
						}
						$Queue->enqueue(QUICKBOOKS_IMPORT_ITEM, null, QB_PRIORITY_REFRESH_DATA_IMPORT,null,$this->get_qbun());
					}
				}
				
				
			}

		}
		
		if($extra_import){
			$import_queue_added = true;
			
			$priority = QB_PRIORITY_REFRESH_DATA_IMPORT;
			
			/*Preferences Import Queue*/
			if($this->check_refresh_data_enabled_by_item('preferences',true) && !$this->if_queue_exists(QUICKBOOKS_IMPORT_PREFERENCES)){				
				if(!$this->if_queue_exists(QUICKBOOKS_IMPORT_COMPANY)){
					$Queue->enqueue(QUICKBOOKS_IMPORT_COMPANY, null, $priority,null,$this->get_qbun());
				}				
			}
			
			/*Vendor Import Queue*/
			if($this->check_refresh_data_enabled_by_item('Vendor',true) && !$this->if_queue_exists(QUICKBOOKS_IMPORT_VENDOR)){
				if (!$this->_quickbooks_get_last_run($user, QUICKBOOKS_IMPORT_VENDOR)){
					$this->_quickbooks_set_last_run($user, QUICKBOOKS_IMPORT_VENDOR, $date);
				}
				$Queue->enqueue(QUICKBOOKS_IMPORT_VENDOR, null, $priority,null,$this->get_qbun());
			}
			
			/*Department Import Queue*/
			if($this->check_refresh_data_enabled_by_item('Department',true) && !$this->if_queue_exists(QUICKBOOKS_IMPORT_DEPARTMENT)){
				if (!$this->_quickbooks_get_last_run($user, QUICKBOOKS_IMPORT_DEPARTMENT)){
					$this->_quickbooks_set_last_run($user, QUICKBOOKS_IMPORT_DEPARTMENT, $date);
				}
				$Queue->enqueue(QUICKBOOKS_IMPORT_DEPARTMENT, null, $priority,null,$this->get_qbun());
			}
			
		}
		
		//Disable Refresh Data
		if($import_queue_added){
			/*
			$this->set_session_val('mw_wc_qbo_desk_cp_refresh_data_enable',true);
			$this->set_session_val('mw_wc_qbo_desk_oth_refresh_data_enable',true);
			
			update_option('mw_wc_qbo_desk_cp_refresh_data_enable','');
			update_option('mw_wc_qbo_desk_oth_refresh_data_enable','');
			*/
		}
		
		/*Auto Pull Queue*/
		
		if($this->option_checked('mw_wc_qbo_desk_rt_pull_enable')){
			$rt_pull_enb_itm_chk = false;
			$rt_force_all_pl_enb = true;
			if($this->check_if_real_time_pull_enable_for_item('inventory') || $this->check_if_real_time_pull_enable_for_item('pricing') || $this->check_if_real_time_pull_enable_for_item('product')){
				$rt_pull_enb_itm_chk = true;
			}
			
			if($rt_pull_enb_itm_chk){
				if($rt_force_all_pl_enb || $this->option_checked('mw_wc_qbo_desk_rt_all_invnt_pull')){					
					$mw_wc_qbo_desk_aipit_ldt = $this->get_option('mw_wc_qbo_desk_aipit_ldt');
					$st_kwd = '';					
					$aip_ti = $this->get_option('mw_wc_qbo_desk_all_invnt_pull_interver_time');
					$is_aip_aq = false;					
					if($aip_ti == 'i_e_r'){
						$is_aip_aq = true;
					}else{
						if($aip_ti == 'e_30_m'){
							$st_kwd = '30 minutes';
						}
						
						if($aip_ti == 'e_1_h'){
							$st_kwd = '1 hour';
						}
						
						if($aip_ti == 'e_2_h'){
							$st_kwd = '2 hours';
						}
					}
					
					if(!$is_aip_aq){
						if($st_kwd!=''){
							$prev_time = strtotime("-{$st_kwd}");
							if(empty($mw_wc_qbo_desk_aipit_ldt)){
								$mw_wc_qbo_desk_aipit_ldt = date('Y-m-d H:i:s',$prev_time);
							}
							
							if(strtotime($mw_wc_qbo_desk_aipit_ldt) <= $prev_time) {
								$is_aip_aq = true;
								$s_dt = date('Y-m-d H:i:s');
								update_option('mw_wc_qbo_desk_aipit_ldt',$s_dt);
							}
						}						
					}
					
					if($is_aip_aq){
						if($this->check_if_real_time_pull_enable_for_item('inventory')){
							if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync') && $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_sites_for_invnt_pull')!=''){
								//
							}else{
								/**/
								$awui_q_added = false;
								$ip_depts = $this->get_option('mw_wc_qbo_desk_invt_pull_qb_departments');
								if(!empty($ip_depts)){
									$ip_depts = explode(',',$ip_depts);
									if(is_array($ip_depts) && !empty($ip_depts)){
										foreach($ip_depts as $department){
											if(!$this->if_queue_exists('ALL_WC_UPDATE_INVENTORY',0,'q',false,'D_ListId',$department)){
												if (!$this->_quickbooks_get_last_run($user, 'ALL_WC_UPDATE_INVENTORY')){
													$this->_quickbooks_set_last_run($user, 'ALL_WC_UPDATE_INVENTORY', $date);
												}
												
												$Queue->enqueue('ALL_WC_UPDATE_INVENTORY', null, 0,array('D_ListId'=>$department),$this->get_qbun());
												$awui_q_added = true;
											}											
										}
									}
								}
								
								if(!$awui_q_added && empty($ip_depts)){
									if(!$this->if_queue_exists('ALL_WC_UPDATE_INVENTORY')){
										if (!$this->_quickbooks_get_last_run($user, 'ALL_WC_UPDATE_INVENTORY')){
											$this->_quickbooks_set_last_run($user, 'ALL_WC_UPDATE_INVENTORY', $date);
										}
										$Queue->enqueue('ALL_WC_UPDATE_INVENTORY', null, 0,null,$this->get_qbun());
									}
								}																
							}
						}
						
						/**/
						if($this->check_if_real_time_pull_enable_for_item('pricing') && !$this->if_queue_exists('ALL_WC_UPDATE_PRICING')){
							if (!$this->_quickbooks_get_last_run($user, 'ALL_WC_UPDATE_PRICING')){
								$this->_quickbooks_set_last_run($user, 'ALL_WC_UPDATE_PRICING', $date);
							}
							$Queue->enqueue('ALL_WC_UPDATE_PRICING', null, 0,null,$this->get_qbun());
						}						
					}
				}else{
					if($this->check_if_real_time_pull_enable_for_item('inventory') && !$this->if_queue_exists('AUTO_WC_UPDATE_INVENTORY')){
						/*
						if (!$this->_quickbooks_get_last_run($user, 'AUTO_WC_UPDATE_INVENTORY')){
							$this->_quickbooks_set_last_run($user, 'AUTO_WC_UPDATE_INVENTORY', $date);
						}
						$Queue->enqueue('AUTO_WC_UPDATE_INVENTORY', null, 0,null,$this->get_qbun());
						*/
					}					
				}
				
				/**/				
				if($this->check_if_real_time_pull_enable_for_item('product') && !$this->if_queue_exists('RECENT_PRODUCT_PULL')){
					if (!$this->_quickbooks_get_last_run($user, 'RECENT_PRODUCT_PULL')){
						$this->_quickbooks_set_last_run($user, 'RECENT_PRODUCT_PULL', $date);
					}
					$Queue->enqueue('RECENT_PRODUCT_PULL', null, 0,null,$this->get_qbun());
				}
				
				if($this->check_if_real_time_pull_enable_for_item('product_update') && !$this->if_queue_exists('RECENT_PRODUCT_PULL_U')){
					if (!$this->_quickbooks_get_last_run($user, 'RECENT_PRODUCT_PULL_U')){
						$this->_quickbooks_set_last_run($user, 'RECENT_PRODUCT_PULL_U', $date);
					}
					$Queue->enqueue('RECENT_PRODUCT_PULL_U', null, 0,array('is_product_update'=>1),$this->get_qbun());
				}
			}
		}
		
		/**/
		if($this->option_checked('mw_wc_qbo_desk_auto_refresh_new_cust_prod')){
			global $wpdb;
			$time_zone = $this->get_qbd_timezone();
			//2nd last
			$dq = "SELECT `added_date` FROM {$wpdb->prefix}mw_wc_qbo_desk_qbd_log  WHERE `log_title` = 'Web Connector Login Success' AND `log_type` = 'Web Connector' ORDER BY `id` DESC LIMIT 1,1 ";
			$datetime = $wpdb->get_var($dq);			
			$datetime = $this->convert_dt_timezone($datetime,$time_zone);
			$timestamp_from = date('Y-m-d', strtotime($datetime)) . 'T' . date('H:i:s', strtotime($datetime));
			
			if(!empty($timestamp_from)){
				if(!$this->if_queue_exists('New_'.QUICKBOOKS_IMPORT_CUSTOMER)){
					if (!$this->_quickbooks_get_last_run($user, 'New_'.QUICKBOOKS_IMPORT_CUSTOMER)){
						$this->_quickbooks_set_last_run($user, 'New_'.QUICKBOOKS_IMPORT_CUSTOMER, $date);
					}
					
					$Queue->enqueue('New_'.QUICKBOOKS_IMPORT_CUSTOMER, null, QB_PRIORITY_REFRESH_DATA_IMPORT,array('new'=>true, 'timestamp_from'=>$timestamp_from),$this->get_qbun());
				}
				
				if(!$this->if_queue_exists('New_'.QUICKBOOKS_IMPORT_ITEM)){
					if (!$this->_quickbooks_get_last_run($user, 'New_'.QUICKBOOKS_IMPORT_ITEM)){
						$this->_quickbooks_set_last_run($user, 'New_'.QUICKBOOKS_IMPORT_ITEM, $date);
					}
					
					$Queue->enqueue('New_'.QUICKBOOKS_IMPORT_ITEM, null, QB_PRIORITY_REFRESH_DATA_IMPORT,array('new'=>true, 'timestamp_from'=>$timestamp_from),$this->get_qbun());
				}
			}			
		}
		
	}
	/*Errors And Hooks Function End*/
	
	/*Pull Functions Start*/
	
	public function Pull_Update_Wc_Product_Price_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<ItemQueryRq  requestID="' . $requestID . '">			
						<ListID >'.$ID.'</ListID>
						<OwnerID>0</OwnerID>
					</ItemQueryRq>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';		
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'Product Price Import Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			//$this->add_test_log($dlog_txt);
		}
		
		return $xml;
	}
	
	public function All_Pull_Update_Wc_Inventory_A_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		if (empty($extra['iteratorID'])){
			$last = $this->_quickbooks_get_last_run($user, $action);
			$this->_quickbooks_set_last_run($user, $action);
			$this->_quickbooks_set_current_run($user, $action, $last);
		}else{
			$attr_iteratorID = ' iteratorID="' . $extra['iteratorID'] . '" ';
			$attr_iterator = ' iterator="Continue" ';

			$last = $this->_quickbooks_get_current_run($user, $action);
		}
		
		$it_q_req = 'ItemInventoryAssemblyQueryRq';
		$dl_it = 'InventoryAssembly';
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<'.$it_q_req.' '.$attr_iterator.' '.$attr_iteratorID.'  requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>
						<OwnerID>0</OwnerID>
					</'.$it_q_req.'>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';		
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .''.$dl_it.' Import Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			//$this->add_test_log($dlog_txt);
		}
		
		return $xml;
	}
	
	/**/
	public function Product_Pull_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		
		$it_q_req = 'ItemInventoryQueryRq';
		$dl_it = 'Product';
		
		$iref_xml = $this->get_ii_ire_f_xml(true);
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<'.$it_q_req.' '.$attr_iterator.' '.$attr_iteratorID.'  requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>
						<ListID >'.$ID.'</ListID>
						<OwnerID>0</OwnerID>
						'.$iref_xml.'
					</'.$it_q_req.'>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';		
		
			
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .''.$dl_it.' Pull Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			//$this->add_test_log($dlog_txt);
		}
		
		return $xml;
	}
	
	/**/
	public function Recent_Product_Pull_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		if (empty($extra['iteratorID'])){
			$last = $this->_quickbooks_get_last_run($user, $action);
			$this->_quickbooks_set_last_run($user, $action);
			$this->_quickbooks_set_current_run($user, $action, $last);
		}else{
			$attr_iteratorID = ' iteratorID="' . $extra['iteratorID'] . '" ';
			$attr_iterator = ' iterator="Continue" ';

			$last = $this->_quickbooks_get_current_run($user, $action);
		}
		
		$is_product_update = (is_array($extra) && isset($extra['is_product_update']))?true:false;
		
		$timestamp_from = $this->get_prd_pull_m_dt_from($this->get_qbd_timezone(),$is_product_update);
		
		$time_zone = $this->get_qbd_timezone();
		$now = new DateTime(null, new DateTimeZone($time_zone));
		$datetime = $now->format('Y-m-d H:i:s');
		$timestamp_to = date('Y-m-d', strtotime($datetime)) . 'T' . date('H:i:s', strtotime($datetime));		
		
		$it_q_req = 'ItemInventoryQueryRq';
		$dl_it = 'Product';
		
		$iref_xml = $this->get_ii_ire_f_xml(true);
		
		$TimeCreatedRangeFilter = '
			<TimeCreatedRangeFilter>
				<FromTimeCreated>'.$timestamp_from.'</FromTimeCreated>
				<ToTimeCreated>'.$timestamp_to.'</ToTimeCreated>
			</TimeCreatedRangeFilter>
		';
		
		$TimeModifiedRangeFilter = '
			<TimeModifiedRangeFilter>
				<FromTimeModified>'.$timestamp_from.'</FromTimeModified>
				<ToTimeModified>'.$timestamp_to.'</ToTimeModified>
			</TimeModifiedRangeFilter>
		';
		
		$Dt_RangeFilter = ($is_product_update)?$TimeModifiedRangeFilter:$TimeCreatedRangeFilter;
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<'.$it_q_req.' '.$attr_iterator.' '.$attr_iteratorID.'  requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>
						'.$Dt_RangeFilter.'
						<OwnerID>0</OwnerID>
						'.$iref_xml.'
					</'.$it_q_req.'>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';
		
		//<ToTimeCreated >DATETIMETYPE</ToTimeCreated>
			
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .''.$dl_it.' Pull Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			//$this->add_test_log($dlog_txt);
		}
		
		return $xml;
	}
	
	public function All_Pull_Update_Wc_Inventory_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		if (empty($extra['iteratorID'])){
			$last = $this->_quickbooks_get_last_run($user, $action);
			$this->_quickbooks_set_last_run($user, $action);
			$this->_quickbooks_set_current_run($user, $action, $last);
		}else{
			$attr_iteratorID = ' iteratorID="' . $extra['iteratorID'] . '" ';
			$attr_iterator = ' iterator="Continue" ';

			$last = $this->_quickbooks_get_current_run($user, $action);
		}
		
		$list_id_filter = '';
		/*
		if($this->is_invnt_imp_q_mapped_list_id_filter()){
			$miaa_qbd_ids = $this->get_mapped_qbd_invnt_and_assmbly_items();
			if(is_array($miaa_qbd_ids) && !empty($miaa_qbd_ids)){
				foreach($miaa_qbd_ids as $mqi){
					$list_id_filter .= '	<ListID >'.$mqi['quickbook_product_id'].'</ListID>'.PHP_EOL;
				}
			}
		}
		*/
		
		$dept_filter = '';
		if(is_array($extra) && isset($extra['D_ListId']) && !empty($extra['D_ListId'])){
			$dept_filter = '<DepartmentListID >'.$extra['D_ListId'].'</DepartmentListID>';
		}
		
		$it_q_req = 'ItemInventoryQueryRq';
		$dl_it = 'Inventory';
		
		$iref_xml = $this->get_ii_ire_f_xml();
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<'.$it_q_req.' '.$attr_iterator.' '.$attr_iteratorID.'  requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>
						<OwnerID>0</OwnerID>
						'.$list_id_filter.'
						'.$dept_filter.'
						<ItemType>Inventory</ItemType>
						'.$iref_xml.'
					</'.$it_q_req.'>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';		
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .''.$dl_it.' Import Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			//$this->add_test_log($dlog_txt);
		}
		
		return $xml;
	}
	
	public function All_Pull_Update_Wc_Pricing_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		if (empty($extra['iteratorID'])){
			$last = $this->_quickbooks_get_last_run($user, $action);
			$this->_quickbooks_set_last_run($user, $action);
			$this->_quickbooks_set_current_run($user, $action, $last);
		}else{
			$attr_iteratorID = ' iteratorID="' . $extra['iteratorID'] . '" ';
			$attr_iterator = ' iterator="Continue" ';

			$last = $this->_quickbooks_get_current_run($user, $action);
		}
		
		$it_q_req = 'ItemInventoryQueryRq';
		$dl_it = 'Product Price';
		
		$iref_xml = $this->get_ii_ire_f_xml();
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<'.$it_q_req.' '.$attr_iterator.' '.$attr_iteratorID.'  requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>
						<OwnerID>0</OwnerID>
						'.$iref_xml.'
					</'.$it_q_req.'>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';		
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .''.$dl_it.' Import Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			//$this->add_test_log($dlog_txt);
		}
		
		return $xml;
	}
	
	public function Pull_Update_Wc_Inventory_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		global $wpdb;
		$it_q_req = 'ItemInventoryQueryRq';
		
		$dl_it = 'Inventory';
		$qp_type = 'Inventory';
		
		if(is_array($extra) && count($extra)){
			if(isset($extra['InventoryAssembly']) && $extra['InventoryAssembly']){
				$qp_type = 'InventoryAssembly';
			}
		}
		
		//$qp_type = $this->get_field_by_val($wpdb->prefix.'mw_wc_qbo_desk_qbd_items','product_type','qbd_id',$ID);
		if($qp_type=='InventoryAssembly'){
			$it_q_req = 'ItemInventoryAssemblyQueryRq';
			$dl_it = 'InventoryAssembly';
		}
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<'.$it_q_req.'  requestID="' . $requestID . '">			
						<ListID >'.$ID.'</ListID>
						<OwnerID>0</OwnerID>
					</'.$it_q_req.'>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';		
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .''.$dl_it.' Import Request #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			//$this->add_test_log($dlog_txt);
		}
		
		return $xml;
	}
	
	/*Date Functions*/	
	public function get_qbd_cdt_now($time_zone=''){
		if(empty($time_zone)){
			$time_zone = $this->get_qbd_timezone();
		}
		$now = new DateTime(null, new DateTimeZone($time_zone));
		$datetime = $now->format('Y-m-d H:i:s');
		
		return $datetime;
	}
	
	public function get_auto_inventory_pull_m_dt_from($time_zone=''){
		global $wpdb;
		if(empty($time_zone)){
			$time_zone = $this->get_qbd_timezone();
		}
		
		$mw_qbo_dts_qwc_sec_interval = (int) $this->get_option('mw_qbo_dts_qwc_sec_interval'); //In Seconds
		$minute_interval = floor(($mw_qbo_dts_qwc_sec_interval / 60));
		
		$now = new DateTime(null, new DateTimeZone($time_zone));
		$datetime = $now->format('Y-m-d H:i:s');
		//$timestamp_to = date('Y-m-d', strtotime($datetime)) . 'T' . date('H:i:s', strtotime($datetime));
		
		$rt_ii_it_val = $this->get_option('mw_wc_qbo_desk_rt_inventory_import_interval_time');		
		
		switch ($rt_ii_it_val) {
			case "c_i_t":
				$datetime = date('Y-m-d H:i:s',strtotime("-{$minute_interval} minutes",strtotime($datetime)));
				break;
			case "l_1_h":
				$datetime = date('Y-m-d H:i:s',strtotime("-60 minutes",strtotime($datetime)));
				break;
			case "l_1_d":
				$datetime = date('Y-m-d H:i:s',strtotime("-1 days",strtotime($datetime)));
				break;
			case "l_i_s_t":
				$datetime = $this->get_option('mw_wc_qbo_desk_rt_inventory_p_s_time');
				$datetime = $this->convert_dt_timezone($datetime,$time_zone);
				break;
			case "l_w_c_a_s_t":
				$dq = "SELECT `added_date` FROM {$wpdb->prefix}mw_wc_qbo_desk_qbd_log  WHERE `log_title` = 'Web Connector Login Success' AND `log_type` = 'Web Connector' ORDER BY `id` DESC LIMIT 0,1 ";
				$datetime = $wpdb->get_var($dq);
				$datetime = $this->convert_dt_timezone($datetime,$time_zone);
				break;
			default:
				$datetime = date('Y-m-d H:i:s',strtotime("-{$minute_interval} minutes",strtotime($datetime)));
		}
		
		if(empty($datetime)){
			$datetime = date('Y-m-d H:i:s',strtotime("-{$minute_interval} minutes",strtotime($datetime)));
		}
		
		$timestamp_from = date('Y-m-d', strtotime($datetime)) . 'T' . date('H:i:s', strtotime($datetime));
		return $timestamp_from;
	}
	
	/**/
	public function get_prd_pull_m_dt_from($time_zone='',$wcls=false){
		global $wpdb;
		
		if($wcls){
			$dq = "SELECT `added_date` FROM {$wpdb->prefix}mw_wc_qbo_desk_qbd_log  WHERE `log_title` = 'Web Connector Login Success' AND `log_type` = 'Web Connector' ORDER BY `id` DESC LIMIT 0,1 ";
			$datetime = $wpdb->get_var($dq);
			$datetime = $this->convert_dt_timezone($datetime,$time_zone);
			if(empty($datetime)){return $datetime;}
		}else{
			if(empty($time_zone)){
				$time_zone = $this->get_qbd_timezone();
			}
			
			$now = new DateTime(null, new DateTimeZone($time_zone));
			$datetime = $now->format('Y-m-d H:i:s');
			$datetime = date('Y-m-d H:i:s',strtotime("-30 minutes",strtotime($datetime)));
		}
		
		$timestamp_from = date('Y-m-d', strtotime($datetime)) . 'T' . date('H:i:s', strtotime($datetime));
		return $timestamp_from;
	}
	
	/*New Inventory Auto Pull*/
	public function Auto_Wc_Inventory_AdjustmentQuery_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		if (empty($extra['iteratorID'])){
			$last = $this->_quickbooks_get_last_run($user, $action);
			$this->_quickbooks_set_last_run($user, $action);
			$this->_quickbooks_set_current_run($user, $action, $last);
		}else{
			$attr_iteratorID = ' iteratorID="' . $extra['iteratorID'] . '" ';
			$attr_iterator = ' iterator="Continue" ';

			$last = $this->_quickbooks_get_current_run($user, $action);
		}		
		
		$timestamp_from = $this->get_auto_inventory_pull_m_dt_from($this->get_qbd_timezone());
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<InventoryAdjustmentQueryRq ' . $attr_iterator . ' ' . $attr_iteratorID . ' requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>
						
						<ModifiedDateRangeFilter>
							<FromModifiedDate >'.$timestamp_from.'</FromModifiedDate>										
						</ModifiedDateRangeFilter>
						
						<IncludeLineItems >true</IncludeLineItems>
						<IncludeRetElement >InventoryAdjustmentLineRet</IncludeRetElement>
					</InventoryAdjustmentQueryRq>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';
		
		/*
		<ModifiedDateRangeFilter>
			<FromModifiedDate >'.$timestamp_from.'</FromModifiedDate>
			<ToModifiedDate >DATETIMETYPE</ToModifiedDate>			
		</ModifiedDateRangeFilter>		
		*/
		
		/*
		<TxnDateRangeFilter>
			<FromTxnDate >'.$timestamp_from.'</FromTxnDate>
			<ToTxnDate >DATETYPE</ToTxnDate>
			<DateMacro >Today</DateMacro>
		</TxnDateRangeFilter>
		*/
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'Auto Inventory Import Request - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			$this->add_test_log($dlog_txt);
		}
		return $xml;
	}
	
	public function Auto_Wc_Inventory_AdjustmentQuery_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		//$this->add_test_log('Auto Inventory Import XML Response'.PHP_EOL .$xml);
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		global $wpdb;
		
		if (!empty($idents['iteratorRemainingCount'])){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			$Queue->enqueue('AUTO_WC_UPDATE_INVENTORY', null, 0, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
		}
		
		$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';
		
		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);
		
		$tot_updated = 0;
		$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_items';
		
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/InventoryAdjustmentQueryRs');
			
			foreach ($List->children() as $Item){
				foreach ($Item->children() as $Item_C){
					if($Item_C->name() == 'InventoryAdjustmentLineRet'){
						$ret = $Item_C->name();						
						$ItemRef = $Item_C->getChildDataAt($ret . ' ItemRef ListID');
						$this->Add_Pull_Inventory_Queue($ItemRef);
					}					
				}
			}
		}
		
		return true;
		
	}	
	
	
	public function Auto_Pull_Update_Wc_Inventory_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		if (empty($extra['iteratorID'])){
			$last = $this->_quickbooks_get_last_run($user, $action);
			$this->_quickbooks_set_last_run($user, $action);
			$this->_quickbooks_set_current_run($user, $action, $last);
		}else{
			$attr_iteratorID = ' iteratorID="' . $extra['iteratorID'] . '" ';
			$attr_iterator = ' iterator="Continue" ';

			$last = $this->_quickbooks_get_current_run($user, $action);
		}		
		
		$timestamp_from = $this->get_auto_inventory_pull_m_dt_from($this->get_qbd_timezone());
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<ItemInventoryQueryRq ' . $attr_iterator . ' ' . $attr_iteratorID . ' requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>
						<FromModifiedDate>' . $timestamp_from . '</FromModifiedDate>
						<OwnerID>0</OwnerID>
					</ItemInventoryQueryRq>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';
		
		/*ToModifiedDate*/
		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'Auto Inventory Import Request - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			$this->add_test_log($dlog_txt);
		}
		return $xml;
	}
	
	public function Pull_Update_Wc_Product_Price_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		//$this->add_test_log($xml);
		global $wpdb;
		
		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);
		
		$tot_updated = 0;
		$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_items';
		
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/ItemInventoryQueryRs');
			
			foreach ($List->children() as $Item){				
				$ret = $Item->name();
				$type =$Item->getChildDataAt($ret . ' ItemType');				
				$ListID = $Item->getChildDataAt($ret . ' ListID');
				
				//$mw_wc_qbo_desk_qbd_wc_price_f_mv = get_option('mw_wc_qbo_desk_qbd_wc_price_f_mv');
				
				$qb_pf = $this->get_option('mw_wc_qbo_desk_pull_prd_price_field');
				if(empty($qb_pf)){$qb_pf = 'Price1';}
				$Price = 0;
				
				$custom_price_field = $this->get_qbd_ext_price_field();
				if(is_array($custom_price_field) && in_array($qb_pf,$custom_price_field)){
					$is_cs_pf_ok = false;
					foreach ($Item->children() as $Item_C){
						if($is_cs_pf_ok){break;}
						
						if($Item_C->name() == 'DataExtRet'){
							$ret_c = $Item_C->name();						
							$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');
							//$Item_C->getChildDataAt($ret_c . ' OwnerID')
							if($DataExtName == $qb_pf){
								$is_cs_pf_ok = true;
								$Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
							}
						}					
					}
					
					if(empty($Price)){
						$qb_pf = 'Price1';
						$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
					}
				}else{
					$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
				}
				
				/**/
				$qb_spf = $this->get_option('mw_wc_qbo_desk_pull_prd_sale_price_field');
				$Sale_Price = 0;
				if(!empty($qb_spf)){
					if(is_array($custom_price_field) && in_array($qb_spf,$custom_price_field)){
						$is_cs_spf_ok = false;
						foreach ($Item->children() as $Item_C){
							if($is_cs_spf_ok){break;}							
							if($Item_C->name() == 'DataExtRet'){
								$ret_c = $Item_C->name();						
								$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');								
								if($DataExtName == $qb_spf){
									$is_cs_spf_ok = true;
									$Sale_Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								}
							}					
						}
					}else{
						$Sale_Price = $Item->getChildDataAt($ret . ' '.$qb_spf);
					}
				}
				
				$arr = array(
					'ListID' 			=> $Item->getChildDataAt('ItemInventoryRet ListID'),
					'Name'				=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'ALU'				=> $Item->getChildDataAt('ItemInventoryRet ALU'),
					'ItemNumber' 		=> $Item->getChildDataAt('ItemInventoryRet ItemNumber'),
					'DepartmentCode' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					'DepartmentListID' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					'Desc1' 			=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'Desc2' 			=> $Item->getChildDataAt('ItemInventoryRet Desc2'),
					'UPC' 				=> $Item->getChildDataAt('ItemInventoryRet UPC'),
					'OnHandStore01' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore01'),
					'OnHandStore02' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore02'),
					'OnHandStore03' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore03'),
					'OnHandStore04' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore04'),
					'OnHandStore05' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore05'),
					'OnHandStore06' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore06'),
					'OnHandStore07' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore07'),
					'OnHandStore08' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore08'),
					'OnHandStore09' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore09'),
					'OnHandStore10' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore10'),
					'OnHandStore11' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore11'),
					'OnHandStore12' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore12'),
					'OnHandStore13' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore13'),
					'OnHandStore14' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore14'),
					'OnHandStore15' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore15'),
					'OnHandStore16' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore16'),
					'OnHandStore17' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore17'),
					'OnHandStore18' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore18'),
					'OnHandStore19' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore19'),
					'OnHandStore20' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore20'),
					'QuantityOnHand' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnHand'),
					
					'QuantityOnCustomerOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnCustomerOrder'),
					'QuantityOnHand' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnHand'),
					'QuantityOnOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnOrder'),
					'QuantityOnPendingOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnPendingOrder'),
					
					'ItemType'			=> $Item->getChildDataAt('ItemInventoryRet ItemType'),
					'Price1'			=> $Item->getChildDataAt('ItemInventoryRet Price1'),
					'Price2'			=> $Item->getChildDataAt('ItemInventoryRet Price2'),
					'Price3'			=> $Item->getChildDataAt('ItemInventoryRet Price3'),
					'Price4'			=> $Item->getChildDataAt('ItemInventoryRet Price4'),
					'Price5'			=> $Item->getChildDataAt('ItemInventoryRet Price5'),
					//
					'WebPrice'			=> $Item->getChildDataAt('ItemInventoryRet WebPrice'),					
					//
					'Price' => $Price,
					'Sale_Price' => $Sale_Price,
					'TaxCode'			=> $Item->getChildDataAt('ItemInventoryRet TaxCode'),
					
					'COGSAccount'			=> $Item->getChildDataAt('ItemInventoryRet COGSAccount'),
					'Cost'			=> $Item->getChildDataAt('ItemInventoryRet Cost'),
					//'DepartmentCode'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					//'DepartmentListID'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					
					'IsWebItem'			=> $Item->getChildDataAt('ItemInventoryRet IsWebItem'),
					'MSRP'			=> $Item->getChildDataAt('ItemInventoryRet MSRP'),
					
					'Attribute'			=> $Item->getChildDataAt('ItemInventoryRet Attribute'),
					'Size'			=> $Item->getChildDataAt('ItemInventoryRet Size'),
					
				);
				
				$uwi_data = array();
				$uwi_data['qbo_product_id'] = $arr['ListID'];
				$uwi_data['Name'] = $arr['Name'];
				$uwi_data['Price'] = $Price;
				$uwi_data['Sale_Price'] = $Sale_Price;
				
				$uwi_data['Price1'] = $arr['Price1'];
				$uwi_data['Price2'] = $arr['Price2'];
				$uwi_data['Price3'] = $arr['Price3'];
				$uwi_data['Price4'] = $arr['Price4'];
				$uwi_data['Price5'] = $arr['Price5'];
				$uwi_data['WebPrice'] = $arr['WebPrice'];
				
				if(is_array($extra) && count($extra) && isset($extra['manual']) && $extra['manual']){
					$uwi_data['manual'] = true;
				}
				//$this->add_test_log(print_r($uwi_data,true));
				
				$this->UpdateWooCommerceProductPrice($uwi_data);
				
				//Update Local Table Data			
				
				$id = (int) $this->get_field_by_val($table,'id','qbd_id',$arr['ListID']);
				
				$save_data = array();
				//$save_data['qbd_id'] = $arr['ListID'];				
				
				$save_data['name'] = $arr['Name'];
				$save_data['sku'] = $arr['ItemNumber'];
				
				$save_data['upc'] = $arr['UPC'];
				$save_data['alu'] = $arr['ALU'];
				
				$save_data['product_type'] = $arr['ItemType'];
				$save_data['parent_id'] = '';
				
				$save_data['info_arr'] = serialize($arr);				
				$save_data['info_qbxml_obj'] = '';
				
				if($id>0){
					$wpdb->update($table,$save_data,array('id'=>$id),'',array('%d'));
				}else{
					$save_data['qbd_id'] = $arr['ListID'];
					$wpdb->insert($table, $save_data);
				}
			}
		}
		
		return true;
	}
	
	public function Auto_Pull_Update_Wc_Inventory_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		//$this->add_test_log($xml);
		
		global $wpdb;
		
		if (!empty($idents['iteratorRemainingCount'])){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			$Queue->enqueue('AUTO_WC_UPDATE_INVENTORY', null, 0, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
		}
		
		$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';
		
		$qp_type = 'Inventory';
		
		if(is_array($extra) && count($extra)){
			if(isset($extra['InventoryAssembly']) && $extra['InventoryAssembly']){
				$qp_type = 'InventoryAssembly';
			}
		}
		
		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);
		
		$tot_updated = 0;
		$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_items';
		
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			
			if($qp_type=='InventoryAssembly'){
				$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/ItemInventoryAssemblyQueryRs');
			}else{
				$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/ItemInventoryQueryRs');
			}
			
			foreach ($List->children() as $Item){				
				$ret = $Item->name();
				
				$qb_pf = $this->get_option('mw_wc_qbo_desk_pull_prd_price_field');
				if(empty($qb_pf)){$qb_pf = 'Price1';}
				$Price = 0;
				
				$custom_price_field = $this->get_qbd_ext_price_field();
				if(is_array($custom_price_field) && in_array($qb_pf,$custom_price_field)){
					$is_cs_pf_ok = false;
					foreach ($Item->children() as $Item_C){
						if($is_cs_pf_ok){break;}
						
						if($Item_C->name() == 'DataExtRet'){
							$ret_c = $Item_C->name();						
							$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');
							//$Item_C->getChildDataAt($ret_c . ' OwnerID')
							if($DataExtName == $qb_pf){
								$is_cs_pf_ok = true;
								$Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
							}
						}					
					}
					
					if(empty($Price)){
						$qb_pf = 'Price1';
						$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
					}
				}else{
					$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
				}
				
				/**/
				$qb_spf = $this->get_option('mw_wc_qbo_desk_pull_prd_sale_price_field');
				$Sale_Price = 0;
				if(!empty($qb_spf)){
					if(is_array($custom_price_field) && in_array($qb_spf,$custom_price_field)){
						$is_cs_spf_ok = false;
						foreach ($Item->children() as $Item_C){
							if($is_cs_spf_ok){break;}							
							if($Item_C->name() == 'DataExtRet'){
								$ret_c = $Item_C->name();						
								$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');								
								if($DataExtName == $qb_spf){
									$is_cs_spf_ok = true;
									$Sale_Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								}
							}					
						}
					}else{
						$Sale_Price = $Item->getChildDataAt($ret . ' '.$qb_spf);
					}
				}			
				
				$arr = array(
					'ListID' 			=> $Item->getChildDataAt('ItemInventoryRet ListID'),
					'Name'				=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'ALU'				=> $Item->getChildDataAt('ItemInventoryRet ALU'),
					'ItemNumber' 		=> $Item->getChildDataAt('ItemInventoryRet ItemNumber'),
					'DepartmentCode' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					'DepartmentListID' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					'Desc1' 			=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'Desc2' 			=> $Item->getChildDataAt('ItemInventoryRet Desc2'),
					'UPC' 				=> $Item->getChildDataAt('ItemInventoryRet UPC'),
					'OnHandStore01' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore01'),
					'OnHandStore02' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore02'),
					'OnHandStore03' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore03'),
					'OnHandStore04' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore04'),
					'OnHandStore05' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore05'),
					'OnHandStore06' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore06'),
					'OnHandStore07' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore07'),
					'OnHandStore08' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore08'),
					'OnHandStore09' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore09'),
					'OnHandStore10' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore10'),
					'OnHandStore11' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore11'),
					'OnHandStore12' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore12'),
					'OnHandStore13' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore13'),
					'OnHandStore14' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore14'),
					'OnHandStore15' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore15'),
					'OnHandStore16' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore16'),
					'OnHandStore17' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore17'),
					'OnHandStore18' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore18'),
					'OnHandStore19' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore19'),
					'OnHandStore20' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore20'),
					'QuantityOnHand' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnHand'),
					
					'QuantityOnCustomerOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnCustomerOrder'),					
					'QuantityOnOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnOrder'),
					'QuantityOnPendingOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnPendingOrder'),
					
					'ItemType'			=> $Item->getChildDataAt('ItemInventoryRet ItemType'),
					'Price1'			=> $Item->getChildDataAt('ItemInventoryRet Price1'),
					'Price2'			=> $Item->getChildDataAt('ItemInventoryRet Price2'),
					'Price3'			=> $Item->getChildDataAt('ItemInventoryRet Price3'),
					'Price4'			=> $Item->getChildDataAt('ItemInventoryRet Price4'),
					'Price5'			=> $Item->getChildDataAt('ItemInventoryRet Price5'),
					
					'WebPrice'			=> $Item->getChildDataAt('ItemInventoryRet WebPrice'),
					'Price' => $Price,
					'Sale_Price' => $Sale_Price,
					
					'TaxCode'			=> $Item->getChildDataAt('ItemInventoryRet TaxCode'),
					
					'COGSAccount'			=> $Item->getChildDataAt('ItemInventoryRet COGSAccount'),
					'Cost'			=> $Item->getChildDataAt('ItemInventoryRet Cost'),
					//'DepartmentCode'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					//'DepartmentListID'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					
					'IsWebItem'			=> $Item->getChildDataAt('ItemInventoryRet IsWebItem'),
					'MSRP'			=> $Item->getChildDataAt('ItemInventoryRet MSRP'),
					
					'Attribute'			=> $Item->getChildDataAt('ItemInventoryRet Attribute'),
					'Size'			=> $Item->getChildDataAt('ItemInventoryRet Size'),
					
				);
				
				$uwi_data = array();
				$uwi_data['qbo_inventory_id'] = $arr['ListID'];
				$uwi_data['Name'] = $arr['Name'];
				
				//
				$QuantityOnHand = $Item->getChildDataAt($ret . ' QuantityOnHand');
				
				/**/
				$q_m_stores = $this->get_option('mw_wc_qbo_desk_invt_pull_qb_stores');
				if(!empty($q_m_stores)){
					$q_m_stores = explode(',',$q_m_stores);
					if(is_array($q_m_stores) && !empty($q_m_stores)){
						$QuantityOnHand = 0;
						foreach($q_m_stores as $qv){
							$qv_k = 'OnHandStore'.$qv;
							if(isset($arr[$qv_k])){
								$QuantityOnHand += (int) $arr[$qv_k];
							}
						}
					}
				}
				
				$QuantityOnOrder = $Item->getChildDataAt($ret . ' QuantityOnOrder');
				$QuantityOnCustomerOrder = $Item->getChildDataAt($ret . ' QuantityOnCustomerOrder');
				$QuantityOnPendingOrder = $Item->getChildDataAt($ret . ' QuantityOnPendingOrder');
				
				/**/
				if(is_array($q_m_stores) && !empty($q_m_stores)){
					$QuantityOnOrder = 0;
					$QuantityOnCustomerOrder = 0;
					$QuantityOnPendingOrder = 0;
					
					foreach ($Item->children() as $Item_C_AQ){
						if($Item_C_AQ->name() == 'AvailableQty'){
							$ret_c_AQ = $Item_C_AQ->name();
							$Aq_StoreNumber = $Item_C_AQ->getChildDataAt($ret_c_AQ . ' StoreNumber');
							$Aq_StoreNumber = ($Aq_StoreNumber < 10)?'0'.$Aq_StoreNumber:$Aq_StoreNumber;
							if(isset($q_m_stores[$Aq_StoreNumber])){
								$QuantityOnOrder += (int) $Item_C_AQ->getChildDataAt($ret_c_AQ . ' QuantityOnOrder');
								$QuantityOnCustomerOrder += (int) $Item_C_AQ->getChildDataAt($ret_c_AQ . ' QuantityOnCustomerOrder');
								$QuantityOnPendingOrder += (int) $Item_C_AQ->getChildDataAt($ret_c_AQ . ' QuantityOnPendingOrder');
							}
						}
					}
				}				
				
				$qqpf = $this->get_option('mw_wc_qbo_desk_pull_invnt_qty_field');
				if($qqpf == 'AvailableQuantity'){
					//$qqpf_val = ($QuantityOnHand-$QuantityOnOrder-$QuantityOnCustomerOrder-$QuantityOnPendingOrder);
					$qqpf_val = ($QuantityOnHand-$QuantityOnCustomerOrder-$QuantityOnPendingOrder);
				}else{
					$qqpf_val = $QuantityOnHand;
				}
				
				$uwi_data['QuantityOnHand'] = $qqpf_val;
				
				if(is_array($extra) && count($extra) && isset($extra['manual']) && $extra['manual']){
					$uwi_data['manual'] = true;
				}
				
				$this->UpdateWooCommerceInventory($uwi_data);
				
				//Update Local Table Data
				$id = (int) $this->get_field_by_val($table,'id','qbd_id',$arr['ListID']);
				
				$save_data = array();
				$save_data['qbd_id'] = $arr['ListID'];				
				
				$save_data['name'] = $arr['Name'];
				$save_data['sku'] = $arr['ItemNumber'];
				
				$save_data['upc'] = $arr['UPC'];
				$save_data['alu'] = $arr['ALU'];
				
				$save_data['product_type'] = $arr['ItemType'];
				$save_data['parent_id'] = '';
				
				$save_data['info_arr'] = serialize($arr);				
				$save_data['info_qbxml_obj'] = '';
				
				if($id>0){
					$wpdb->update($table,$save_data,array('id'=>$id),'',array('%d'));
				}else{
					$save_data['qbd_id'] = $arr['ListID'];
					$wpdb->insert($table, $save_data);
				}
			}
		}
		
		return true;
	}
	
	public function Pull_Update_Wc_Inventory_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!is_array($extra)){
			$extra = array();
		}
		
		$extra['manual'] = true;
		$this->Auto_Pull_Update_Wc_Inventory_Response($requestID, $user, $action, $ID, $extra, $err, $last_action_time, $last_actionident_time, $xml, $idents);
	}
	
	public function All_Pull_ItemSitesQuery_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		//$this->add_test_log('ItemSitesQuery Response: '.$this->get_cdt(). PHP_EOL .$xml);
		
		global $wpdb;
		
		$is_process_invnt_pull = false;
		if (!empty($idents['iteratorRemainingCount'])){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			$Queue->enqueue('ALL_PULL_INVT_ISQ', null, 0, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
		}else{
			$is_process_invnt_pull = true;
		}
		
		$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';
		
		if($this->get_session_val('invnt_pull_item_site_iteratorID','',true)!=$iteratorID){			
			$this->unset_session('invnt_st_qty_arr');
			$this->unset_session('item_name_arr');
			$this->unset_session('item_asmb_arr');
			
			$this->set_session_val('invnt_st_qty_arr',array());
			$this->set_session_val('item_name_arr',array());
			$this->set_session_val('item_asmb_arr',array());
		}
		
		$this->set_session_val('invnt_pull_item_site_iteratorID',$iteratorID);
		
		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);
		
		$tot_updated = 0;
		$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_items';
		
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/ItemSitesQueryRs');
			
			//$invnt_st_qty_arr = array();			
			//$item_name_arr = array();
			//$item_asmb_arr = array();
			
			$invnt_st_qty_arr = $this->get_session_val('invnt_st_qty_arr',array(),false);
			$item_name_arr = $this->get_session_val('item_name_arr',array(),false);
			$item_asmb_arr = $this->get_session_val('item_asmb_arr',array(),false);
			
			foreach ($List->children() as $Item){
				$ret = $Item->name();				
				$InventoryRef = $Item->getChildDataAt($ret.' ItemInventoryRef ListID');
				$Name = $Item->getChildDataAt($ret.' ItemInventoryRef FullName');
				
				$InventoryAssembly = false;
				if(empty($InventoryRef)){
					$InventoryRef = $Item->getChildDataAt($ret.' ItemInventoryAssemblyRef ListID');
					$Name = $Item->getChildDataAt($ret.' ItemInventoryAssemblyRef FullName');
					$InventoryAssembly = true;
				}
				//$this->add_test_log($InventoryRef . ':' . $Name);
				if(!empty($InventoryRef)){
					$InventorySiteRef = $Item->getChildDataAt($ret.' InventorySiteRef ListID');
					$InventorySiteLocationRef = $Item->getChildDataAt($ret.' InventorySiteLocationRef ListID');					
					
					$adv_inv_site = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_sites_for_invnt_pull');
					if(!empty($adv_inv_site)){
						$adv_inv_site = explode(',',$adv_inv_site);
					}
					
					//
					$Inv_Site_Check_Val = '';
					if($this->is_inv_site_bin_allowed()){
						if(!empty($InventorySiteLocationRef)){
							$Inv_Site_Check_Val = $InventorySiteRef.':'.$InventorySiteLocationRef;
						}						
					}else{
						$Inv_Site_Check_Val = $InventorySiteRef;
					}
					
					if(!empty($Inv_Site_Check_Val) && is_array($adv_inv_site) && count($adv_inv_site) && in_array($Inv_Site_Check_Val,$adv_inv_site)){
						$QuantityOnHand = (float) $Item->getChildDataAt($ret.' QuantityOnHand');
						$QuantityOnPurchaseOrders = (float) $Item->getChildDataAt($ret.' QuantityOnPurchaseOrders');
						$QuantityOnSalesOrders = (float) $Item->getChildDataAt($ret.' QuantityOnSalesOrders');
						
						$InventorySiteRef_FullName = $Item->getChildDataAt($ret.' InventorySiteRef FullName');
						$InventorySiteLocationRef_FullName = $Item->getChildDataAt($ret.' InventorySiteLocationRef FullName');
						
						$q_tmp_arr = array();
						$q_tmp_arr['QuantityOnHand'] = $QuantityOnHand;
						$q_tmp_arr['QuantityOnPurchaseOrders'] = $QuantityOnPurchaseOrders;
						$q_tmp_arr['QuantityOnSalesOrders'] = $QuantityOnSalesOrders;
						
						$s_tmp_arr = array(
							'InventorySiteRef' => $InventorySiteRef,
							'InventorySiteRef_FullName' => $InventorySiteRef_FullName,
							'InventorySiteLocationRef' => $InventorySiteLocationRef,
							'InventorySiteLocationRef_FullName' => $InventorySiteLocationRef_FullName,
							'Qty_Arr' => $q_tmp_arr
						);
						
						$invnt_st_qty_arr[$InventoryRef][] = $s_tmp_arr;
						
						if(!isset($item_name_arr[$InventoryRef])){
							$item_name_arr[$InventoryRef] = $Name;
						}	

						if(!isset($item_asmb_arr[$InventoryRef])){
							$item_asmb_arr[$InventoryRef] = $InventoryAssembly;
						}
					}
				}				
				
			}
			
			/*
			$this->add_test_log(print_r($invnt_st_qty_arr,true));
			$this->add_test_log(print_r($item_name_arr,true));
			$this->add_test_log(print_r($item_asmb_arr,true));
			*/
			
			/**/
			$this->set_session_val('invnt_st_qty_arr',$invnt_st_qty_arr);
			$this->set_session_val('item_name_arr',$item_name_arr);
			$this->set_session_val('item_asmb_arr',$item_asmb_arr);
			
			if(!$is_process_invnt_pull){
				return true;
			}
			
			$s_qty_sum_arr = array();
			if(count($invnt_st_qty_arr)){				
				foreach($invnt_st_qty_arr as $sqa_k => $sqa_v){
					if(is_array($sqa_v) && count($sqa_v)){
						$QuantityOnHand_Sum = 0;
						$QuantityOnPurchaseOrders_Sum = 0;
						$QuantityOnSalesOrders_Sum = 0;
						$is_sum_added = false;
						foreach($sqa_v as $sqa_v_c){
							if(is_array($sqa_v_c) && count($sqa_v_c)){
								if(isset($sqa_v_c['Qty_Arr']) && is_array($sqa_v_c['Qty_Arr']) && count($sqa_v_c['Qty_Arr'])){
									$Qty_Arr = $sqa_v_c['Qty_Arr'];
									$is_sum_added = true;
									$QuantityOnHand_Sum+= $Qty_Arr['QuantityOnHand'];
									$QuantityOnPurchaseOrders_Sum+= $Qty_Arr['QuantityOnPurchaseOrders'];
									$QuantityOnSalesOrders_Sum+= $Qty_Arr['QuantityOnSalesOrders'];
								}
							}
							
						}
						if($is_sum_added){
							$tmp_sum_arr = array();
							$tmp_sum_arr['QuantityOnHand'] = $QuantityOnHand_Sum;
							$tmp_sum_arr['QuantityOnPurchaseOrders'] = $QuantityOnPurchaseOrders_Sum;
							$tmp_sum_arr['QuantityOnSalesOrders'] = $QuantityOnSalesOrders_Sum;
							
							$s_qty_sum_arr[$sqa_k] = $tmp_sum_arr;
						}
						
					}
				}
			}
			
			if(count($s_qty_sum_arr)){
				//$this->add_test_log(print_r($invnt_st_qty_arr,true));
				//$this->add_test_log(print_r($s_qty_sum_arr,true));
				
				foreach($s_qty_sum_arr as $qty_sum_k => $qty_sum_v){
					$uwi_data = array();
					$uwi_data['qbo_inventory_id'] = $qty_sum_k;
					
					//$Name = $this->get_field_by_val($table,'name','qbd_id',$qty_sum_k);
					$uwi_data['Name'] = (isset($item_name_arr[$qty_sum_k]))?$item_name_arr[$qty_sum_k]:'';
					//
					$qqpf = $this->get_option('mw_wc_qbo_desk_pull_invnt_qty_field');
					if($qqpf == 'AvailableQuantity'){
						$qqpf_val = ($qty_sum_v['QuantityOnHand']-$qty_sum_v['QuantityOnSalesOrders']);
					}else{
						$qqpf_val = $qty_sum_v['QuantityOnHand'];
					}
					
					/**/
					$uwi_data['QuantityOnHand_Original'] = $qty_sum_v['QuantityOnHand'];
					$uwi_data['QuantityOnSalesOrders'] = $qty_sum_v['QuantityOnSalesOrders'];
					
					$uwi_data['QuantityOnHand'] = $qqpf_val;
					$uwi_data['InventoryAssembly'] = (isset($item_asmb_arr[$qty_sum_k]))?$item_asmb_arr[$qty_sum_k]:false;
					
					$this->UpdateWooCommerceInventory($uwi_data);
					
					/*
					$InventoryRef = $this->sanitize($qty_sum_k);
					$e_qbd_prd = $this->get_row("SELECT * FROM {$table} WHERE `qbd_id` = '{$InventoryRef}' ");
					if(is_array($e_qbd_prd) && count($e_qbd_prd)){
						$id = (int) $e_qbd_prd['id'];
						if(!empty($e_qbd_prd['info_arr'])){
							$info_arr = @unserialize($e_qbd_prd['info_arr']);
							if(is_array($info_arr) && count($info_arr)){
								$info_arr['QuantityOnHand'] = $qty_sum_v['QuantityOnHand'];
								$info_arr['QuantityOnOrder'] = $qty_sum_v['QuantityOnPurchaseOrders'];
								$info_arr['QuantityOnSalesOrder'] = $qty_sum_v['QuantityOnSalesOrders'];
								
								$info_arr = serialize($info_arr);
								$save_data = array();
								$save_data['info_arr'] = $info_arr;
								$wpdb->update($table,$save_data,array('id'=>$id),'',array('%d'));
							}
						}						
					}
					*/
				}
			}
		}
		
		return true;
	}
	
	public function All_Pull_Update_Wc_Inventory_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		//$this->save_log(array('log_type'=>'Test','log_title'=>'Test','details'=>'Test','status'=>2));
		if (!empty($idents['iteratorRemainingCount'])){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			if(is_array($extra) && isset($extra['D_ListId']) && !empty($extra['D_ListId'])){
				$Queue->enqueue('ALL_WC_UPDATE_INVENTORY', null, 0,array('D_ListId'=>$extra['D_ListId'], 'iteratorID' => $idents['iteratorID']),$this->get_qbun());
			}else{
				$Queue->enqueue('ALL_WC_UPDATE_INVENTORY', null, 0, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
			}			
		}		
		//$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';
		$idents = array();		
		$this->Auto_Pull_Update_Wc_Inventory_Response($requestID, $user, $action, $ID, $extra, $err, $last_action_time, $last_actionident_time, $xml, $idents);
	}
	
	public function All_Pull_Update_Wc_Pricing_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){		
		if (!empty($idents['iteratorRemainingCount'])){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			$Queue->enqueue('ALL_WC_UPDATE_PRICING', null, 0, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
		}		
		//$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';
		$idents = array();		
		$this->Pull_Update_Wc_Product_Price_Response($requestID, $user, $action, $ID, $extra, $err, $last_action_time, $last_actionident_time, $xml, $idents);
	}
	
	//
	public function All_Pull_Update_Wc_Inventory_A_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if (!empty($idents['iteratorRemainingCount'])){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			$Queue->enqueue('ALL_WC_UPDATE_INVENTORY_A', null, 0, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
		}		
		//$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';
		$idents = array();
		if(!is_array($extra)){
			$extra = array();
		}		
		$extra['InventoryAssembly'] = true;
		$idents = array();
		//$this->Auto_Pull_Update_Wc_Inventory_Response($requestID, $user, $action, $ID, $extra, $err, $last_action_time, $last_actionident_time, $xml, $idents);
	}
	
	/*Pull Functions End*/

	/*Import Functions Start*/
	
	/*Vendor Import Request/Response*/
	public function Vendor_Import_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}

		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		if (empty($extra['iteratorID'])){
			$last = $this->_quickbooks_get_last_run($user, $action);
			$this->_quickbooks_set_last_run($user, $action);
			$this->_quickbooks_set_current_run($user, $action, $last);
		}else{
			$attr_iteratorID = ' iteratorID="' . $extra['iteratorID'] . '" ';
			$attr_iterator = ' iterator="Continue" ';

			$last = $this->_quickbooks_get_current_run($user, $action);
		}

		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<VendorQueryRq ' . $attr_iterator . ' ' . $attr_iteratorID . ' requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>
						<!--<FromModifiedDate>' . $last . '</FromModifiedDate>-->
						<OwnerID>0</OwnerID>
					</VendorQueryRq>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';
		
		/*
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'Vendor Import Request - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			$this->add_test_log($dlog_txt);
		}
		*/
		
		return $xml;

	}
	
	public function Vendor_Import_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}

		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));
		global $wpdb;
		if (!empty($idents['iteratorRemainingCount'])){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			$Queue->enqueue(QUICKBOOKS_IMPORT_VENDOR, null, QB_PRIORITY_REFRESH_DATA_IMPORT, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
		}

		$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';

		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);

		$tot_imported = 0;
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/VendorQueryRs');

			$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_vendors';

			/*Delete Old Data*/
			if($this->get_session_val('import_vendor_iteratorID','',true)!=$iteratorID){
				$wpdb->query("DELETE FROM {$table} WHERE `id` > 0");
				$wpdb->query("TRUNCATE TABLE {$table}");
			}

			//
			$this->set_session_val('import_vendor_iteratorID',$iteratorID);
			
			foreach ($List->children() as $Vendor){
				$tot_imported++;
				$arr = array(
				'ListID' => $Vendor->getChildDataAt('VendorRet ListID'),
				'TimeCreated' => $Vendor->getChildDataAt('VendorRet TimeCreated'),
				'TimeModified' => $Vendor->getChildDataAt('VendorRet TimeModified'),
				'Email' => $Vendor->getChildDataAt('VendorRet Email'),
				'Name' => $Vendor->getChildDataAt('VendorRet Name'),				
				'FirstName' => $Vendor->getChildDataAt('VendorRet FirstName'),
				'MiddleName' => $Vendor->getChildDataAt('VendorRet MiddleName'),
				'LastName' => $Vendor->getChildDataAt('VendorRet LastName'),
				'JobTitle' => $Vendor->getChildDataAt('VendorRet JobTitle'),
				
				'Contact' => $Vendor->getChildDataAt('VendorRet Contact'),
				'Phone' => $Vendor->getChildDataAt('VendorRet Phone'),
				'AltPhone' => $Vendor->getChildDataAt('VendorRet AltPhone'),
				'Fax' => $Vendor->getChildDataAt('VendorRet Fax'),
				'CompanyName' => $Vendor->getChildDataAt('VendorRet CompanyName'),
				
				'AccountNumber' => $Vendor->getChildDataAt('VendorRet AccountNumber'),
				
				'IsVendorEligibleFor1099' => $Vendor->getChildDataAt('VendorRet IsVendorEligibleFor1099'),
				'VendorTaxIdent' => $Vendor->getChildDataAt('VendorRet VendorTaxIdent'),
				
				'CreditLimit' => $Vendor->getChildDataAt('VendorRet CreditLimit'),

				'VendorAddress_Addr1' => $Vendor->getChildDataAt('VendorRet VendorAddress Addr1'),
				'VendorAddress_Addr2' => $Vendor->getChildDataAt('VendorRet VendorAddress Addr2'),
				
				'VendorAddress_Addr3' => $Vendor->getChildDataAt('VendorRet VendorAddress Addr3'),
				'VendorAddress_Addr4' => $Vendor->getChildDataAt('VendorRet VendorAddress Addr4'),
				'VendorAddress_Addr5' => $Vendor->getChildDataAt('VendorRet VendorAddress Addr5'),
				
				'VendorAddress_City' => $Vendor->getChildDataAt('VendorRet VendorAddress City'),
				'VendorAddress_State' => $Vendor->getChildDataAt('VendorRet VendorAddress State'),
				'VendorAddress_PostalCode' => $Vendor->getChildDataAt('VendorRet VendorAddress PostalCode'),
				'VendorAddress_Country' => $Vendor->getChildDataAt('VendorRet VendorAddress Country'),
				'VendorAddress_Note' => $Vendor->getChildDataAt('VendorRet VendorAddress Note'),
				

				'ShipAddress_Addr1' => $Vendor->getChildDataAt('VendorRet ShipAddress Addr1'),
				'ShipAddress_Addr2' => $Vendor->getChildDataAt('VendorRet ShipAddress Addr2'),
				
				'ShipAddress_Addr3' => $Vendor->getChildDataAt('VendorRet ShipAddress Addr3'),
				'ShipAddress_Addr4' => $Vendor->getChildDataAt('VendorRet ShipAddress Addr4'),
				'ShipAddress_Addr5' => $Vendor->getChildDataAt('VendorRet ShipAddress Addr5'),
				
				'ShipAddress_City' => $Vendor->getChildDataAt('VendorRet ShipAddress City'),
				'ShipAddress_State' => $Vendor->getChildDataAt('VendorRet ShipAddress State'),
				'ShipAddress_PostalCode' => $Vendor->getChildDataAt('VendorRet ShipAddress PostalCode'),
				'ShipAddress_Country' => $Vendor->getChildDataAt('VendorRet ShipAddress Country'),
				'ShipAddress_Note' => $Vendor->getChildDataAt('VendorRet ShipAddress Note'),
				);
				
				//$this->add_test_log(print_r($arr,true));

				$save_data = array();
				$save_data['qbd_vendorid'] = $arr['ListID'];
				$save_data['email'] = $arr['Email'];
				$save_data['first_name'] = $arr['FirstName'];
				$save_data['middle_name'] = $arr['MiddleName'];
				$save_data['last_name'] = $arr['LastName'];
				$save_data['company'] = $arr['CompanyName'];
				$save_data['d_name'] = $arr['Name'];
				//
				$save_data['jobtitle'] = $arr['JobTitle'];
				$save_data['info_arr'] = serialize($arr);
				
				$save_data['info_qbxml_obj'] = '';
				//$this->add_test_log(print_r($save_data,true));
				$wpdb->insert($table, $save_data);
				//$lastid = $wpdb->insert_id;
				//$this->add_test_log($wpdb->last_error);

			}
		}
		
		if($tot_imported>0){
			$log_title = "Recognized Vendor Successfully";
			$details = "Total Vendor Recognized:{$tot_imported}";
			$status = 1;
		}else{
			$log_title = "Recognized Vendor Error";
			$errmsg = (!empty($errmsg))?$errmsg:"No Vendor Found";
			$details = ($errnum)?"Error Number:{$errnum}\n"."Error:{$errmsg}":"Error:{$errmsg}";
			$status = 0;
		}
		$this->save_log(array('log_type'=>'Vendor','log_title'=>$log_title,'details'=>$details,'status'=>$status),true);

		return true;
	}
	
	/**/
	public function CustomerMod_Query_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$ListID = '';
		if(is_array($extra) && !empty($extra) && isset($extra['ListID'])){
			$ListID = $extra['ListID'];
		}
		
		if(empty($ListID)){
			return false;
		}
		
		$xml = '<?xml version="1.0" encoding="utf-8"?>
		<?qbposxml version="' . $version . '"?>
		<QBPOSXML>
			<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
				<CustomerQueryRq requestID="' . $requestID . '">								
					<ListID >'.$ListID.'</ListID>
				</CustomerQueryRq>
			</QBPOSXMLMsgsRq>
		</QBPOSXML>';
		
		return $xml;
	}
	
	/*Customer Import Request/Response*/
	public function Customer_Import_ByName_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$is_guest = false;
		if(is_array($extra) && !empty($extra)){
			if(isset($extra['is_guest']) && $extra['is_guest'] == 1){
				$is_guest = true;
			}
		}
		$ID = intval($ID);
		if($ID>0){
			if($is_guest){
				$customer_data = $this->get_wc_customer_info_from_order($ID);
			}else{
				$customer_data = $this->get_wc_customer_info($ID);
			}
			
			if(is_array($customer_data) && !empty($customer_data)){
				$name_replace_chars = array(':','\t','\n');
				$display_name = $this->get_array_isset($customer_data,'display_name','',true,100,false,$name_replace_chars);
				
				if(!empty($display_name)){
					/**/
					$active_filter = 'ActiveOnly';
					if($this->option_checked('mw_wc_qbo_desk_cus_imp_inc_inactive_sts')){
						$active_filter = 'All';
					}
					//<ActiveStatus>' . $active_filter . '</ActiveStatus>
					
					$xml = '<?xml version="1.0" encoding="utf-8"?>
					<?qbposxml version="' . $version . '"?>
					<QBPOSXML>
						<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
							<CustomerQueryRq requestID="' . $requestID . '">								
								<NameFilter>
									<MatchCriterion>Contains</MatchCriterion>
									<Name>'.$display_name.'</Name>
								</NameFilter>								
							</CustomerQueryRq>
						</QBPOSXMLMsgsRq>
					</QBPOSXML>';
					
					/*
					<MaxReturned>1</MaxReturned>							
					<OwnerID>0</OwnerID>
					*/
					
					$gc_txt = ($is_guest)?'Guest':'Customer';
					
					if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
						$dlog_txt = PHP_EOL . $gc_txt.' Import Request By Name #'.$ID.' - '.$this->get_cdt(). PHP_EOL;
						$dlog_txt.=$xml;
						$this->add_test_log($dlog_txt);
					}
					return $xml;
				}
			}
		}
	}
	
	public function Customer_Import_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}

		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		if (empty($extra['iteratorID'])){
			$last = $this->_quickbooks_get_last_run($user, $action);
			$this->_quickbooks_set_last_run($user, $action);
			$this->_quickbooks_set_current_run($user, $action, $last);
		}else{
			$attr_iteratorID = ' iteratorID="' . $extra['iteratorID'] . '" ';
			$attr_iterator = ' iterator="Continue" ';

			$last = $this->_quickbooks_get_current_run($user, $action);
		}
		
		$dr = '';
		if(is_array($extra) && isset($extra['new']) && $extra['new'] && isset($extra['timestamp_from']) && !empty($extra['timestamp_from'])){
			$timestamp_from = $extra['timestamp_from'];			
			$dr = '
				<TimeModifiedFilter>
					<MatchNumericCriterion >GreaterThan</MatchNumericCriterion>
					<TimeModified >'.$timestamp_from.'</TimeModified>
				</TimeModifiedFilter>
			';
			
			/*
			$c_dt = $this->now();			
			$timestamp_to = date('Y-m-d', strtotime($c_dt)) . 'T' . date('H:i:s', strtotime($c_dt));
			$dr = '
				<TimeModifiedRangeFilter>
					<FromTimeModified >'.$timestamp_from.'</FromTimeModified>
					<ToTimeModified >'.$timestamp_to.'</ToTimeModified>
				</TimeModifiedRangeFilter>
			';
			*/
		}
		
		/**/
		$active_filter = 'ActiveOnly';
		if($this->option_checked('mw_wc_qbo_desk_cus_imp_inc_inactive_sts')){
			$active_filter = 'All';
		}
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<CustomerQueryRq ' . $attr_iterator . ' ' . $attr_iteratorID . ' requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>
						<!--<FromModifiedDate>' . $last . '</FromModifiedDate>-->
						<!--<ActiveStatus>' . $active_filter . '</ActiveStatus>-->
						'.$dr.'
						<OwnerID>0</OwnerID>
					</CustomerQueryRq>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';
		
		/*
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'Customer Import Request - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			$this->add_test_log($dlog_txt);
		}
		*/
		
		return $xml;

	}
	
	/**/
	public function CustomerMod_Query_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}		
		
		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);
		
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/CustomerQueryRs');
			
			$ListID = (is_array($extra) && isset($extra['ListID']))?$extra['ListID']:'';
			
			foreach ($List->children() as $Customer){
				$EditSequence = $Customer->getChildDataAt('CustomerRet EditSequence');
				$ListID_L = $Customer->getChildDataAt('CustomerRet ListID');
				
				if($ListID == $ListID_L){
					$Queue = new QuickBooks_WebConnector_Queue($this->get_dsn());
					$Queue->enqueue(QUICKBOOKS_MOD_CUSTOMER, $ID,3,array('ListID'=>$ListID, 'EditSequence'=>$EditSequence),$this->get_qbun());
				}
				
				break;
			}			
		}
	}
	
	/**/
	public function Customer_Import_ByName_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$is_guest = false;
		if(is_array($extra) && !empty($extra)){
			if(isset($extra['is_guest']) && $extra['is_guest'] == 1){
				$is_guest = true;
			}
		}
		
		//$this->add_test_log($xml);
		
		global $wpdb;
		
		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);
		
		$tot_imported = 0;
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/CustomerQueryRs');
			
			$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_customers';
			
			foreach ($List->children() as $Customer){				
				$ListID = $Customer->getChildDataAt('CustomerRet ListID');
				if(!$this->get_field_by_val($table,'id','qbd_customerid',$ListID)){
					
					$arr = array(
					'ListID' => $ListID,
					'TimeCreated' => $Customer->getChildDataAt('CustomerRet TimeCreated'),
					'TimeModified' => $Customer->getChildDataAt('CustomerRet TimeModified'),
					'Email' => $Customer->getChildDataAt('CustomerRet Email'),
					'Name' => $Customer->getChildDataAt('CustomerRet Name'),
					'FullName' => $Customer->getChildDataAt('CustomerRet FullName'),
					'FirstName' => $Customer->getChildDataAt('CustomerRet FirstName'),
					'MiddleName' => $Customer->getChildDataAt('CustomerRet MiddleName'),
					'LastName' => $Customer->getChildDataAt('CustomerRet LastName'),
					'Contact' => $Customer->getChildDataAt('CustomerRet Contact'),
					'CompanyName' => $Customer->getChildDataAt('CustomerRet CompanyName'),
					
					'IsActive' => $Customer->getChildDataAt('CustomerRet IsActive'),

					'BillAddress_Addr1' => $Customer->getChildDataAt('CustomerRet BillAddress Addr1'),
					'BillAddress_Addr2' => $Customer->getChildDataAt('CustomerRet BillAddress Addr2'),
					'BillAddress_City' => $Customer->getChildDataAt('CustomerRet BillAddress City'),
					'BillAddress_State' => $Customer->getChildDataAt('CustomerRet BillAddress State'),
					'BillAddress_PostalCode' => $Customer->getChildDataAt('CustomerRet BillAddress PostalCode'),
					'BillAddress_Country' => $Customer->getChildDataAt('CustomerRet BillAddress Country'),

					'ShipAddress_Addr1' => $Customer->getChildDataAt('CustomerRet ShipAddress Addr1'),
					'ShipAddress_Addr2' => $Customer->getChildDataAt('CustomerRet ShipAddress Addr2'),
					'ShipAddress_City' => $Customer->getChildDataAt('CustomerRet ShipAddress City'),
					'ShipAddress_State' => $Customer->getChildDataAt('CustomerRet ShipAddress State'),
					'ShipAddress_PostalCode' => $Customer->getChildDataAt('CustomerRet ShipAddress PostalCode'),
					'ShipAddress_Country' => $Customer->getChildDataAt('CustomerRet ShipAddress Country'),
					);
					
					//
					$is_status_ok  = true;
					if($arr['IsActive'] != 'true' && !$this->option_checked('mw_wc_qbo_desk_cus_imp_inc_inactive_sts')){
						$is_status_ok  = false;
					}
					
					if($is_status_ok){
						$save_data = array();
						$save_data['qbd_customerid'] = $arr['ListID'];
						$save_data['email'] = $arr['Email'];
						$save_data['first_name'] = $arr['FirstName'];
						$save_data['middle_name'] = $arr['MiddleName'];
						$save_data['last_name'] = $arr['LastName'];
						$save_data['company'] = $arr['CompanyName'];
						$save_data['d_name'] = $arr['Name'];
						//
						$save_data['fullname'] = $arr['FullName'];
						$save_data['info_arr'] = serialize($arr);
						$save_data['info_qbxml_obj'] = '';
						
						$wpdb->insert($table, $save_data);
						$tot_imported++;
					}
					
				}
				
				break;
			}
		}
		
		if($tot_imported>0){
			$log_title = "Recognized Customer By Name Successfully";
			$details = "Total Customer Recognized:{$tot_imported}";
			$status = 1;
			//$this->save_log(array('log_type'=>'Customer','log_title'=>$log_title,'details'=>$details,'status'=>$status),true);
			
			/**/
			$this->remove_add_guest_customer_queue_after_ibn_success($ID,$is_guest);
			
		}else{
			/*
			$log_title = "Recognized Customer By Name Error";
			$errmsg = (!empty($errmsg))?$errmsg:"No Customer Found";
			$details = ($errnum)?"Error Number:{$errnum}\n"."Error:{$errmsg}":"Error:{$errmsg}";
			$status = 0;
			*/
		}
		//$this->save_log(array('log_type'=>'Customer','log_title'=>$log_title,'details'=>$details,'status'=>$status),true);

		return true;
	}
	
	public function Customer_Import_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$is_only_new = false;
		if(is_array($extra) && isset($extra['new']) && $extra['new']){
			$is_only_new = true;
		}
		
		//$this->add_test_log($xml);
		//$this->add_test_log(print_r($idents,true));
		global $wpdb;
		if (!empty($idents['iteratorRemainingCount'])){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			if($is_only_new){
				$Queue->enqueue('New_'.QUICKBOOKS_IMPORT_CUSTOMER, null, QB_PRIORITY_REFRESH_DATA_IMPORT, array( 'iteratorID' => $idents['iteratorID'], 'new'=>$extra['new'], 'timestamp_from'=>$extra['timestamp_from'] ),$this->get_qbun());
			}else{
				$Queue->enqueue(QUICKBOOKS_IMPORT_CUSTOMER, null, QB_PRIORITY_REFRESH_DATA_IMPORT, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
			}			
		}
		
		$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';

		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);

		$tot_imported = 0;
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/CustomerQueryRs');

			$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_customers';

			/*Delete Old Data*/
			if(!$is_only_new && $this->get_session_val('import_customer_iteratorID','',true)!=$iteratorID){
				$wpdb->query("DELETE FROM {$table} WHERE `id` > 0");
				$wpdb->query("TRUNCATE TABLE {$table}");
			}
			
			//
			$this->set_session_val('import_customer_iteratorID',$iteratorID);

			foreach ($List->children() as $Customer){
				
				$arr = array(
				'ListID' => $Customer->getChildDataAt('CustomerRet ListID'),
				'TimeCreated' => $Customer->getChildDataAt('CustomerRet TimeCreated'),
				'TimeModified' => $Customer->getChildDataAt('CustomerRet TimeModified'),
				'Email' => $Customer->getChildDataAt('CustomerRet EMail'),
				'Name' => '',
				'FullName' => $Customer->getChildDataAt('CustomerRet FullName'),
				'FirstName' => $Customer->getChildDataAt('CustomerRet FirstName'),
				'MiddleName' => $Customer->getChildDataAt('CustomerRet MiddleName'),
				'LastName' => $Customer->getChildDataAt('CustomerRet LastName'),
				'CustomerID' => $Customer->getChildDataAt('CustomerRet CustomerID'),
				'CompanyName' => $Customer->getChildDataAt('CustomerRet CompanyName'),
				
				'IsActive' => 1,
				'CustomerDiscType' => $Customer->getChildDataAt('CustomerRet CustomerDiscType'),
				'CustomerType' => $Customer->getChildDataAt('CustomerRet CustomerType'),
				
				'Notes' => $Customer->getChildDataAt('CustomerRet Notes'),
				'Phone' => $Customer->getChildDataAt('CustomerRet Phone'),
				
				'BillAddress_Street' => $Customer->getChildDataAt('CustomerRet BillAddress Street'),
				'BillAddress_Street2' => $Customer->getChildDataAt('CustomerRet BillAddress Street2'),
				'BillAddress_City' => $Customer->getChildDataAt('CustomerRet BillAddress City'),
				'BillAddress_State' => $Customer->getChildDataAt('CustomerRet BillAddress State'),
				'BillAddress_PostalCode' => $Customer->getChildDataAt('CustomerRet BillAddress PostalCode'),
				'BillAddress_Country' => $Customer->getChildDataAt('CustomerRet BillAddress Country'),
				
				'ShipAddress_AddressName' => $Customer->getChildDataAt('CustomerRet ShipAddress AddressName'),
				'ShipAddress_CompanyName' => $Customer->getChildDataAt('CustomerRet ShipAddress CompanyName'),
				'ShipAddress_FullName' => $Customer->getChildDataAt('CustomerRet ShipAddress FullName'),
				
				'ShipAddress_Street' => $Customer->getChildDataAt('CustomerRet ShipAddress Street'),
				'ShipAddress_Street2' => $Customer->getChildDataAt('CustomerRet ShipAddress Street2'),
				'ShipAddress_City' => $Customer->getChildDataAt('CustomerRet ShipAddress City'),
				'ShipAddress_State' => $Customer->getChildDataAt('CustomerRet ShipAddress State'),
				'ShipAddress_PostalCode' => $Customer->getChildDataAt('CustomerRet ShipAddress PostalCode'),
				'ShipAddress_Country' => $Customer->getChildDataAt('CustomerRet ShipAddress Country'),
				);

				//QuickBooks_Utilities::log($this->dsn, 'Recognized customer ' . $arr['FullName'] . ': ' . print_r($arr, true));
				//$this->add_test_log(print_r($arr,true));
				
				$save_data = array();
				$save_data['qbd_customerid'] = $arr['ListID'];
				$save_data['email'] = $arr['Email'];
				$save_data['first_name'] = $arr['FirstName'];
				$save_data['middle_name'] = $arr['MiddleName'];
				$save_data['last_name'] = $arr['LastName'];
				$save_data['company'] = $arr['CompanyName'];
				$save_data['d_name'] = $arr['FullName'];
				//
				$save_data['fullname'] = $arr['FullName'];
				$save_data['info_arr'] = serialize($arr);
				
				$save_data['info_qbxml_obj'] = '';
				//$this->add_test_log(print_r($save_data,true));
				$id = (int) $this->get_field_by_val($table,'id','qbd_customerid',$arr['ListID']);
				if(!$id){
					$wpdb->insert($table, $save_data);
					$tot_imported++;
				}
				
				//$lastid = $wpdb->insert_id;
				//$this->add_test_log($wpdb->last_error);

			}
		}

		if($tot_imported>0){
			$log_title = "Recognized Customer Successfully";
			$details = "Total Customer Recognized:{$tot_imported}";
			$status = 1;
			
			//Clear Invalid Mappings
			if(!$is_only_new && empty($idents['iteratorRemainingCount'])){
				$this->clear_customer_invalid_mappings();
			}			
		}else{
			$log_title = "Recognized Customer Error";
			$errmsg = (!empty($errmsg))?$errmsg:"No Customer Found";
			$details = ($errnum)?"Error Number:{$errnum}\n"."Error:{$errmsg}":"Error:{$errmsg}";
			$status = 0;
		}
		
		if(!$is_only_new || ($is_only_new && $status)){
			$this->save_log(array('log_type'=>'Customer','log_title'=>$log_title,'details'=>$details,'status'=>$status),true);
		}		

		return true;
	}
	
	private function get_ii_ire_f_xml($pull_req=false){
		$ire= '
			<IncludeRetElement>ListID</IncludeRetElement>
			<IncludeRetElement>Desc1</IncludeRetElement>
			<IncludeRetElement>ALU</IncludeRetElement>
			<IncludeRetElement>ItemNumber</IncludeRetElement>
			<IncludeRetElement>DepartmentCode</IncludeRetElement>
			<IncludeRetElement>DepartmentListID</IncludeRetElement>
			<IncludeRetElement>UPC</IncludeRetElement>
			<IncludeRetElement>OnHandStore01</IncludeRetElement>
			<IncludeRetElement>OnHandStore02</IncludeRetElement>
			<IncludeRetElement>OnHandStore03</IncludeRetElement>
			<IncludeRetElement>OnHandStore04</IncludeRetElement>
			<IncludeRetElement>OnHandStore05</IncludeRetElement>
			<IncludeRetElement>OnHandStore06</IncludeRetElement>
			<IncludeRetElement>OnHandStore07</IncludeRetElement>
			<IncludeRetElement>OnHandStore08</IncludeRetElement>
			<IncludeRetElement>OnHandStore09</IncludeRetElement>
			<IncludeRetElement>OnHandStore10</IncludeRetElement>
			<IncludeRetElement>OnHandStore11</IncludeRetElement>
			<IncludeRetElement>OnHandStore12</IncludeRetElement>
			<IncludeRetElement>OnHandStore13</IncludeRetElement>
			<IncludeRetElement>OnHandStore14</IncludeRetElement>
			<IncludeRetElement>OnHandStore15</IncludeRetElement>
			<IncludeRetElement>OnHandStore16</IncludeRetElement>
			<IncludeRetElement>OnHandStore17</IncludeRetElement>
			<IncludeRetElement>OnHandStore18</IncludeRetElement>
			<IncludeRetElement>OnHandStore19</IncludeRetElement>
			<IncludeRetElement>OnHandStore20</IncludeRetElement>
			<IncludeRetElement>QuantityOnHand</IncludeRetElement>
			<IncludeRetElement>QuantityOnCustomerOrder</IncludeRetElement>
			<IncludeRetElement>QuantityOnOrder</IncludeRetElement>
			<IncludeRetElement>QuantityOnPendingOrder</IncludeRetElement>
			<IncludeRetElement>ItemType</IncludeRetElement>
			<IncludeRetElement>Price1</IncludeRetElement>
			<IncludeRetElement>Price2</IncludeRetElement>
			<IncludeRetElement>Price3</IncludeRetElement>
			<IncludeRetElement>Price4</IncludeRetElement>
			<IncludeRetElement>Price5</IncludeRetElement>
			<IncludeRetElement>TaxCode</IncludeRetElement>
			<IncludeRetElement>COGSAccount</IncludeRetElement>
			<IncludeRetElement>Cost</IncludeRetElement>
			<IncludeRetElement>DepartmentCode</IncludeRetElement>
			<IncludeRetElement>DepartmentListID</IncludeRetElement>
			<IncludeRetElement>IsWebItem</IncludeRetElement>
			<IncludeRetElement>MSRP</IncludeRetElement>
			<IncludeRetElement>Attribute</IncludeRetElement>
			<IncludeRetElement>Size</IncludeRetElement>
			<IncludeRetElement>Manufacturer</IncludeRetElement>
			<IncludeRetElement>Weight</IncludeRetElement>
		';
		//DataExtRet
		
		if($pull_req || $this->option_checked('mw_wc_qbo_desk_enable_pp_desc2_qb')){
			$ire.='<IncludeRetElement>Desc2</IncludeRetElement>';
		}
		
		return $ire;
	}
	
	/*Product Import Request/Response*/
	public function Item_Import_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}

		$attr_iteratorID = '';
		$attr_iterator = ' iterator="Start" ';
		if (empty($extra['iteratorID'])){
			$last = $this->_quickbooks_get_last_run($user, $action);
			$this->_quickbooks_set_last_run($user, $action);
			$this->_quickbooks_set_current_run($user, $action, $last);
		}else{
			$attr_iteratorID = ' iteratorID="' . $extra['iteratorID'] . '" ';
			$attr_iterator = ' iterator="Continue" ';

			$last = $this->_quickbooks_get_current_run($user, $action);
		}
		
		$iref_xml = $this->get_ii_ire_f_xml();
		
		$dr = '';
		$p_ois = '';
		
		$dept_filter = '';
		if(is_array($extra) && isset($extra['new']) && $extra['new'] && isset($extra['timestamp_from']) && !empty($extra['timestamp_from'])){			
			$timestamp_from = $extra['timestamp_from'];			
			$dr = '
				<TimeModifiedFilter>
					<MatchNumericCriterion >GreaterThan</MatchNumericCriterion>
					<TimeModified >'.$timestamp_from.'</TimeModified>
				</TimeModifiedFilter>
			';
			
			/*
			$c_dt = $this->now();			
			$timestamp_to = date('Y-m-d', strtotime($c_dt)) . 'T' . date('H:i:s', strtotime($c_dt));
			$dr = '
				<TimeModifiedRangeFilter>
					<FromTimeModified >'.$timestamp_from.'</FromTimeModified>
					<ToTimeModified >'.$timestamp_to.'</ToTimeModified>
				</TimeModifiedRangeFilter>
			';
			*/
		}else{
			if($this->option_checked('mw_wc_qbo_desk_rdprdopt_ois')){
				$p_ois = '
					<QuantityOnHandFilter>
						<MatchNumericCriterion>GreaterThan</MatchNumericCriterion>
						<QuantityOnHand>0</QuantityOnHand>
					</QuantityOnHandFilter>
				';
			}
			
			if(is_array($extra) && isset($extra['D_ListId']) && !empty($extra['D_ListId'])){
				$dept_filter = '<DepartmentListID >'.$extra['D_ListId'].'</DepartmentListID>';
			}
		}
		
		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<ItemInventoryQueryRq ' . $attr_iterator . ' ' . $attr_iteratorID . ' requestID="' . $requestID . '">
						<MaxReturned>' . QB_QUICKBOOKS_MAX_RETURNED . '</MaxReturned>						
						<OwnerID>0</OwnerID>
						'.$dr.'
						'.$p_ois.'
						'.$dept_filter.'
						'.$iref_xml.'
					</ItemInventoryQueryRq>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';

		
		if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
			$dlog_txt = PHP_EOL .'Item Import Request - '.$this->get_cdt(). PHP_EOL;
			$dlog_txt.=$xml;
			//$this->add_test_log($dlog_txt);
		}		
		
		return $xml;
	}
	
	/**/
	public function Product_Pull_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		//$this->add_test_log($xml);
		//return true;
		global $wpdb;
		
		$is_product_update = (is_array($extra) && isset($extra['is_product_update']))?$extra['is_product_update']:0;
		
		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);
		
		$tot_imported = 0;
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/ItemInventoryQueryRs');
			
			$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_items';
			
			foreach ($List->children() as $Item){
				$ret = $Item->name();
				
				$qb_pf = $this->get_option('mw_wc_qbo_desk_pull_prd_price_field');
				if(empty($qb_pf)){$qb_pf = 'Price1';}
				$Price = 0;
				
				$custom_price_field = $this->get_qbd_ext_price_field();
				if(is_array($custom_price_field) && in_array($qb_pf,$custom_price_field)){
					$is_cs_pf_ok = false;
					foreach ($Item->children() as $Item_C){
						if($is_cs_pf_ok){break;}
						
						if($Item_C->name() == 'DataExtRet'){
							$ret_c = $Item_C->name();						
							$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');
							//$Item_C->getChildDataAt($ret_c . ' OwnerID')
							if($DataExtName == $qb_pf){
								$is_cs_pf_ok = true;
								$Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
							}
						}					
					}
					
					if(empty($Price)){
						$qb_pf = 'Price1';
						$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
					}
				}else{
					$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
				}
				
				/**/
				$qb_spf = $this->get_option('mw_wc_qbo_desk_pull_prd_sale_price_field');
				$Sale_Price = 0;
				if(!empty($qb_spf)){
					if(is_array($custom_price_field) && in_array($qb_spf,$custom_price_field)){
						$is_cs_spf_ok = false;
						foreach ($Item->children() as $Item_C){
							if($is_cs_spf_ok){break;}							
							if($Item_C->name() == 'DataExtRet'){
								$ret_c = $Item_C->name();						
								$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');								
								if($DataExtName == $qb_spf){
									$is_cs_spf_ok = true;
									$Sale_Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								}
							}					
						}
					}else{
						$Sale_Price = $Item->getChildDataAt($ret . ' '.$qb_spf);
					}
				}
				
				/**/
				$Woo_Cat_Ids = array();
				if($this->is_plugin_active('custom-product-field-map-2-for-myworks-quickbooks-pos-sync') && $this->option_checked('mw_wc_qbo_desk_compt_cust_pro_fld_m_2_ed')){
					foreach ($Item->children() as $Item_C){
						if($Item_C->name() == 'DataExtRet'){
							$ret_c = $Item_C->name();						
							$DeN = $Item_C->getChildDataAt($ret_c . ' DataExtName');
							if($DeN == 'Sub Category 1' || $DeN == 'Sub Category 2' || $DeN == 'Sub Category 3' || $DeN == 'Sub Category 4'){
								$DeV = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								if(!empty($DeV)){
									$scat_id = (int) $this->get_woocommerce_category_id_by_name($DeV,'sub');
									if($scat_id > 0){
										$Woo_Cat_Ids[] = $scat_id;
									}									
								}
							}
						}
					}
				}
				
				$WP_Status = '';
				if($this->is_plugin_active('custom-product-field-map-3-for-myworks-quickbooks-pos-sync') && $this->option_checked('mw_wc_qbo_desk_compt_cust_pro_fld_m_3_ed')){
					foreach ($Item->children() as $Item_C){
						if($Item_C->name() == 'DataExtRet'){
							$ret_c = $Item_C->name();
							$DeN = $Item_C->getChildDataAt($ret_c . ' DataExtName');
							if($DeN == 'Status Active/Inactive'){
								$DeV = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								if($DeV == 'Active'){
									$WP_Status = 'publish';
								}
								
								if($DeV == 'Inactive'){
									$WP_Status = 'draft';
								}
								
								break;
							}
						}
					}
				}
				
				//
				$QuantityOnHand = $Item->getChildDataAt($ret . ' QuantityOnHand');
				
				/**/
				$q_m_stores = $this->get_option('mw_wc_qbo_desk_invt_pull_qb_stores');
				if(!empty($q_m_stores)){
					$q_m_stores = explode(',',$q_m_stores);
					if(is_array($q_m_stores) && !empty($q_m_stores)){
						$QuantityOnHand = 0;
						foreach($q_m_stores as $qv){
							$qv_k = 'OnHandStore'.$qv;
							if(isset($arr[$qv_k])){
								$QuantityOnHand += (int) $arr[$qv_k];
							}
						}
					}
				}
				
				$QuantityOnOrder = $Item->getChildDataAt($ret . ' QuantityOnOrder');
				$QuantityOnCustomerOrder = $Item->getChildDataAt($ret . ' QuantityOnCustomerOrder');
				$QuantityOnPendingOrder = $Item->getChildDataAt($ret . ' QuantityOnPendingOrder');
				
				/**/
				if(is_array($q_m_stores) && !empty($q_m_stores)){
					$QuantityOnOrder = 0;
					$QuantityOnCustomerOrder = 0;
					$QuantityOnPendingOrder = 0;
					
					foreach ($Item->children() as $Item_C_AQ){
						if($Item_C_AQ->name() == 'AvailableQty'){
							$ret_c_AQ = $Item_C_AQ->name();
							$Aq_StoreNumber = $Item_C_AQ->getChildDataAt($ret_c_AQ . ' StoreNumber');
							$Aq_StoreNumber = ($Aq_StoreNumber < 10)?'0'.$Aq_StoreNumber:$Aq_StoreNumber;
							if(isset($q_m_stores[$Aq_StoreNumber])){
								$QuantityOnOrder += (int) $Item_C_AQ->getChildDataAt($ret_c_AQ . ' QuantityOnOrder');
								$QuantityOnCustomerOrder += (int) $Item_C_AQ->getChildDataAt($ret_c_AQ . ' QuantityOnCustomerOrder');
								$QuantityOnPendingOrder += (int) $Item_C_AQ->getChildDataAt($ret_c_AQ . ' QuantityOnPendingOrder');
							}
						}
					}
				}
				
				$arr = array(
					'ListID' 			=> $Item->getChildDataAt('ItemInventoryRet ListID'),
					'Name'				=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'ALU'				=> $Item->getChildDataAt('ItemInventoryRet ALU'),
					'ItemNumber' 		=> $Item->getChildDataAt('ItemInventoryRet ItemNumber'),
					'DepartmentCode' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					'DepartmentListID' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					'Desc1' 			=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'Desc2' 			=> $Item->getChildDataAt('ItemInventoryRet Desc2'),
					'UPC' 				=> $Item->getChildDataAt('ItemInventoryRet UPC'),
					'OnHandStore01' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore01'),
					'OnHandStore02' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore02'),
					'OnHandStore03' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore03'),
					'OnHandStore04' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore04'),
					'OnHandStore05' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore05'),
					'OnHandStore06' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore06'),
					'OnHandStore07' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore07'),
					'OnHandStore08' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore08'),
					'OnHandStore09' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore09'),
					'OnHandStore10' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore10'),
					'OnHandStore11' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore11'),
					'OnHandStore12' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore12'),
					'OnHandStore13' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore13'),
					'OnHandStore14' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore14'),
					'OnHandStore15' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore15'),
					'OnHandStore16' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore16'),
					'OnHandStore17' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore17'),
					'OnHandStore18' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore18'),
					'OnHandStore19' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore19'),
					'OnHandStore20' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore20'),
					'QuantityOnHand' 	=> $QuantityOnHand,
					
					'QuantityOnOrder' 	=> $QuantityOnOrder,
					'QuantityOnCustomerOrder' 	=> $QuantityOnCustomerOrder,					
					'QuantityOnPendingOrder' 	=> $QuantityOnPendingOrder,
					
					'ItemType'			=> $Item->getChildDataAt('ItemInventoryRet ItemType'),
					'Price1'			=> $Item->getChildDataAt('ItemInventoryRet Price1'),
					'Price2'			=> $Item->getChildDataAt('ItemInventoryRet Price2'),
					'Price3'			=> $Item->getChildDataAt('ItemInventoryRet Price3'),
					'Price4'			=> $Item->getChildDataAt('ItemInventoryRet Price4'),
					'Price5'			=> $Item->getChildDataAt('ItemInventoryRet Price5'),
					
					'WebPrice'			=> $Item->getChildDataAt('ItemInventoryRet WebPrice'),
					'Price' => $Price,
					'Sale_Price' => $Sale_Price,
					'Woo_Cat_Ids' => $Woo_Cat_Ids,
					'WP_Status' => $WP_Status,
					
					'is_product_update' => $is_product_update,
					
					'TaxCode'			=> $Item->getChildDataAt('ItemInventoryRet TaxCode'),
					
					'COGSAccount'			=> $Item->getChildDataAt('ItemInventoryRet COGSAccount'),
					'Cost'			=> $Item->getChildDataAt('ItemInventoryRet Cost'),
					'DepartmentCode'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					'DepartmentListID'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					
					'IsWebItem'			=> $Item->getChildDataAt('ItemInventoryRet IsWebItem'),
					'MSRP'			=> $Item->getChildDataAt('ItemInventoryRet MSRP'),
					
					'Attribute'			=> $Item->getChildDataAt('ItemInventoryRet Attribute'),
					'Size'			=> $Item->getChildDataAt('ItemInventoryRet Size'),
					
					'Weight'			=> $Item->getChildDataAt('ItemInventoryRet Weight'),
					'Manufacturer'			=> $Item->getChildDataAt('ItemInventoryRet Manufacturer'),
					
				);
				
				/**/
				if($this->option_checked('mw_wc_qbo_desk_compt_acf_pp_map_ed')){
					$wcfe_cf_rep_map = get_option('mw_wc_qbo_desk_acf_pp_map_mv');
					if(is_array($wcfe_cf_rep_map) && !empty($wcfe_cf_rep_map)){
						$wcfe_cf_rep_map = array_flip($wcfe_cf_rep_map);
						//$this->_p($wcfe_cf_rep_map);
						foreach ($Item->children() as $Item_C){
							if($Item_C->name() == 'DataExtRet'){
								$ret_c = $Item_C->name();						
								$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');								
								$DataExtName = str_replace(' ','__',$DataExtName);
								if(isset($wcfe_cf_rep_map[$DataExtName]) && !empty($wcfe_cf_rep_map[$DataExtName])){
									$arr[$wcfe_cf_rep_map[$DataExtName]] = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								}								
							}
						}
					}					
				}
				
				//$this->_p($arr);continue;
				
				/**/
				$save_data = array();
				//$save_data['qbd_id'] = $arr['ListID'];				
				
				$save_data['name'] = $arr['Name'];
				$save_data['sku'] = $arr['ItemNumber'];
				
				$save_data['upc'] = $arr['UPC'];
				$save_data['alu'] = $arr['ALU'];
				
				$save_data['product_type'] = $arr['ItemType'];
				$save_data['parent_id'] = '';
				
				$save_data['info_arr'] = serialize($arr);				
				$save_data['info_qbxml_obj'] = '';
				
				$id = (int) $this->get_field_by_val($table,'id','qbd_id',$arr['ListID']);
				
				if(!$id){
					$save_data['qbd_id'] = $arr['ListID'];
					$wpdb->insert($table, $save_data);
				}else{
					if($is_product_update){
						$wpdb->update($table,$save_data,array('id'=>$id),'',array('%d'));
					}
				}
				
				$arr['manual'] = true;
				
				$return = $this->Qbd_pull_product($arr);
			}
		}
		
		/**/
		if(!empty($errmsg)){
			$this->save_log(array('log_type'=>'Product','log_title'=>"Pull Product XML Parse Error #".$ID,'details'=>$errmsg,'status'=>0),false);
		}
		
		return true;
	}
	
	/**/
	public function Recent_Product_Pull_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		//$this->add_test_log($xml);
		//return true;
		
		global $wpdb;
		$is_product_update = (is_array($extra) && isset($extra['is_product_update']))?true:false;
		
		if (!empty($idents['iteratorRemainingCount'])){
			if(!$is_product_update){
				$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
				$Queue->enqueue('RECENT_PRODUCT_PULL', null, QB_PRIORITY_REFRESH_DATA_IMPORT, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
			}else{
				$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
				$Queue->enqueue('RECENT_PRODUCT_PULL_U', null, QB_PRIORITY_REFRESH_DATA_IMPORT, array('is_product_update'=>1, 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
			}			
		}
		
		$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';
		
		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);
		
		$tot_imported = 0;
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/ItemInventoryQueryRs');
			
			$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_items';
			
			foreach ($List->children() as $Item){
				$ret = $Item->name();
				
				$qb_pf = $this->get_option('mw_wc_qbo_desk_pull_prd_price_field');
				if(empty($qb_pf)){$qb_pf = 'Price1';}
				$Price = 0;
				
				$custom_price_field = $this->get_qbd_ext_price_field();
				if(is_array($custom_price_field) && in_array($qb_pf,$custom_price_field)){
					$is_cs_pf_ok = false;
					foreach ($Item->children() as $Item_C){
						if($is_cs_pf_ok){break;}
						
						if($Item_C->name() == 'DataExtRet'){
							$ret_c = $Item_C->name();						
							$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');
							//$Item_C->getChildDataAt($ret_c . ' OwnerID')
							if($DataExtName == $qb_pf){
								$is_cs_pf_ok = true;
								$Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
							}
						}					
					}
					
					if(empty($Price)){
						$qb_pf = 'Price1';
						$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
					}
				}else{
					$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
				}
				
				/**/
				$qb_spf = $this->get_option('mw_wc_qbo_desk_pull_prd_sale_price_field');
				$Sale_Price = 0;
				if(!empty($qb_spf)){
					if(is_array($custom_price_field) && in_array($qb_spf,$custom_price_field)){
						$is_cs_spf_ok = false;
						foreach ($Item->children() as $Item_C){
							if($is_cs_spf_ok){break;}							
							if($Item_C->name() == 'DataExtRet'){
								$ret_c = $Item_C->name();						
								$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');								
								if($DataExtName == $qb_spf){
									$is_cs_spf_ok = true;
									$Sale_Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								}
							}					
						}
					}else{
						$Sale_Price = $Item->getChildDataAt($ret . ' '.$qb_spf);
					}
				}
				
				/**/
				$Woo_Cat_Ids = array();
				if($this->is_plugin_active('custom-product-field-map-2-for-myworks-quickbooks-pos-sync') && $this->option_checked('mw_wc_qbo_desk_compt_cust_pro_fld_m_2_ed')){
					foreach ($Item->children() as $Item_C){
						if($Item_C->name() == 'DataExtRet'){
							$ret_c = $Item_C->name();						
							$DeN = $Item_C->getChildDataAt($ret_c . ' DataExtName');
							if($DeN == 'Sub Category 1' || $DeN == 'Sub Category 2' || $DeN == 'Sub Category 3' || $DeN == 'Sub Category 4'){
								$DeV = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								if(!empty($DeV)){
									$scat_id = (int) $this->get_woocommerce_category_id_by_name($DeV,'sub');
									if($scat_id > 0){
										$Woo_Cat_Ids[] = $scat_id;
									}									
								}
							}
						}
					}
				}
				
				$WP_Status = '';
				if($this->is_plugin_active('custom-product-field-map-3-for-myworks-quickbooks-pos-sync') && $this->option_checked('mw_wc_qbo_desk_compt_cust_pro_fld_m_3_ed')){
					foreach ($Item->children() as $Item_C){
						if($Item_C->name() == 'DataExtRet'){
							$ret_c = $Item_C->name();
							$DeN = $Item_C->getChildDataAt($ret_c . ' DataExtName');
							if($DeN == 'Status Active/Inactive'){
								$DeV = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								if($DeV == 'Active'){
									$WP_Status = 'publish';
								}
								
								if($DeV == 'Inactive'){
									$WP_Status = 'draft';
								}
								
								break;
							}
						}
					}
				}
				
				$arr = array(
					'ListID' 			=> $Item->getChildDataAt('ItemInventoryRet ListID'),
					'Name'				=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'ALU'				=> $Item->getChildDataAt('ItemInventoryRet ALU'),
					'ItemNumber' 		=> $Item->getChildDataAt('ItemInventoryRet ItemNumber'),
					'DepartmentCode' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					'DepartmentListID' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					'Desc1' 			=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'Desc2' 			=> $Item->getChildDataAt('ItemInventoryRet Desc2'),
					'UPC' 				=> $Item->getChildDataAt('ItemInventoryRet UPC'),
					'OnHandStore01' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore01'),
					'OnHandStore02' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore02'),
					'OnHandStore03' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore03'),
					'OnHandStore04' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore04'),
					'OnHandStore05' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore05'),
					'OnHandStore06' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore06'),
					'OnHandStore07' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore07'),
					'OnHandStore08' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore08'),
					'OnHandStore09' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore09'),
					'OnHandStore10' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore10'),
					'OnHandStore11' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore11'),
					'OnHandStore12' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore12'),
					'OnHandStore13' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore13'),
					'OnHandStore14' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore14'),
					'OnHandStore15' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore15'),
					'OnHandStore16' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore16'),
					'OnHandStore17' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore17'),
					'OnHandStore18' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore18'),
					'OnHandStore19' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore19'),
					'OnHandStore20' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore20'),
					'QuantityOnHand' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnHand'),
					
					'QuantityOnCustomerOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnCustomerOrder'),
					'QuantityOnHand' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnHand'),
					'QuantityOnOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnOrder'),
					'QuantityOnPendingOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnPendingOrder'),
					
					'ItemType'			=> $Item->getChildDataAt('ItemInventoryRet ItemType'),
					'Price1'			=> $Item->getChildDataAt('ItemInventoryRet Price1'),
					'Price2'			=> $Item->getChildDataAt('ItemInventoryRet Price2'),
					'Price3'			=> $Item->getChildDataAt('ItemInventoryRet Price3'),
					'Price4'			=> $Item->getChildDataAt('ItemInventoryRet Price4'),
					'Price5'			=> $Item->getChildDataAt('ItemInventoryRet Price5'),
					
					'WebPrice'			=> $Item->getChildDataAt('ItemInventoryRet WebPrice'),
					'Price' => $Price,
					'Sale_Price' => $Sale_Price,
					'Woo_Cat_Ids' => $Woo_Cat_Ids,
					'WP_Status' => $WP_Status,
					
					'TaxCode'			=> $Item->getChildDataAt('ItemInventoryRet TaxCode'),
					
					'COGSAccount'			=> $Item->getChildDataAt('ItemInventoryRet COGSAccount'),
					'Cost'			=> $Item->getChildDataAt('ItemInventoryRet Cost'),
					'DepartmentCode'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					'DepartmentListID'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					
					'IsWebItem'			=> $Item->getChildDataAt('ItemInventoryRet IsWebItem'),
					'MSRP'			=> $Item->getChildDataAt('ItemInventoryRet MSRP'),
					
					'Attribute'			=> $Item->getChildDataAt('ItemInventoryRet Attribute'),
					'Size'			=> $Item->getChildDataAt('ItemInventoryRet Size'),
					
					'Weight'			=> $Item->getChildDataAt('ItemInventoryRet Weight'),
					'Manufacturer'			=> $Item->getChildDataAt('ItemInventoryRet Manufacturer'),
					'is_product_update' => $is_product_update,
					
				);

				//$this->_p($arr);die;
				
				/**/
				if($this->option_checked('mw_wc_qbo_desk_compt_acf_pp_map_ed')){
					$wcfe_cf_rep_map = get_option('mw_wc_qbo_desk_acf_pp_map_mv');
					if(is_array($wcfe_cf_rep_map) && !empty($wcfe_cf_rep_map)){
						$wcfe_cf_rep_map = array_flip($wcfe_cf_rep_map);
						//$this->_p($wcfe_cf_rep_map);
						foreach ($Item->children() as $Item_C){
							if($Item_C->name() == 'DataExtRet'){
								$ret_c = $Item_C->name();						
								$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');								
								$DataExtName = str_replace(' ','__',$DataExtName);
								if(isset($wcfe_cf_rep_map[$DataExtName]) && !empty($wcfe_cf_rep_map[$DataExtName])){
									$arr[$wcfe_cf_rep_map[$DataExtName]] = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								}								
							}
						}
					}					
				}
				
				/**/
				$save_data = array();
				//$save_data['qbd_id'] = $arr['ListID'];				
				
				$save_data['name'] = $arr['Name'];
				$save_data['sku'] = $arr['ItemNumber'];
				
				$save_data['upc'] = $arr['UPC'];
				$save_data['alu'] = $arr['ALU'];
				
				$save_data['product_type'] = $arr['ItemType'];
				$save_data['parent_id'] = '';
				
				$save_data['info_arr'] = serialize($arr);				
				$save_data['info_qbxml_obj'] = '';
				
				$id = (int) $this->get_field_by_val($table,'id','qbd_id',$arr['ListID']);
				
				if(!$id){
					$save_data['qbd_id'] = $arr['ListID'];
					$wpdb->insert($table, $save_data);
				}else{
					if($is_product_update){
						$wpdb->update($table,$save_data,array('id'=>$id),'',array('%d'));
					}
				}				
				
				$return = $this->Qbd_pull_product($arr);
			}
		}
		
		return true;
	}
	
	public function Item_Import_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		$is_only_new = false;
		if(is_array($extra) && isset($extra['new']) && $extra['new']){
			$is_only_new = true;
		}
		
		//$this->add_test_log($xml);
		//return true;
		
		global $wpdb;

		if (!empty($idents['iteratorRemainingCount'])){
			$Queue = QuickBooks_WebConnector_Queue_Singleton::getInstance();
			if($is_only_new){
				$Queue->enqueue('New_'.QUICKBOOKS_IMPORT_ITEM, null, QB_PRIORITY_REFRESH_DATA_IMPORT, array( 'iteratorID' => $idents['iteratorID'], 'new'=>$extra['new'], 'timestamp_from'=>$extra['timestamp_from']),$this->get_qbun());
			}else{
				if(is_array($extra) && isset($extra['D_ListId']) && !empty($extra['D_ListId'])){
					$Queue->enqueue(QUICKBOOKS_IMPORT_ITEM, null, QB_PRIORITY_REFRESH_DATA_IMPORT,array('D_ListId'=>$extra['D_ListId'], 'iteratorID' => $idents['iteratorID']),$this->get_qbun());
				}else{
					$Queue->enqueue(QUICKBOOKS_IMPORT_ITEM, null, QB_PRIORITY_REFRESH_DATA_IMPORT, array( 'iteratorID' => $idents['iteratorID'] ),$this->get_qbun());
				}				
			}			
		}
		
		$iteratorID = (isset($idents['iteratorID']) && !empty($idents['iteratorID']))?$idents['iteratorID']:'';

		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);

		$tot_imported = 0;
		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/ItemInventoryQueryRs');

			$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_items';
			
			/*Delete Old Data*/
			if(!$is_only_new && $this->get_session_val('import_product_iteratorID','',true)!=$iteratorID){
				$wpdb->query("DELETE FROM {$table} WHERE `id` > 0");
				$wpdb->query("TRUNCATE TABLE {$table}");
			}

			//
			$this->set_session_val('import_product_iteratorID',$iteratorID);

			foreach ($List->children() as $Item){
				
				$ret = $Item->name();
				
				$qb_pf = $this->get_option('mw_wc_qbo_desk_pull_prd_price_field');
				if(empty($qb_pf)){$qb_pf = 'Price1';}
				$Price = 0;
				
				$custom_price_field = $this->get_qbd_ext_price_field();
				if(is_array($custom_price_field) && in_array($qb_pf,$custom_price_field)){
					$is_cs_pf_ok = false;
					foreach ($Item->children() as $Item_C){
						if($is_cs_pf_ok){break;}
						
						if($Item_C->name() == 'DataExtRet'){
							$ret_c = $Item_C->name();						
							$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');
							//$Item_C->getChildDataAt($ret_c . ' OwnerID')
							if($DataExtName == $qb_pf){
								$is_cs_pf_ok = true;
								$Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
							}
						}					
					}
					
					if(empty($Price)){
						$qb_pf = 'Price1';
						$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
					}
				}else{
					$Price = $Item->getChildDataAt($ret . ' '.$qb_pf);
				}
				
				/**/
				$qb_spf = $this->get_option('mw_wc_qbo_desk_pull_prd_sale_price_field');
				$Sale_Price = 0;
				if(!empty($qb_spf)){
					if(is_array($custom_price_field) && in_array($qb_spf,$custom_price_field)){
						$is_cs_spf_ok = false;
						foreach ($Item->children() as $Item_C){
							if($is_cs_spf_ok){break;}							
							if($Item_C->name() == 'DataExtRet'){
								$ret_c = $Item_C->name();						
								$DataExtName = $Item_C->getChildDataAt($ret_c . ' DataExtName');								
								if($DataExtName == $qb_spf){
									$is_cs_spf_ok = true;
									$Sale_Price = $Item_C->getChildDataAt($ret_c . ' DataExtValue');
								}
							}					
						}
					}else{
						$Sale_Price = $Item->getChildDataAt($ret . ' '.$qb_spf);
					}
				}
				
				$arr = array(
					'ListID' 			=> $Item->getChildDataAt('ItemInventoryRet ListID'),
					'Name'				=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'ALU'				=> $Item->getChildDataAt('ItemInventoryRet ALU'),
					'ItemNumber' 		=> $Item->getChildDataAt('ItemInventoryRet ItemNumber'),
					'DepartmentCode' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					'DepartmentListID' 	=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					'Desc1' 			=> $Item->getChildDataAt('ItemInventoryRet Desc1'),
					'Desc2' 			=> $Item->getChildDataAt('ItemInventoryRet Desc2'),
					'UPC' 				=> $Item->getChildDataAt('ItemInventoryRet UPC'),
					'OnHandStore01' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore01'),
					'OnHandStore02' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore02'),
					'OnHandStore03' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore03'),
					'OnHandStore04' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore04'),
					'OnHandStore05' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore05'),
					'OnHandStore06' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore06'),
					'OnHandStore07' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore07'),
					'OnHandStore08' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore08'),
					'OnHandStore09' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore09'),
					'OnHandStore10' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore10'),
					'OnHandStore11' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore11'),
					'OnHandStore12' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore12'),
					'OnHandStore13' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore13'),
					'OnHandStore14' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore14'),
					'OnHandStore15' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore15'),
					'OnHandStore16' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore16'),
					'OnHandStore17' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore17'),
					'OnHandStore18' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore18'),
					'OnHandStore19' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore19'),
					'OnHandStore20' 	=> $Item->getChildDataAt('ItemInventoryRet OnHandStore20'),
					'QuantityOnHand' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnHand'),
					
					'QuantityOnCustomerOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnCustomerOrder'),
					'QuantityOnHand' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnHand'),
					'QuantityOnOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnOrder'),
					'QuantityOnPendingOrder' 	=> $Item->getChildDataAt('ItemInventoryRet QuantityOnPendingOrder'),
					
					'ItemType'			=> $Item->getChildDataAt('ItemInventoryRet ItemType'),
					'Price1'			=> $Item->getChildDataAt('ItemInventoryRet Price1'),
					'Price2'			=> $Item->getChildDataAt('ItemInventoryRet Price2'),
					'Price3'			=> $Item->getChildDataAt('ItemInventoryRet Price3'),
					'Price4'			=> $Item->getChildDataAt('ItemInventoryRet Price4'),
					'Price5'			=> $Item->getChildDataAt('ItemInventoryRet Price5'),
					'TaxCode'			=> $Item->getChildDataAt('ItemInventoryRet TaxCode'),
					
					'WebPrice'			=> $Item->getChildDataAt('ItemInventoryRet WebPrice'),
					'Price' => $Price,
					'Sale_Price' => $Sale_Price,
					
					'COGSAccount'			=> $Item->getChildDataAt('ItemInventoryRet COGSAccount'),
					'Cost'			=> $Item->getChildDataAt('ItemInventoryRet Cost'),
					//'DepartmentCode'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentCode'),
					//'DepartmentListID'			=> $Item->getChildDataAt('ItemInventoryRet DepartmentListID'),
					
					'IsWebItem'			=> $Item->getChildDataAt('ItemInventoryRet IsWebItem'),
					'MSRP'			=> $Item->getChildDataAt('ItemInventoryRet MSRP'),
					
					'Attribute'			=> $Item->getChildDataAt('ItemInventoryRet Attribute'),
					'Size'			=> $Item->getChildDataAt('ItemInventoryRet Size'),
					
				);				
				
				//$this->add_test_log(print_r($arr,true));
				
				$save_data = array();
				$save_data['qbd_id'] = $arr['ListID'];				
				
				$save_data['name'] = $arr['Name'];
				$save_data['sku'] = $arr['ItemNumber'];
				
				$save_data['upc'] = $arr['UPC'];
				$save_data['alu'] = $arr['ALU'];
				
				$save_data['product_type'] = $arr['ItemType'];
				$save_data['parent_id'] = '';
				
				$save_data['info_arr'] = serialize($arr);				
				$save_data['info_qbxml_obj'] = '';				
				$id = (int) $this->get_field_by_val($table,'id','qbd_id',$arr['ListID']);
				if(!$id){
					$wpdb->insert($table, $save_data);
					$tot_imported++;
				}
				
				//$lastid = $wpdb->insert_id;
				//$this->add_test_log('Testing...' . PHP_EOL .$wpdb->last_error);

			}
		}else{
			/*
			if($this->option_checked('mw_wc_qbo_desk_add_xml_req_into_log')){
				$dlog_txt = PHP_EOL .'Product Import Debug - '.$this->get_cdt(). PHP_EOL;
				$dlog_txt.=$xml;
				$this->add_test_log($dlog_txt);
			}
			*/
		}
		
		if($tot_imported>0){
			$log_title = "Recognized Product Successfully";
			$details = "Total Product Recognized:{$tot_imported}";
			$status = 1;
			
			//Clear Invalid Mappings
			if (!$is_only_new && empty($idents['iteratorRemainingCount'])){
				$this->clear_product_invalid_mappings();
				$this->clear_variation_invalid_mappings();
			}
			
		}else{
			$log_title = "Recognized Product Error";
			$errmsg = (!empty($errmsg))?$errmsg:"No Product Found";
			$details = ($errnum)?"Error Number:{$errnum}\n"."Error:{$errmsg}":"Error:{$errmsg}";
			$status = 0;
		}
		
		if(!$is_only_new || ($is_only_new && $status)){
			$this->save_log(array('log_type'=>'Product','log_title'=>$log_title,'details'=>$details,'status'=>$status),true);
		}		

		return true;
	}
		
	/*Department Import Request/Response*/
	public function Department_Import_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}

		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<DepartmentQueryRq requestID="' . $requestID . '">
					</DepartmentQueryRq>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';

		//$this->add_test_log($xml);
		return $xml;

	}
	
	public function Department_Import_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}

		//$this->add_test_log($xml);
		//return;
		global $wpdb;

		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);

		$tot_imported = 0;
		if ($Doc = $Parser->parse($errnum, $errmsg)){

			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/DepartmentQueryRs');

			$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_list_department';

			/*Delete Old Data*/
			$wpdb->query("DELETE FROM {$table} WHERE `id` > 0");
			$wpdb->query("TRUNCATE TABLE {$table}");

			foreach ($List->children() as $Department){
				$tot_imported++;
				$type = substr($Department->name(), 0, -8);
				$ret = $Department->name();

				$arr = array(
				'ListID' => $Department->getChildDataAt($ret.' ListID'),
				'Name' => $Department->getChildDataAt($ret.' DepartmentName'),
				'DepartmentCode' => $Department->getChildDataAt($ret.' DepartmentCode'),
				'TaxCode' => $Department->getChildDataAt($ret.' TaxCode'),
				'StoreExchangeStatus' => $Department->getChildDataAt($ret.' StoreExchangeStatus'),
				
				'DefaultMarginPercent' => $Department->getChildDataAt($ret.' DefaultMarginPercent'),
				'DefaultMarkupPercent' => $Department->getChildDataAt($ret.' DefaultMarkupPercent'),				
				);
				
				//$this->add_test_log(print_r($arr,true));
				
				$save_data = array();
				$save_data['qbd_id'] = $arr['ListID'];
				$save_data['name'] = $arr['Name'];
				$save_data['d_code'] = $arr['DepartmentCode'];
				$save_data['is_active'] = 1;			
				
				$save_data['info_arr'] = serialize($arr);
				//$save_data['info_qbxml_obj'] = serialize($Term);
				//$save_data['info_qbxml_obj'] = $xml;
				$save_data['info_qbxml_obj'] = '';
				$wpdb->insert($table, $save_data);
				//$lastid = $wpdb->insert_id;

			}
		}
		
		if($tot_imported>0){
			$log_title = "Recognized Department Successfully";
			$details = "Total Department Recognized:{$tot_imported}";
			$status = 1;
		}else{
			$log_title = "Recognized Department Error";
			$errmsg = (!empty($errmsg))?$errmsg:"No Department Found";
			$details = ($errnum)?"Error Number:{$errnum}\n"."Error:{$errmsg}":"Error:{$errmsg}";

			$status = 0;
		}
		$this->save_log(array('log_type'=>'Department','log_title'=>$log_title,'details'=>$details,'status'=>$status),true);

		return true;
	}	
	
	/*Company Import Request/Response*/
	public function Company_Import_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}

		// Build the request
		$xml = '<?xml version="1.0" encoding="utf-8"?>
			<?qbposxml version="' . $version . '"?>
			<QBPOSXML>
				<QBPOSXMLMsgsRq onError="'.$this->getonError().'">
					<CompanyQueryRq requestID="' . $requestID . '">
					</CompanyQueryRq>
				</QBPOSXMLMsgsRq>
			</QBPOSXML>';

		//$this->add_test_log($xml);
		return $xml;

	}
	
	public function Company_Import_Response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		//$this->add_test_log($xml);


		$errnum = 0;
		$errmsg = '';
		$Parser = new QuickBooks_XML_Parser($xml);

		if ($Doc = $Parser->parse($errnum, $errmsg)){
			$Root = $Doc->getRoot();
			$List = $Root->getChildAt('QBPOSXML/QBPOSXMLMsgsRs/CompanyQueryRs');
			foreach ($List->children() as $Company){
				$ret = $Company->name();
				$arr = array();
				$arr['CompanyName'] = $Company->getChildDataAt($ret.' CompanyName');
				$arr['IsSampleCompany'] = $Company->getChildDataAt($ret.' IsSampleCompany');
				$arr['Email'] = '';
				$arr['Country'] = '';
				
				$arr['CityStateZIP'] = $Company->getChildDataAt($ret.' CityStateZIP');
				$arr['StoreNumber'] = $Company->getChildDataAt($ret.' StoreNumber');
				$arr['StoreCode'] = $Company->getChildDataAt($ret.' StoreCode');
				
				$arr['added_date'] = $this->get_cdt();
				//$this->add_test_log(print_r($arr,true));
				update_option('mw_wc_qbo_desk_qbd_company_info_arr',$arr);
				update_option('mw_wc_qbo_desk_qbd_company_info_qbxml',$xml);
				
				$arr = array();
				$arr['IsUsingIntegratedShipping'] = $Company->getChildDataAt($ret.' IsUsingIntegratedShipping');
				
				update_option('mw_wc_qbo_desk_qbd_preferences_arr',$arr);
				//update_option('mw_wc_qbo_desk_qbd_preferences_qbxml',$xml);
				
				global $wpdb;
				
				/*Payment Methods*/
				$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_list_paymentmethod';
				
				/*Delete Old Data*/				
				$wpdb->query("DELETE FROM {$table} WHERE `id` > 0");
				$wpdb->query("TRUNCATE TABLE {$table}");
				
				$qb_pos_pm_list = array(
					"Cash"=>array(
						'ListID'=>"Cash"
						),
					"Cash"=>array(
						'ListID'=>"Cash"
						), 
					"Check"=>array(
						'ListID'=>"Check"
						),
					"Visa"=>array(
						'ListID'=>"Visa"
						), 
					"Mastercard"=>array(
						'ListID'=>"Mastercard"
						),
					"Discover Card"=>array(
						'ListID'=>"Discover Card"
						),
					"American Express"=>array(
						'ListID'=>"American Express"
						),
					"Diners Club"=>array(
						'ListID'=>"Diners Club"
						),
					"JCB"=>array(
						'ListID'=>"JCB"
						) 
				);
				
				foreach($qb_pos_pm_list as $pm_k => $pm_v){
					$save_data = array();
					$save_data['qbd_id'] = $pm_v['ListID'];
					$save_data['name'] = $pm_v['ListID'];
					$save_data['pm_type'] = '';
					$save_data['is_active'] = 1;
					$save_data['info_arr'] = serialize($qb_pos_pm_list);
					$save_data['info_qbxml_obj'] = '';
					$wpdb->insert($table, $save_data);
				}

				/*Tax Records*/
				$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_list_salestaxcode';
				
				/*Delete Old Data*/				
				$wpdb->query("DELETE FROM {$table} WHERE `id` > 0");
				$wpdb->query("TRUNCATE TABLE {$table}");
				
				$qb_pos_sp_list = array();
				$qb_pos_pl_list = array();
				
				if(count($Company->children())){
					foreach ($Company->children() as $Company_c){
						$ret_c = $Company_c->name();
						if($ret_c == 'TaxRecord'){
							$arr_tr = array();
							$arr_tr['TaxCategoryListID'] = $Company_c->getChildDataAt($ret_c.' TaxCategoryListID');
							$arr_tr['TaxCategory'] = $Company_c->getChildDataAt($ret_c.' TaxCategory');
							$arr_tr['POSTaxCodeListID'] = $Company_c->getChildDataAt($ret_c.' POSTaxCodeListID');
							$arr_tr['POSTaxCode'] = $Company_c->getChildDataAt($ret_c.' POSTaxCode');
							$arr_tr['TaxPercent'] = $Company_c->getChildDataAt($ret_c.' TaxPercent');
							$arr_tr['QBTaxGroup'] = $Company_c->getChildDataAt($ret_c.' QBTaxGroup');
							$arr_tr['QBTaxCode'] = $Company_c->getChildDataAt($ret_c.' QBTaxCode');
							
							$save_data = array();
							$save_data['qbd_id'] = $arr_tr['POSTaxCodeListID'];
							$save_data['name'] = $arr_tr['POSTaxCode'];
							$save_data['stc_desc'] = $arr_tr['TaxCategory'];
							$save_data['is_active'] = 1;
							$save_data['is_taxable'] = 1;
							$save_data['info_arr'] = serialize($arr_tr);
							$save_data['info_qbxml_obj'] = '';
							$wpdb->insert($table, $save_data);
						}
						
						//
						if($ret_c == 'ShippingProvider'){
							$qb_pos_sp_list[] = $Company_c->getChildDataAt('ShippingProvider');
						}
					}
				}
				
				/**/
				$qbd_company_shipping_provider_list_arr = '';
				if(!empty($qb_pos_sp_list)){
					$qbd_company_shipping_provider_list_arr = $qb_pos_sp_list;
				}
				update_option('mw_wc_qbo_desk_qbd_company_shipping_provider_list_arr',$qbd_company_shipping_provider_list_arr);
				
				/**/
				for($pl = 1; $pl <= 6; $pl++){
					$qb_pos_pl_list['PriceLevel'.$pl] = array(
					'Name' => $Company->getChildDataAt($ret.' PriceLevel'.$pl.' Name'),
					'Markdown' => $Company->getChildDataAt($ret.' PriceLevel'.$pl.' Markdown')
					);
				}
				
				$qbd_company_price_level_list_arr = '';
				if(!empty($qb_pos_pl_list)){
					$qbd_company_price_level_list_arr = $qb_pos_pl_list;
				}
				update_option('mw_wc_qbo_desk_qbd_company_price_level_list_arr',$qbd_company_price_level_list_arr);
				
				$this->save_log(array('log_type'=>'Company','log_title'=>'Recognized Company Preferences','details'=>'Company info Recognized Successfully','status'=>1),true);
			}
		}

	}
	
	/*Import Functions End*/

	public function _quickbooks_get_last_run($user, $action){
		$type = null;
		$opts = null;
		return QuickBooks_Utilities::configRead($this->dsn, $user, md5(__FILE__), QB_QUICKBOOKS_CONFIG_LAST . '-' . $action, $type, $opts);
	}

	public function _quickbooks_set_last_run($user, $action, $force = null){
		$value = date('Y-m-d') . 'T' . date('H:i:s');
		if ($force){
			$value = date('Y-m-d', strtotime($force)) . 'T' . date('H:i:s', strtotime($force));
		}
		return QuickBooks_Utilities::configWrite($this->dsn, $user, md5(__FILE__), QB_QUICKBOOKS_CONFIG_LAST . '-' . $action, $value);
	}

	public function _quickbooks_get_current_run($user, $action){
		$type = null;
		$opts = null;
		return QuickBooks_Utilities::configRead($this->dsn, $user, md5(__FILE__), QB_QUICKBOOKS_CONFIG_CURR . '-' . $action, $type, $opts);
	}

	public function _quickbooks_set_current_run($user, $action, $force = null){
		$value = date('Y-m-d') . 'T' . date('H:i:s');

		if ($force){
			$value = date('Y-m-d', strtotime($force)) . 'T' . date('H:i:s', strtotime($force));
		}

		return QuickBooks_Utilities::configWrite($this->dsn, $user, md5(__FILE__), QB_QUICKBOOKS_CONFIG_CURR . '-' . $action, $value);
	}
}